package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOBigDecimal</code>.
 */
public class VOBigDecimal extends org.openxma.dsl.platform.valueobject.ValueObjectBigDecimal {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOBigDecimal(java.math.BigDecimal pBigDecimal) {
    	super(pBigDecimal);
    }

    /**
     * Create a new instance of VOBigDecimal or return null depending on input.
     */
    public static VOBigDecimal newOrNull(java.math.BigDecimal pBigDecimal) {
        if (pBigDecimal != null) {
            return new VOBigDecimal(pBigDecimal);
        }
        return null;
    }

    /**
     * Create a new instance of VOBigDecimal or return null depending on input.
     */
    public static VOBigDecimal newOrNull(String value) {
        if (value != null && value.length() > 0) {
            return new VOBigDecimal(new java.math.BigDecimal(value));
        }
        return null;
    }

}
