package org.openxma.dsl.reference.ui.panels.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.graphics.Point;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of VPanelPage.
 * It implements the widgets and models of the page.
 *
 */
public abstract class VPanelPageGen extends org.openxma.dsl.platform.xma.client.DslDialogPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    Composite VPanelPage_composite_0_0_0_0W;
    Composite VPanelPage_composite_1_0_0_0W;
    Composite namedPanelW;
    Group titlePanelW;
    ScrolledComposite scrolledscrollablePanelW;
    Group scrollablePanelW;
    Composite scrollablePanel_set0W;
    Label scrollablePanel_set0_centered;
    Text bigTextW;
    ISimpleWMClient bigText;
    Composite VPanelPage_composite_5_0_0_0W;
    Composite VPanelPage_composite_5_0_0_0_set0W;
    Label VPanelPage_composite_5_0_0_0_set0_centered;
    Label tx1L;
    Text tx1W;
    ISimpleWMClient tx1;
    Composite VPanelPage_composite_5_0_0_0_set1W;
    Label VPanelPage_composite_5_0_0_0_set1_centered;
    Label tx2L;
    Text tx2W;
    ISimpleWMClient tx2;
    Composite tabulatorPanelW;
    Composite tabulatorPanel_set0W;
    Label tabulatorPanel_set0_centered;
    Label tx3L;
    Text tx3W;
    ISimpleWMClient tx3;
    Composite tabulatorPanel_set1W;
    Label tabulatorPanel_set1_centered;
    Label tx4L;
    Text tx4W;
    ISimpleWMClient tx4;
    Composite tabulatorPanel2W;
    Composite tabulatorPanel2_set0W;
    Label tabulatorPanel2_set0_centered;
    Label tx5L;
    Text tx5W;
    ISimpleWMClient tx5;
    Composite tabulatorPanel2_set1W;
    Label tabulatorPanel2_set1_centered;
    Label tx6L;
    Text tx6W;
    ISimpleWMClient tx6;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the VPanelPageGen.
     * @param parent the parent page
     */
    public VPanelPageGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the VPanelPageGen.
     * @param component the component this page belongs to
     */
    public VPanelPageGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the VPanelPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public VPanelPageGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the VPanelPageGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public VPanelPageGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.panels.client.Panels",getGenPageLocale());
        }
        return genPageMessages;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/ui/panels/VPanelPage.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        bigText = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        bigText.setFmt(formatter);
        tx1 = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx1.setFmt(formatter);
        tx2 = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx2.setFmt(formatter);
        tx3 = new SimpleWMClient((short) 3, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx3.setFmt(formatter);
        tx4 = new SimpleWMClient((short) 4, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx4.setFmt(formatter);
        tx5 = new SimpleWMClient((short) 5, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx5.setFmt(formatter);
        tx6 = new SimpleWMClient((short) 6, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        tx6.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) bigText, (WModel) tx1, (WModel) tx2, (WModel) tx3, (WModel) tx4, (WModel) tx5, (WModel) tx6 };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        bigText = null;
        tx1 = null;
        tx2 = null;
        tx3 = null;
        tx4 = null;
        tx5 = null;
        tx6 = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Panels.VPanelPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Panels getTypedComponent() {
        return (Panels) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = Scaler.getInstance(getComposite());

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("VPanelPage"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite VPanelPageCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        VPanelPageCompW.setLayout(layout);

        VPanelPage_composite_0_0_0_0W = new Composite(VPanelPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        VPanelPage_composite_0_0_0_0W.setLayout(layout);
        VPanelPage_composite_0_0_0_0W.setData("WIDGET_ID","VPanelPage_composite_0_0_0_0W");

        VPanelPage_composite_1_0_0_0W = new Composite(VPanelPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        VPanelPage_composite_1_0_0_0W.setLayout(layout);
        VPanelPage_composite_1_0_0_0W.setData("WIDGET_ID","VPanelPage_composite_1_0_0_0W");

        namedPanelW = new Composite(VPanelPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        namedPanelW.setLayout(layout);
        namedPanelW.setData("WIDGET_ID","namedPanelW");

        titlePanelW = new Group(VPanelPageCompW,SWT.NONE);
        titlePanelW.setText(getGenPageMessages().getString("VPanelPage.titlePanelW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        titlePanelW.setLayout(layout);

        scrolledscrollablePanelW = new ScrolledComposite(VPanelPageCompW,SWT.NONE|SWT.H_SCROLL|SWT.V_SCROLL);
        scrolledscrollablePanelW.setExpandHorizontal(true);
        scrolledscrollablePanelW.setExpandVertical(true);
        scrolledscrollablePanelW.setData("WIDGET_ID","scrolledscrollablePanelW");

        scrollablePanelW = new Group(scrolledscrollablePanelW,SWT.NONE);
        scrollablePanelW.setText(getGenPageMessages().getString("VPanelPage.scrollablePanelW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        scrollablePanelW.setLayout(layout);

        scrollablePanel_set0W = new Composite(scrollablePanelW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        scrollablePanel_set0W.setLayout(layout);
        scrollablePanel_set0W.setData("WIDGET_ID","scrollablePanel_set0W");

        scrollablePanel_set0_centered = new Label(scrollablePanel_set0W,SWT.LEFT);
        scrollablePanel_set0_centered.setVisible(false);
        scrollablePanel_set0_centered.setData("WIDGET_ID","scrollablePanel_set0_centered");

        bigTextW = new Text(scrollablePanel_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        bigTextW.setData("WIDGET_ID","bigTextW");
        bigTextW.addFocusListener(adapter);
        bigTextW.addModifyListener(adapter);
        bigTextW.addVerifyListener(adapter);

        VPanelPage_composite_5_0_0_0W = new Composite(VPanelPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        VPanelPage_composite_5_0_0_0W.setLayout(layout);
        VPanelPage_composite_5_0_0_0W.setData("WIDGET_ID","VPanelPage_composite_5_0_0_0W");

        VPanelPage_composite_5_0_0_0_set0W = new Composite(VPanelPage_composite_5_0_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        VPanelPage_composite_5_0_0_0_set0W.setLayout(layout);
        VPanelPage_composite_5_0_0_0_set0W.setData("WIDGET_ID","VPanelPage_composite_5_0_0_0_set0W");

        VPanelPage_composite_5_0_0_0_set0_centered = new Label(VPanelPage_composite_5_0_0_0_set0W,SWT.LEFT);
        VPanelPage_composite_5_0_0_0_set0_centered.setVisible(false);
        VPanelPage_composite_5_0_0_0_set0_centered.setData("WIDGET_ID","VPanelPage_composite_5_0_0_0_set0_centered");

        tx1L = new Label(VPanelPage_composite_5_0_0_0_set0W,SWT.LEFT|SWT.WRAP);
        tx1L.setText(getGenPageMessages().getString("VPanelPage.tx1L"));
        tx1L.setData("WIDGET_ID","tx1L");

        tx1W = new Text(VPanelPage_composite_5_0_0_0_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        tx1W.setData("WIDGET_ID","tx1W");
        tx1W.addFocusListener(adapter);
        tx1W.addModifyListener(adapter);
        tx1W.addVerifyListener(adapter);

        VPanelPage_composite_5_0_0_0_set1W = new Composite(VPanelPage_composite_5_0_0_0W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        VPanelPage_composite_5_0_0_0_set1W.setLayout(layout);
        VPanelPage_composite_5_0_0_0_set1W.setData("WIDGET_ID","VPanelPage_composite_5_0_0_0_set1W");

        VPanelPage_composite_5_0_0_0_set1_centered = new Label(VPanelPage_composite_5_0_0_0_set1W,SWT.LEFT);
        VPanelPage_composite_5_0_0_0_set1_centered.setVisible(false);
        VPanelPage_composite_5_0_0_0_set1_centered.setData("WIDGET_ID","VPanelPage_composite_5_0_0_0_set1_centered");

        tx2L = new Label(VPanelPage_composite_5_0_0_0_set1W,SWT.LEFT|SWT.WRAP);
        tx2L.setText(getGenPageMessages().getString("VPanelPage.tx2L"));
        tx2L.setData("WIDGET_ID","tx2L");

        tx2W = new Text(VPanelPage_composite_5_0_0_0_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        tx2W.setData("WIDGET_ID","tx2W");
        tx2W.addFocusListener(adapter);
        tx2W.addModifyListener(adapter);
        tx2W.addVerifyListener(adapter);

        tabulatorPanelW = new Composite(VPanelPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        tabulatorPanelW.setLayout(layout);
        tabulatorPanelW.setData("WIDGET_ID","tabulatorPanelW");

        tabulatorPanel_set0W = new Composite(tabulatorPanelW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        tabulatorPanel_set0W.setLayout(layout);
        tabulatorPanel_set0W.setData("WIDGET_ID","tabulatorPanel_set0W");

        tabulatorPanel_set0_centered = new Label(tabulatorPanel_set0W,SWT.LEFT);
        tabulatorPanel_set0_centered.setVisible(false);
        tabulatorPanel_set0_centered.setData("WIDGET_ID","tabulatorPanel_set0_centered");

        tx3L = new Label(tabulatorPanel_set0W,SWT.LEFT|SWT.WRAP);
        tx3L.setText(getGenPageMessages().getString("VPanelPage.tx3L"));
        tx3L.setData("WIDGET_ID","tx3L");

        tx3W = new Text(tabulatorPanel_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        tx3W.setData("WIDGET_ID","tx3W");
        tx3W.addFocusListener(adapter);
        tx3W.addModifyListener(adapter);
        tx3W.addVerifyListener(adapter);

        tabulatorPanel_set1W = new Composite(tabulatorPanelW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        tabulatorPanel_set1W.setLayout(layout);
        tabulatorPanel_set1W.setData("WIDGET_ID","tabulatorPanel_set1W");

        tabulatorPanel_set1_centered = new Label(tabulatorPanel_set1W,SWT.LEFT);
        tabulatorPanel_set1_centered.setVisible(false);
        tabulatorPanel_set1_centered.setData("WIDGET_ID","tabulatorPanel_set1_centered");

        tx4L = new Label(tabulatorPanel_set1W,SWT.LEFT|SWT.WRAP);
        tx4L.setText(getGenPageMessages().getString("VPanelPage.tx4L"));
        tx4L.setData("WIDGET_ID","tx4L");

        tx4W = new Text(tabulatorPanel_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        tx4W.setData("WIDGET_ID","tx4W");
        tx4W.addFocusListener(adapter);
        tx4W.addModifyListener(adapter);
        tx4W.addVerifyListener(adapter);

        tabulatorPanel2W = new Composite(VPanelPageCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        tabulatorPanel2W.setLayout(layout);
        tabulatorPanel2W.setData("WIDGET_ID","tabulatorPanel2W");

        tabulatorPanel2_set0W = new Composite(tabulatorPanel2W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        tabulatorPanel2_set0W.setLayout(layout);
        tabulatorPanel2_set0W.setData("WIDGET_ID","tabulatorPanel2_set0W");

        tabulatorPanel2_set0_centered = new Label(tabulatorPanel2_set0W,SWT.LEFT);
        tabulatorPanel2_set0_centered.setVisible(false);
        tabulatorPanel2_set0_centered.setData("WIDGET_ID","tabulatorPanel2_set0_centered");

        tx5L = new Label(tabulatorPanel2_set0W,SWT.LEFT|SWT.WRAP);
        tx5L.setText(getGenPageMessages().getString("VPanelPage.tx5L"));
        tx5L.setData("WIDGET_ID","tx5L");

        tx5W = new Text(tabulatorPanel2_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        tx5W.setData("WIDGET_ID","tx5W");
        tx5W.addFocusListener(adapter);
        tx5W.addModifyListener(adapter);
        tx5W.addVerifyListener(adapter);

        tabulatorPanel2_set1W = new Composite(tabulatorPanel2W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        tabulatorPanel2_set1W.setLayout(layout);
        tabulatorPanel2_set1W.setData("WIDGET_ID","tabulatorPanel2_set1W");

        tabulatorPanel2_set1_centered = new Label(tabulatorPanel2_set1W,SWT.LEFT);
        tabulatorPanel2_set1_centered.setVisible(false);
        tabulatorPanel2_set1_centered.setData("WIDGET_ID","tabulatorPanel2_set1_centered");

        tx6L = new Label(tabulatorPanel2_set1W,SWT.LEFT|SWT.WRAP);
        tx6L.setText(getGenPageMessages().getString("VPanelPage.tx6L"));
        tx6L.setData("WIDGET_ID","tx6L");

        tx6W = new Text(tabulatorPanel2_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        tx6W.setData("WIDGET_ID","tx6W");
        tx6W.addFocusListener(adapter);
        tx6W.addModifyListener(adapter);
        tx6W.addVerifyListener(adapter);

        widgets = new Control[] { VPanelPage_composite_0_0_0_0W, VPanelPage_composite_1_0_0_0W, namedPanelW, titlePanelW, scrolledscrollablePanelW, scrollablePanelW, scrollablePanel_set0W, scrollablePanel_set0_centered, bigTextW, VPanelPage_composite_5_0_0_0W, VPanelPage_composite_5_0_0_0_set0W, VPanelPage_composite_5_0_0_0_set0_centered, tx1L, tx1W, VPanelPage_composite_5_0_0_0_set1W, VPanelPage_composite_5_0_0_0_set1_centered, tx2L, tx2W, tabulatorPanelW, tabulatorPanel_set0W, tabulatorPanel_set0_centered, tx3L, tx3W, tabulatorPanel_set1W, tabulatorPanel_set1_centered, tx4L, tx4W, tabulatorPanel2W, tabulatorPanel2_set0W, tabulatorPanel2_set0_centered, tx5L, tx5W, tabulatorPanel2_set1W, tabulatorPanel2_set1_centered, tx6L, tx6W };

        createWidgetsLayout();
        createWidgetsTabOrder();

        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        VPanelPage_composite_0_0_0_0W.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(40);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(VPanelPage_composite_0_0_0_0W,scaler.convertYToCurrent(3),SWT.BOTTOM);
        VPanelPage_composite_1_0_0_0W.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(40);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(VPanelPage_composite_1_0_0_0W,scaler.convertYToCurrent(3),SWT.BOTTOM);
        namedPanelW.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(40);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(namedPanelW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        titlePanelW.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(40);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(titlePanelW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        scrolledscrollablePanelW.setLayoutData(data);


        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        scrollablePanel_set0W.setLayoutData(data);
        lastControl=scrollablePanel_set0W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        scrollablePanel_set0_centered.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(60);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(scrollablePanel_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        bigTextW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(scrolledscrollablePanelW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        VPanelPage_composite_5_0_0_0W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        VPanelPage_composite_5_0_0_0_set0W.setLayoutData(data);
        lastControl=VPanelPage_composite_5_0_0_0_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        VPanelPage_composite_5_0_0_0_set1W.setLayoutData(data);
        lastControl=VPanelPage_composite_5_0_0_0_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        VPanelPage_composite_5_0_0_0_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(VPanelPage_composite_5_0_0_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx1L.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(tx1L,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(VPanelPage_composite_5_0_0_0_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx1W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        VPanelPage_composite_5_0_0_0_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(VPanelPage_composite_5_0_0_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx2L.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(tx2L,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(VPanelPage_composite_5_0_0_0_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx2W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(VPanelPage_composite_5_0_0_0W,scaler.convertYToCurrent(3),SWT.BOTTOM);
        tabulatorPanelW.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        tabulatorPanel_set0W.setLayoutData(data);
        lastControl=tabulatorPanel_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        tabulatorPanel_set1W.setLayoutData(data);
        lastControl=tabulatorPanel_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        tabulatorPanel_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(100));
        data.top = new FormAttachment(tabulatorPanel_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx3L.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(103));
        data.top = new FormAttachment(tabulatorPanel_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx3W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        tabulatorPanel_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(100));
        data.top = new FormAttachment(tabulatorPanel_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx4L.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(103));
        data.top = new FormAttachment(tabulatorPanel_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx4W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(tabulatorPanelW,scaler.convertYToCurrent(3),SWT.BOTTOM);
        tabulatorPanel2W.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        tabulatorPanel2_set0W.setLayoutData(data);
        lastControl=tabulatorPanel2_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        tabulatorPanel2_set1W.setLayoutData(data);
        lastControl=tabulatorPanel2_set1W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        tabulatorPanel2_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(100));
        data.top = new FormAttachment(tabulatorPanel2_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx5L.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(103));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(250));
        data.top = new FormAttachment(tabulatorPanel2_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx5W.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        tabulatorPanel2_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(100));
        data.top = new FormAttachment(tabulatorPanel2_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx6L.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(103));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(250));
        data.top = new FormAttachment(tabulatorPanel2_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        tx6W.setLayoutData(data);


        scrolledscrollablePanelW.setContent(scrollablePanelW);
        Point size = scrollablePanelW.computeSize(SWT.DEFAULT,SWT.DEFAULT);
        scrolledscrollablePanelW.setMinSize(size);
    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Shell shell = getShell();
        final Composite VPanelPageCompW = getComposite();
        if(getDialog()==this) {
            shell.setTabList(new Control[] { VPanelPageCompW });
        }
        tabOrder = new Control[8];
        tabOrder[0] = VPanelPage_composite_0_0_0_0W;
        tabOrder[1] = VPanelPage_composite_1_0_0_0W;
        tabOrder[2] = namedPanelW;
        tabOrder[3] = titlePanelW;
        tabOrder[4] = scrolledscrollablePanelW;
        tabOrder[5] = VPanelPage_composite_5_0_0_0W;
        tabOrder[6] = tabulatorPanelW;
        tabOrder[7] = tabulatorPanel2W;
        VPanelPageCompW.setTabList(tabOrder);
        tabOrder = new Control[0];
        VPanelPage_composite_0_0_0_0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        VPanelPage_composite_1_0_0_0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        namedPanelW.setTabList(tabOrder);
        tabOrder = new Control[0];
        titlePanelW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = scrollablePanel_set0W;
        scrollablePanelW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = bigTextW;
        scrollablePanel_set0W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = VPanelPage_composite_5_0_0_0_set0W;
        tabOrder[1] = VPanelPage_composite_5_0_0_0_set1W;
        VPanelPage_composite_5_0_0_0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = tx1W;
        VPanelPage_composite_5_0_0_0_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = tx2W;
        VPanelPage_composite_5_0_0_0_set1W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = tabulatorPanel_set0W;
        tabOrder[1] = tabulatorPanel_set1W;
        tabulatorPanelW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = tx3W;
        tabulatorPanel_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = tx4W;
        tabulatorPanel_set1W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = tabulatorPanel2_set0W;
        tabOrder[1] = tabulatorPanel2_set1W;
        tabulatorPanel2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = tx5W;
        tabulatorPanel2_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = tx6W;
        tabulatorPanel2_set1W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        VPanelPage_composite_0_0_0_0W = null;
        VPanelPage_composite_1_0_0_0W = null;
        namedPanelW = null;
        titlePanelW = null;
        scrolledscrollablePanelW = null;
        scrollablePanelW = null;
        scrollablePanel_set0W = null;
        scrollablePanel_set0_centered = null;
        bigTextW = null;
        VPanelPage_composite_5_0_0_0W = null;
        VPanelPage_composite_5_0_0_0_set0W = null;
        VPanelPage_composite_5_0_0_0_set0_centered = null;
        tx1L = null;
        tx1W = null;
        VPanelPage_composite_5_0_0_0_set1W = null;
        VPanelPage_composite_5_0_0_0_set1_centered = null;
        tx2L = null;
        tx2W = null;
        tabulatorPanelW = null;
        tabulatorPanel_set0W = null;
        tabulatorPanel_set0_centered = null;
        tx3L = null;
        tx3W = null;
        tabulatorPanel_set1W = null;
        tabulatorPanel_set1_centered = null;
        tx4L = null;
        tx4W = null;
        tabulatorPanel2W = null;
        tabulatorPanel2_set0W = null;
        tabulatorPanel2_set0_centered = null;
        tx5L = null;
        tx5W = null;
        tabulatorPanel2_set1W = null;
        tabulatorPanel2_set1_centered = null;
        tx6L = null;
        tx6W = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        bigTextW.setData(bigText.getUIDelegate());
        bigText.getUIDelegate().attachUI(bigTextW,null);
        tx1W.setData(tx1.getUIDelegate());
        tx1.getUIDelegate().attachUI(tx1W,null);
        tx2W.setData(tx2.getUIDelegate());
        tx2.getUIDelegate().attachUI(tx2W,null);
        tx3W.setData(tx3.getUIDelegate());
        tx3.getUIDelegate().attachUI(tx3W,null);
        tx4W.setData(tx4.getUIDelegate());
        tx4.getUIDelegate().attachUI(tx4W,null);
        tx5W.setData(tx5.getUIDelegate());
        tx5.getUIDelegate().attachUI(tx5W,null);
        tx6W.setData(tx6.getUIDelegate());
        tx6.getUIDelegate().attachUI(tx6W,null);
    }

    /**
     * This method will be called every time the VPanelPage becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

}
