package org.openxma.dsl.reference.xma.customeredit.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.xma.mdl.table.*;
import at.spardat.enterprise.fmt.*;

/**
 *  Customer search form
 *  
 * This class implements the generic client part of CustomerSearchForm.
 * It implements the widgets and models of the page.
 *
 */
public abstract class CustomerSearchFormGen extends org.openxma.dsl.platform.xma.client.DslDialogPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    Composite customerTableHeaderW;
    Composite customerTableHeader_set0W;
    Label customerTableHeader_set0_centered;
    Label headerText;
    Composite customerTableHeader_set1W;
    Label customerTableHeader_set1_centered;
    Label customer_firstNameL;
    Text customer_firstNameW;
    ISimpleWMClient customer_firstName;
    Composite customerTableHeader_set2W;
    Label customerTableHeader_set2_centered;
    Label customer_lastNameL;
    Text customer_lastNameW;
    ISimpleWMClient customer_lastName;
    Button findButtonW;
    Table customerTableW;
    at.spardat.xma.mdl.table.TableLayoutManager customerTableWLM;
    ITableWMClient customerTable;
    static final int CUSTOMERTABLE_FIRSTNAME = 0;
    static final int CUSTOMERTABLE_LASTNAME = 1;
    static final int CUSTOMERTABLE_BIRTHDATE = 2;
    static final int CUSTOMERTABLE_EMAILADDRESS = 3;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the CustomerSearchFormGen.
     * @param parent the parent page
     */
    public CustomerSearchFormGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the CustomerSearchFormGen.
     * @param component the component this page belongs to
     */
    public CustomerSearchFormGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the CustomerSearchFormGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public CustomerSearchFormGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the CustomerSearchFormGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public CustomerSearchFormGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.customeredit.client.CustomerEdit",getGenPageLocale());
        }
        return genPageMessages;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/xma/customeredit/CustomerSearchForm.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        CompoundValidator compound;
        customer_firstName = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_firstName.setFmt(formatter);
        customer_lastName = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_lastName.setFmt(formatter);
        customerTable = new TableWMClient((short) 2,this,4,TableWMClient.S_NULL|TableWM.S_ONE_WAY);
        formatter = AStringFmt.getInstance(25);
        ((TableWMClient)customerTable).getColumn(CUSTOMERTABLE_FIRSTNAME).setFormatter(formatter);
        formatter = AStringFmt.getInstance(50);
        ((TableWMClient)customerTable).getColumn(CUSTOMERTABLE_LASTNAME).setFormatter(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        ((TableWMClient)customerTable).getColumn(CUSTOMERTABLE_BIRTHDATE).setFormatter(formatter);
        formatter = AStringFmt.getInstance(40);
        ((TableWMClient)customerTable).getColumn(CUSTOMERTABLE_EMAILADDRESS).setFormatter(formatter);

        widgetModels = new WModel[] { (WModel) customer_firstName, (WModel) customer_lastName, (WModel) customerTable };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        customer_firstName = null;
        customer_lastName = null;
        customerTable = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return CustomerEdit.CustomerSearchFormClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public CustomerEdit getTypedComponent() {
        return (CustomerEdit) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = Scaler.getInstance(getComposite());

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("CustomerSearchForm"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite customerSearchFormCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        customerSearchFormCompW.setLayout(layout);

        customerTableHeaderW = new Composite(customerSearchFormCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        customerTableHeaderW.setLayout(layout);
        customerTableHeaderW.setData("WIDGET_ID","customerTableHeaderW");

        customerTableHeader_set0W = new Composite(customerTableHeaderW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        customerTableHeader_set0W.setLayout(layout);
        customerTableHeader_set0W.setData("WIDGET_ID","customerTableHeader_set0W");

        customerTableHeader_set0_centered = new Label(customerTableHeader_set0W,SWT.LEFT);
        customerTableHeader_set0_centered.setVisible(false);
        customerTableHeader_set0_centered.setData("WIDGET_ID","customerTableHeader_set0_centered");

        headerText = new Label(customerTableHeader_set0W,SWT.LEFT);
        headerText.setText(getGenPageMessages().getString("CustomerSearchForm.headerText"));
        headerText.setData("WIDGET_ID","headerText");

        customerTableHeader_set1W = new Composite(customerTableHeaderW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        customerTableHeader_set1W.setLayout(layout);
        customerTableHeader_set1W.setData("WIDGET_ID","customerTableHeader_set1W");

        customerTableHeader_set1_centered = new Label(customerTableHeader_set1W,SWT.LEFT);
        customerTableHeader_set1_centered.setVisible(false);
        customerTableHeader_set1_centered.setData("WIDGET_ID","customerTableHeader_set1_centered");

        customer_firstNameL = new Label(customerTableHeader_set1W,SWT.LEFT|SWT.WRAP);
        customer_firstNameL.setText(getGenPageMessages().getString("CustomerSearchForm.customer_firstNameL"));
        customer_firstNameL.setData("WIDGET_ID","customer_firstNameL");

        customer_firstNameW = new Text(customerTableHeader_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_firstNameW.setToolTipText(getGenPageMessages().getString("CustomerSearchForm.customer_firstNameWTip"));
        customer_firstNameW.setData("WIDGET_ID","customer_firstNameW");
        customer_firstNameW.addFocusListener(adapter);
        customer_firstNameW.addModifyListener(adapter);
        customer_firstNameW.addVerifyListener(adapter);

        customerTableHeader_set2W = new Composite(customerTableHeaderW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        customerTableHeader_set2W.setLayout(layout);
        customerTableHeader_set2W.setData("WIDGET_ID","customerTableHeader_set2W");

        customerTableHeader_set2_centered = new Label(customerTableHeader_set2W,SWT.LEFT);
        customerTableHeader_set2_centered.setVisible(false);
        customerTableHeader_set2_centered.setData("WIDGET_ID","customerTableHeader_set2_centered");

        customer_lastNameL = new Label(customerTableHeader_set2W,SWT.LEFT|SWT.WRAP);
        customer_lastNameL.setText(getGenPageMessages().getString("CustomerSearchForm.customer_lastNameL"));
        customer_lastNameL.setData("WIDGET_ID","customer_lastNameL");

        customer_lastNameW = new Text(customerTableHeader_set2W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_lastNameW.setToolTipText(getGenPageMessages().getString("CustomerSearchForm.customer_lastNameWTip"));
        customer_lastNameW.setData("WIDGET_ID","customer_lastNameW");
        customer_lastNameW.addFocusListener(adapter);
        customer_lastNameW.addModifyListener(adapter);
        customer_lastNameW.addVerifyListener(adapter);

        findButtonW = new Button(customerTableHeader_set2W, SWT.PUSH|SWT.CENTER);
        findButtonW.setText(getGenPageMessages().getString("CustomerSearchForm.findButtonW"));
        findButtonW.setData("WIDGET_ID","findButtonW");
        findButtonW.addSelectionListener(adapter);

        customerTableW = new Table(customerSearchFormCompW,SWT.SINGLE|SWT.BORDER|SWT.FULL_SELECTION
);
        customerTableW.setHeaderVisible(true);
        customerTableW.setLinesVisible(true);
        customerTableW.setData("WIDGET_ID","customerTableW");
        customerTableW.addSelectionListener(adapter);
        TableColumn customerTable_firstName = new TableColumn(customerTableW,SWT.LEFT);
        customerTable_firstName.setText(getGenPageMessages().getString("CustomerSearchForm.customerTable_firstName"));
        customerTable_firstName.addSelectionListener(adapter);
        TableColumn customerTable_lastName = new TableColumn(customerTableW,SWT.LEFT);
        customerTable_lastName.setText(getGenPageMessages().getString("CustomerSearchForm.customerTable_lastName"));
        customerTable_lastName.addSelectionListener(adapter);
        TableColumn customerTable_birthDate = new TableColumn(customerTableW,SWT.LEFT);
        customerTable_birthDate.setText(getGenPageMessages().getString("CustomerSearchForm.customerTable_birthDate"));
        customerTable_birthDate.addSelectionListener(adapter);
        TableColumn customerTable_emailAddress = new TableColumn(customerTableW,SWT.LEFT);
        customerTable_emailAddress.setText(getGenPageMessages().getString("CustomerSearchForm.customerTable_emailAddress"));
        customerTable_emailAddress.addSelectionListener(adapter);
        customerTableW.addMouseListener(adapter);
        Menu customerTableWCM = new Menu(customerTableW.getShell());
        MenuItem customerTableWCMI = new MenuItem(customerTableWCM, SWT.PUSH);
        customerTableWCMI.setText("Copy text");
        customerTableWCMI.addSelectionListener(adapter);
        customerTableW.setMenu(customerTableWCM);
        customerTableWLM = new at.spardat.xma.mdl.table.TableLayoutManager();
        customerTableWLM.manageTable(customerTableW,at.spardat.xma.mdl.table.TableLayoutManager.NONE);
        customerTableWLM.setMinLimit(scaler.convertXToCurrent(10));
        customerTableWLM.setAbsolutWidth(0,scaler.convertXToCurrent(80));
        customerTableWLM.setAbsolutWidth(1,scaler.convertXToCurrent(140));
        customerTableWLM.setAbsolutWidth(2,scaler.convertXToCurrent(140));
        customerTableWLM.setAbsolutWidth(3,scaler.convertXToCurrent(140));

        widgets = new Control[] { customerTableHeaderW, customerTableHeader_set0W, customerTableHeader_set0_centered, headerText, customerTableHeader_set1W, customerTableHeader_set1_centered, customer_firstNameL, customer_firstNameW, customerTableHeader_set2W, customerTableHeader_set2_centered, customer_lastNameL, customer_lastNameW, findButtonW, customerTableW };

        createWidgetsLayout();
        createWidgetsTabOrder();

        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.bottom = new FormAttachment(0,100,scaler.convertYToCurrent(100));
        customerTableHeaderW.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        customerTableHeader_set0W.setLayoutData(data);
        lastControl=customerTableHeader_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        customerTableHeader_set1W.setLayoutData(data);
        lastControl=customerTableHeader_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        customerTableHeader_set2W.setLayoutData(data);
        lastControl=customerTableHeader_set2W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        customerTableHeader_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(customerTableHeader_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        headerText.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        customerTableHeader_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(customerTableHeader_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_firstNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(175);
        data.left = new FormAttachment(customer_firstNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(customerTableHeader_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_firstNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        customerTableHeader_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(customerTableHeader_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(350);
        data.left = new FormAttachment(customer_lastNameL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(customerTableHeader_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_lastNameW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(customer_lastNameW,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(customerTableHeader_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        findButtonW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(customerTableHeaderW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        customerTableW.setLayoutData(data);

    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Shell shell = getShell();
        final Composite customerSearchFormCompW = getComposite();
        if(getDialog()==this) {
            shell.setTabList(new Control[] { customerSearchFormCompW });
        }
        tabOrder = new Control[2];
        tabOrder[0] = customerTableHeaderW;
        tabOrder[1] = customerTableW;
        customerSearchFormCompW.setTabList(tabOrder);
        tabOrder = new Control[3];
        tabOrder[0] = customerTableHeader_set0W;
        tabOrder[1] = customerTableHeader_set1W;
        tabOrder[2] = customerTableHeader_set2W;
        customerTableHeaderW.setTabList(tabOrder);
        tabOrder = new Control[0];
        customerTableHeader_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_firstNameW;
        customerTableHeader_set1W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = customer_lastNameW;
        tabOrder[1] = findButtonW;
        customerTableHeader_set2W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        customerTableHeaderW = null;
        customerTableHeader_set0W = null;
        customerTableHeader_set0_centered = null;
        headerText = null;
        customerTableHeader_set1W = null;
        customerTableHeader_set1_centered = null;
        customer_firstNameL = null;
        customer_firstNameW = null;
        customerTableHeader_set2W = null;
        customerTableHeader_set2_centered = null;
        customer_lastNameL = null;
        customer_lastNameW = null;
        findButtonW = null;
        customerTableW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        TableColumn[] cols;
        customer_firstNameW.setData(customer_firstName.getUIDelegate());
        customer_firstName.getUIDelegate().attachUI(customer_firstNameW,customer_firstNameL);
        customer_lastNameW.setData(customer_lastName.getUIDelegate());
        customer_lastName.getUIDelegate().attachUI(customer_lastNameW,customer_lastNameL);
        customerTableW.setData(customerTable.getUIDelegate());
        customerTable.getUIDelegate().attachUI(customerTableW,null);
        cols = customerTableW.getColumns();
        for(int i = 0; i<cols.length; i++) {
            cols[i].setData(customerTable.getUIDelegate());
        }
        if (customerTableW.getMenu() != null) {
           for(MenuItem item : customerTableW.getMenu().getItems()) {
               item.setData(customerTable.getUIDelegate());
           }
        }

    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        customer_firstName.setMandatory(true);
        customer_lastName.setMandatory(true);
    }

    /**
     * Method called to start the DialogPage.
     */
    public boolean invoke() {
        findCustomer(null);
        return super.invoke();
    }

    /**
     * This method will be called every time the CustomerSearchForm becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
        if (event.widget == findButtonW) {
            findCustomer(event);
        } else if (event.widget == customerTableW  && type == SWT.Selection) {
            selectCustomer(event);
        }
    }



    protected void findCustomer(SelectionEvent event) {
        newRemoteCall("findCustomer").execute();
    }

    protected void selectCustomer(SelectionEvent event) {
        newRemoteCall("selectCustomer").execute();
    }

}
