package org.openxma.dsl.reference.xma.order.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.xma.mdl.table.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of OrderSearchForm.
 * It implements the widgets and models of the page.
 *
 */
public abstract class OrderSearchFormGen extends org.openxma.dsl.platform.xma.client.DslDialogPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    Composite orderTableHeaderW;
    Composite orderTableHeader_set0W;
    Label orderTableHeader_set0_centered;
    Label headerText;
    Composite orderTableHeader_set1W;
    Label orderTableHeader_set1_centered;
    Label orderState_orderNumberL;
    Text orderState_orderNumberW;
    ISimpleWMClient orderState_orderNumber;
    Composite orderTableHeader_set2W;
    Label orderTableHeader_set2_centered;
    Label customerText;
    Text customerW;
    ISimpleWMClient customer;
    Button selectCustomerW;
    Composite orderTableHeader_set3W;
    Label orderTableHeader_set3_centered;
    Button findButtonW;
    Table orderTableW;
    at.spardat.xma.mdl.table.TableLayoutManager orderTableWLM;
    ITableWMClient orderTable;
    static final int ORDERTABLE_ORDERNUMBER = 0;
    static final int ORDERTABLE_STOREID = 1;
    static final int ORDERTABLE_PLACEMENTDATE = 2;
    static final int ORDERTABLE_DELIVERYDATE = 3;
    static final int ORDERTABLE_ORDERSTATE = 4;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the OrderSearchFormGen.
     * @param parent the parent page
     */
    public OrderSearchFormGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the OrderSearchFormGen.
     * @param component the component this page belongs to
     */
    public OrderSearchFormGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the OrderSearchFormGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public OrderSearchFormGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the OrderSearchFormGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public OrderSearchFormGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.order.client.Order",getGenPageLocale());
        }
        return genPageMessages;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/xma/order/OrderSearchForm.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        CompoundValidator compound;
        orderState_orderNumber = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(-1);
        compound.setFormatter(formatter);
        formatter = compound;
        orderState_orderNumber.setFmt(formatter);
        customer = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        customer.setFmt(formatter);
        orderTable = new TableWMClient((short) 2,this,5,TableWMClient.S_NULL|TableWM.S_ONE_WAY);
        formatter = AStringFmt.getInstance(-1);
        ((TableWMClient)orderTable).getColumn(ORDERTABLE_ORDERNUMBER).setFormatter(formatter);
        formatter = AStringFmt.getInstance(-1);
        ((TableWMClient)orderTable).getColumn(ORDERTABLE_STOREID).setFormatter(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        ((TableWMClient)orderTable).getColumn(ORDERTABLE_PLACEMENTDATE).setFormatter(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        ((TableWMClient)orderTable).getColumn(ORDERTABLE_DELIVERYDATE).setFormatter(formatter);
        formatter = AStringFmt.getInstance(33);
        ((TableWMClient)orderTable).getColumn(ORDERTABLE_ORDERSTATE).setFormatter(formatter);

        widgetModels = new WModel[] { (WModel) orderState_orderNumber, (WModel) customer, (WModel) orderTable };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        orderState_orderNumber = null;
        customer = null;
        orderTable = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Order.OrderSearchFormClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Order getTypedComponent() {
        return (Order) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = Scaler.getInstance(getComposite());

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("OrderSearchForm"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite orderSearchFormCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        orderSearchFormCompW.setLayout(layout);

        orderTableHeaderW = new Composite(orderSearchFormCompW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        orderTableHeaderW.setLayout(layout);
        orderTableHeaderW.setData("WIDGET_ID","orderTableHeaderW");

        orderTableHeader_set0W = new Composite(orderTableHeaderW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        orderTableHeader_set0W.setLayout(layout);
        orderTableHeader_set0W.setData("WIDGET_ID","orderTableHeader_set0W");

        orderTableHeader_set0_centered = new Label(orderTableHeader_set0W,SWT.LEFT);
        orderTableHeader_set0_centered.setVisible(false);
        orderTableHeader_set0_centered.setData("WIDGET_ID","orderTableHeader_set0_centered");

        headerText = new Label(orderTableHeader_set0W,SWT.LEFT);
        headerText.setText(getGenPageMessages().getString("OrderSearchForm.headerText"));
        headerText.setData("WIDGET_ID","headerText");

        orderTableHeader_set1W = new Composite(orderTableHeaderW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        orderTableHeader_set1W.setLayout(layout);
        orderTableHeader_set1W.setData("WIDGET_ID","orderTableHeader_set1W");

        orderTableHeader_set1_centered = new Label(orderTableHeader_set1W,SWT.LEFT);
        orderTableHeader_set1_centered.setVisible(false);
        orderTableHeader_set1_centered.setData("WIDGET_ID","orderTableHeader_set1_centered");

        orderState_orderNumberL = new Label(orderTableHeader_set1W,SWT.LEFT|SWT.WRAP);
        orderState_orderNumberL.setText(getGenPageMessages().getString("OrderSearchForm.orderState_orderNumberL"));
        orderState_orderNumberL.setData("WIDGET_ID","orderState_orderNumberL");

        orderState_orderNumberW = new Text(orderTableHeader_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        orderState_orderNumberW.setToolTipText(getGenPageMessages().getString("OrderSearchForm.orderState_orderNumberWTip"));
        orderState_orderNumberW.setData("WIDGET_ID","orderState_orderNumberW");
        orderState_orderNumberW.addFocusListener(adapter);
        orderState_orderNumberW.addModifyListener(adapter);
        orderState_orderNumberW.addVerifyListener(adapter);

        orderTableHeader_set2W = new Composite(orderTableHeaderW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        orderTableHeader_set2W.setLayout(layout);
        orderTableHeader_set2W.setData("WIDGET_ID","orderTableHeader_set2W");

        orderTableHeader_set2_centered = new Label(orderTableHeader_set2W,SWT.LEFT);
        orderTableHeader_set2_centered.setVisible(false);
        orderTableHeader_set2_centered.setData("WIDGET_ID","orderTableHeader_set2_centered");

        customerText = new Label(orderTableHeader_set2W,SWT.LEFT);
        customerText.setText(getGenPageMessages().getString("OrderSearchForm.customerText"));
        customerText.setData("WIDGET_ID","customerText");

        customerW = new Text(orderTableHeader_set2W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customerW.setData("WIDGET_ID","customerW");
        customerW.addFocusListener(adapter);
        customerW.addModifyListener(adapter);
        customerW.addVerifyListener(adapter);

        selectCustomerW = new Button(orderTableHeader_set2W, SWT.PUSH|SWT.CENTER);
        selectCustomerW.setText(getGenPageMessages().getString("OrderSearchForm.selectCustomerW"));
        selectCustomerW.setData("WIDGET_ID","selectCustomerW");
        selectCustomerW.addSelectionListener(adapter);

        orderTableHeader_set3W = new Composite(orderTableHeaderW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        orderTableHeader_set3W.setLayout(layout);
        orderTableHeader_set3W.setData("WIDGET_ID","orderTableHeader_set3W");

        orderTableHeader_set3_centered = new Label(orderTableHeader_set3W,SWT.LEFT);
        orderTableHeader_set3_centered.setVisible(false);
        orderTableHeader_set3_centered.setData("WIDGET_ID","orderTableHeader_set3_centered");

        findButtonW = new Button(orderTableHeader_set3W, SWT.PUSH|SWT.CENTER);
        findButtonW.setText(getGenPageMessages().getString("OrderSearchForm.findButtonW"));
        findButtonW.setData("WIDGET_ID","findButtonW");
        findButtonW.addSelectionListener(adapter);

        orderTableW = new Table(orderSearchFormCompW,SWT.SINGLE|SWT.BORDER|SWT.FULL_SELECTION
);
        orderTableW.setHeaderVisible(true);
        orderTableW.setLinesVisible(true);
        orderTableW.setData("WIDGET_ID","orderTableW");
        orderTableW.addSelectionListener(adapter);
        TableColumn orderTable_orderNumber = new TableColumn(orderTableW,SWT.LEFT);
        orderTable_orderNumber.setText(getGenPageMessages().getString("OrderSearchForm.orderTable_orderNumber"));
        orderTable_orderNumber.addSelectionListener(adapter);
        TableColumn orderTable_storeId = new TableColumn(orderTableW,SWT.LEFT);
        orderTable_storeId.setText(getGenPageMessages().getString("OrderSearchForm.orderTable_storeId"));
        orderTable_storeId.addSelectionListener(adapter);
        TableColumn orderTable_placementDate = new TableColumn(orderTableW,SWT.LEFT);
        orderTable_placementDate.setText(getGenPageMessages().getString("OrderSearchForm.orderTable_placementDate"));
        orderTable_placementDate.addSelectionListener(adapter);
        TableColumn orderTable_deliveryDate = new TableColumn(orderTableW,SWT.LEFT);
        orderTable_deliveryDate.setText(getGenPageMessages().getString("OrderSearchForm.orderTable_deliveryDate"));
        orderTable_deliveryDate.addSelectionListener(adapter);
        TableColumn orderTable_orderState = new TableColumn(orderTableW,SWT.LEFT);
        orderTable_orderState.setText(getGenPageMessages().getString("OrderSearchForm.orderTable_orderState"));
        orderTable_orderState.addSelectionListener(adapter);
        orderTableW.addMouseListener(adapter);
        Menu orderTableWCM = new Menu(orderTableW.getShell());
        MenuItem orderTableWCMI = new MenuItem(orderTableWCM, SWT.PUSH);
        orderTableWCMI.setText("Copy text");
        orderTableWCMI.addSelectionListener(adapter);
        orderTableW.setMenu(orderTableWCM);
        orderTableWLM = new at.spardat.xma.mdl.table.TableLayoutManager();
        orderTableWLM.manageTable(orderTableW,at.spardat.xma.mdl.table.TableLayoutManager.NONE);
        orderTableWLM.setMinLimit(scaler.convertXToCurrent(10));
        orderTableWLM.setAbsolutWidth(0,scaler.convertXToCurrent(80));
        orderTableWLM.setAbsolutWidth(1,scaler.convertXToCurrent(140));
        orderTableWLM.setAbsolutWidth(2,scaler.convertXToCurrent(140));
        orderTableWLM.setAbsolutWidth(3,scaler.convertXToCurrent(140));
        orderTableWLM.setAbsolutWidth(4,scaler.convertXToCurrent(140));

        widgets = new Control[] { orderTableHeaderW, orderTableHeader_set0W, orderTableHeader_set0_centered, headerText, orderTableHeader_set1W, orderTableHeader_set1_centered, orderState_orderNumberL, orderState_orderNumberW, orderTableHeader_set2W, orderTableHeader_set2_centered, customerText, customerW, selectCustomerW, orderTableHeader_set3W, orderTableHeader_set3_centered, findButtonW, orderTableW };

        createWidgetsLayout();
        createWidgetsTabOrder();

        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = Scaler.getInstance(getComposite());
        Control lastControl;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.bottom = new FormAttachment(0,100,scaler.convertYToCurrent(200));
        orderTableHeaderW.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        orderTableHeader_set0W.setLayoutData(data);
        lastControl=orderTableHeader_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        orderTableHeader_set1W.setLayoutData(data);
        lastControl=orderTableHeader_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        orderTableHeader_set2W.setLayoutData(data);
        lastControl=orderTableHeader_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        orderTableHeader_set3W.setLayoutData(data);
        lastControl=orderTableHeader_set3W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        orderTableHeader_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(orderTableHeader_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        headerText.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        orderTableHeader_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(orderTableHeader_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_orderNumberL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(orderState_orderNumberL,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(orderTableHeader_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        orderState_orderNumberW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        orderTableHeader_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(orderTableHeader_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customerText.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(200);
        data.left = new FormAttachment(customerText,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(orderTableHeader_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customerW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(customerW,scaler.convertXToCurrent(3),SWT.RIGHT);
        data.top = new FormAttachment(orderTableHeader_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        selectCustomerW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        orderTableHeader_set3_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(orderTableHeader_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        findButtonW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(orderTableHeaderW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        orderTableW.setLayoutData(data);

    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Shell shell = getShell();
        final Composite orderSearchFormCompW = getComposite();
        if(getDialog()==this) {
            shell.setTabList(new Control[] { orderSearchFormCompW });
        }
        tabOrder = new Control[2];
        tabOrder[0] = orderTableHeaderW;
        tabOrder[1] = orderTableW;
        orderSearchFormCompW.setTabList(tabOrder);
        tabOrder = new Control[4];
        tabOrder[0] = orderTableHeader_set0W;
        tabOrder[1] = orderTableHeader_set1W;
        tabOrder[2] = orderTableHeader_set2W;
        tabOrder[3] = orderTableHeader_set3W;
        orderTableHeaderW.setTabList(tabOrder);
        tabOrder = new Control[0];
        orderTableHeader_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = orderState_orderNumberW;
        orderTableHeader_set1W.setTabList(tabOrder);
        tabOrder = new Control[2];
        tabOrder[0] = customerW;
        tabOrder[1] = selectCustomerW;
        orderTableHeader_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = findButtonW;
        orderTableHeader_set3W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        orderTableHeaderW = null;
        orderTableHeader_set0W = null;
        orderTableHeader_set0_centered = null;
        headerText = null;
        orderTableHeader_set1W = null;
        orderTableHeader_set1_centered = null;
        orderState_orderNumberL = null;
        orderState_orderNumberW = null;
        orderTableHeader_set2W = null;
        orderTableHeader_set2_centered = null;
        customerText = null;
        customerW = null;
        selectCustomerW = null;
        orderTableHeader_set3W = null;
        orderTableHeader_set3_centered = null;
        findButtonW = null;
        orderTableW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        TableColumn[] cols;
        orderState_orderNumberW.setData(orderState_orderNumber.getUIDelegate());
        orderState_orderNumber.getUIDelegate().attachUI(orderState_orderNumberW,orderState_orderNumberL);
        customerW.setData(customer.getUIDelegate());
        customer.getUIDelegate().attachUI(customerW,null);
        orderTableW.setData(orderTable.getUIDelegate());
        orderTable.getUIDelegate().attachUI(orderTableW,null);
        cols = orderTableW.getColumns();
        for(int i = 0; i<cols.length; i++) {
            cols[i].setData(orderTable.getUIDelegate());
        }
        if (orderTableW.getMenu() != null) {
           for(MenuItem item : orderTableW.getMenu().getItems()) {
               item.setData(orderTable.getUIDelegate());
           }
        }

    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {

        orderState_orderNumber.setMandatory(true);
        customer.setEditable(false);
    }

    /**
     * Method called to start the DialogPage.
     */
    public boolean invoke() {
        findOrder(null);
        return super.invoke();
    }

    /**
     * This method will be called every time the OrderSearchForm becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
        if (event.widget == selectCustomerW) {
            selectCustomerWEvent();
        } else if (event.widget == findButtonW) {
            findOrder(event);
        } else if (event.widget == orderTableW  && type == SWT.Selection) {
            selectOrder(event);
        }
    }

    /**
     * This method will be called every time the user clicks on selectCustomerW.
     */
    abstract protected void selectCustomerWEvent();



    protected void findOrder(SelectionEvent event) {
        newRemoteCall("findOrder").execute();
    }

    protected void selectOrder(SelectionEvent event) {
        newRemoteCall("selectOrder").execute();
    }

}
