package org.openxma.dsl.reference.xma.order.server;

import at.spardat.xma.component.ComponentServer;
import at.spardat.xma.session.XMASessionServer;
import org.openxma.dsl.reference.service.OrderService;
import org.openxma.dsl.reference.service.CustomerService;

/**
 * This class implements the generic server part of Order.
 * It provides the mapping between typeIds and classnames
 * of all pages in the component.
 *
 */
abstract public class OrderGen extends org.openxma.dsl.platform.xma.SpringComponentServer {

    org.openxma.dsl.reference.dto.OrderStateView orderState;
    java.util.Collection orders;
    java.util.Collection orderItems;
    org.openxma.dsl.reference.dto.CustomerView customer;
	@org.springframework.beans.factory.annotation.Autowired
	org.openxma.dsl.reference.service.OrderService orderService;
	@org.springframework.beans.factory.annotation.Autowired
	org.openxma.dsl.reference.service.CustomerService customerService;

    /**
     * Initializes the OrderGen. This method is called
     * by the XMA-Runtime.
     *
     * @param session the XMASession, this OrderGen belongs to.
     * @param id the unique id of this Order.
     */
    public OrderGen (XMASessionServer session,short id) {
        super (session,false,id);
    }


    /** the unique typeId for the page OrderSearchForm */
    public static final short OrderSearchFormClass = 0;
    /** the unique typeId for the page OrderEditForm */
    public static final short OrderEditFormClass = 1;
    /** the unique typeId for the page Page1 */
    public static final short Page1Class = 2;
    /** the unique typeId for the page Page2 */
    public static final short Page2Class = 3;

    /**
    * Array of the classnames of all pages in
    * this component. The typeIds are used as indices
    * into this array.
     */
    static final String[] modelClasses = {
        "OrderSearchForm",
        "OrderEditForm",
        "Page1",
        "Page2"
    };

    /**
    * Gets the short classname for the given typeId of
    * a page in this component. The short classname does
    * not contain the package.
    *
    * @param typeId the unique typeId
    * @return the short classname
     */
    static public String getShortModelClass(short typeId) {
        return modelClasses[typeId];
    }

    /**
    * Gets the full classname for the given typeId of
    * a page in this component.
    *
    * @param typeId the unique typeId
    * @return the full classname
     */
    public String getModelClass(short typeId) {
        return "org.openxma.dsl.reference.xma.order.server."+modelClasses[typeId];
    }

    /**
     * returns the orderState
     */
    public org.openxma.dsl.reference.dto.OrderStateView getOrderState() {
        return orderState;
    }

    /**
     * sets the orderState
     */
    public void setOrderState(org.openxma.dsl.reference.dto.OrderStateView orderState) {
        this.orderState = orderState;
    }

    /**
     * returns the orders
     */
    public java.util.Collection getOrders() {
        return orders;
    }

    /**
     * sets the orders
     */
    public void setOrders(java.util.Collection orders) {
        this.orders = orders;
    }

    /**
     * returns the orderItems
     */
    public java.util.Collection getOrderItems() {
        return orderItems;
    }

    /**
     * sets the orderItems
     */
    public void setOrderItems(java.util.Collection orderItems) {
        this.orderItems = orderItems;
    }

    /**
     * returns the customer
     */
    public org.openxma.dsl.reference.dto.CustomerView getCustomer() {
        return customer;
    }

    /**
     * sets the customer
     */
    public void setCustomer(org.openxma.dsl.reference.dto.CustomerView customer) {
        this.customer = customer;
    }


}
