package org.openxma.dsl.reference;

import org.openxma.dsl.platform.service.MapperContextHolder;
import java.util.ArrayList;
import java.util.List;
import org.openxma.dsl.platform.assembler.DtoAssembler;
import org.openxma.dsl.platform.assembler.DtoAssemblerFactory;
import org.openxma.dsl.platform.assembler.DtoAssemblerRegistry;
import org.openxma.dsl.platform.converter.Converter;
import org.openxma.dsl.reference.dto.AddressView;
import org.openxma.dsl.reference.dto.BugView;
import org.openxma.dsl.reference.dto.CategoryView;
import org.openxma.dsl.reference.dto.CertificateView;
import org.openxma.dsl.reference.dto.CustomerAddressDto;
import org.openxma.dsl.reference.dto.CustomerContactReport;
import org.openxma.dsl.reference.dto.CustomerIdDto;
import org.openxma.dsl.reference.dto.CustomerOrderReportDto;
import org.openxma.dsl.reference.dto.CustomerOrderView;
import org.openxma.dsl.reference.dto.CustomerView;
import org.openxma.dsl.reference.dto.OrderItemQuantityView;
import org.openxma.dsl.reference.dto.OrderItemView;
import org.openxma.dsl.reference.dto.OrderStateView;
import org.openxma.dsl.reference.dto.OrderView;
import org.openxma.dsl.reference.dto.PrivateCustomerView;
import org.openxma.dsl.reference.dto.ProductIdView;
import org.openxma.dsl.reference.dto.ProductImageView;
import org.openxma.dsl.reference.dto.ProductView;
import org.openxma.dsl.reference.dto.RoleGroupView;
import org.openxma.dsl.reference.dto.RoleView;
import org.openxma.dsl.reference.dto.SingleOrderView;
import org.openxma.dsl.reference.dto.SingleRoleView;
import org.openxma.dsl.reference.dto.SpCustomerInputParameter;
import org.openxma.dsl.reference.dto.SpOutCustomer;
import org.openxma.dsl.reference.dto.SpReportResultDto;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedCollection;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedStructure;
import org.openxma.dsl.reference.dto.SpResultDtoWithNestedStructures;
import org.openxma.dsl.reference.dto.SpTestView;
import org.openxma.dsl.reference.dto.SupplierNameView;
import org.openxma.dsl.reference.dto.SupplierNameView2;
import org.openxma.dsl.reference.dto.SupplierView;
import org.openxma.dsl.reference.dto.TestEntityView;
import org.openxma.dsl.reference.dto.VODataView;
import org.openxma.dsl.reference.model.Address;
import org.openxma.dsl.reference.model.Bug;
import org.openxma.dsl.reference.model.Category;
import org.openxma.dsl.reference.model.Certificate;
import org.openxma.dsl.reference.model.Customer;
import org.openxma.dsl.reference.model.Order;
import org.openxma.dsl.reference.model.OrderItem;
import org.openxma.dsl.reference.model.PrivateCustomer;
import org.openxma.dsl.reference.model.Product;
import org.openxma.dsl.reference.model.ProductImage;
import org.openxma.dsl.reference.model.Role;
import org.openxma.dsl.reference.model.RoleGroup;
import org.openxma.dsl.reference.model.SingleRole;
import org.openxma.dsl.reference.model.SpTest;
import org.openxma.dsl.reference.model.Supplier;
import org.openxma.dsl.reference.model.TestEntity;
import org.openxma.dsl.reference.model.VOData;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.Assert;

public class DtoAssemblerFactoryReferenceGen implements DtoAssemblerFactory {

	private List<DtoAssembler<?>> dtoAssemblers;

	@Autowired
    private DtoAssemblerRegistry dtoAssemblerRegistry;
    
    @Autowired
    private Converter converter;

    public DtoAssemblerFactoryReferenceGen() {
		dtoAssemblers = new ArrayList<DtoAssembler<?>>(34);
		initDtoAssemblers();
	}


	public List<DtoAssembler<?>> getDtoAssemblers() {
		return dtoAssemblers;
	}

	protected DtoAssemblerRegistry getDtoAssemblerRegistry() {
		return dtoAssemblerRegistry;
	}
	
	protected Converter getConverter() {
		return converter;
	}

	private void initDtoAssemblers() {
		dtoAssemblers.add(createDtoAssemblerAddressView());
		dtoAssemblers.add(createDtoAssemblerBugView());
		dtoAssemblers.add(createDtoAssemblerCategoryView());
		dtoAssemblers.add(createDtoAssemblerCertificateView());
		dtoAssemblers.add(createDtoAssemblerCustomerAddressDto());
		dtoAssemblers.add(createDtoAssemblerCustomerContactReport());
		dtoAssemblers.add(createDtoAssemblerCustomerIdDto());
		dtoAssemblers.add(createDtoAssemblerCustomerOrderReportDto());
		dtoAssemblers.add(createDtoAssemblerCustomerOrderView());
		dtoAssemblers.add(createDtoAssemblerCustomerView());
		dtoAssemblers.add(createDtoAssemblerOrderItemQuantityView());
		dtoAssemblers.add(createDtoAssemblerOrderItemView());
		dtoAssemblers.add(createDtoAssemblerOrderStateView());
		dtoAssemblers.add(createDtoAssemblerOrderView());
		dtoAssemblers.add(createDtoAssemblerPrivateCustomerView());
		dtoAssemblers.add(createDtoAssemblerProductIdView());
		dtoAssemblers.add(createDtoAssemblerProductImageView());
		dtoAssemblers.add(createDtoAssemblerProductView());
		dtoAssemblers.add(createDtoAssemblerRoleGroupView());
		dtoAssemblers.add(createDtoAssemblerRoleView());
		dtoAssemblers.add(createDtoAssemblerSingleOrderView());
		dtoAssemblers.add(createDtoAssemblerSingleRoleView());
		dtoAssemblers.add(createDtoAssemblerSpCustomerInputParameter());
		dtoAssemblers.add(createDtoAssemblerSpOutCustomer());
		dtoAssemblers.add(createDtoAssemblerSpReportResultDto());
		dtoAssemblers.add(createDtoAssemblerSpResultDtoWithNestedCollection());
		dtoAssemblers.add(createDtoAssemblerSpResultDtoWithNestedStructure());
		dtoAssemblers.add(createDtoAssemblerSpResultDtoWithNestedStructures());
		dtoAssemblers.add(createDtoAssemblerSpTestView());
		dtoAssemblers.add(createDtoAssemblerSupplierNameView());
		dtoAssemblers.add(createDtoAssemblerSupplierNameView2());
		dtoAssemblers.add(createDtoAssemblerSupplierView());
		dtoAssemblers.add(createDtoAssemblerTestEntityView());
		dtoAssemblers.add(createDtoAssemblerVODataView());
	}


	private DtoAssembler<AddressView> createDtoAssemblerAddressView() {
		return new DtoAssembler<AddressView>() {
		    public AddressView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		AddressView result = mapFromAddressToAddressView(address);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public AddressView mapFromEntity(Object sourceEntity, AddressView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		mapFromAddressToAddressView(address, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(AddressView sourceDto, Class<T> target) {
				if (AddressView.class.equals(target)) {
					AddressView result = new AddressView();
					mapFromAddressViewToAddressView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Address.class.equals(target)) {
		    		return target.cast(mapFromAddressViewToAddress(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(AddressView sourceDto, Object targetObject) {
		    	if (targetObject instanceof AddressView) {
					mapFromAddressViewToAddressView(sourceDto, (AddressView) targetObject);
				}				
		    	else if (targetObject instanceof Address) {
		    		mapFromAddressViewToAddress(sourceDto, (Address)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromAddressViewToAddressView(AddressView sourceDto, AddressView addressView) {
   		addressView.setOid(sourceDto.getOid());
   		addressView.setVersion(sourceDto.getVersion());
   		addressView.setStreetName(sourceDto.getStreetName());
   		addressView.setStreetNumber(sourceDto.getStreetNumber());
   		addressView.setZip(sourceDto.getZip());
   		addressView.setCity(sourceDto.getCity());
   		addressView.setCountry(sourceDto.getCountry());
    }
    
    protected Address mapFromAddressViewToAddress(AddressView sourceDto) {
    	return mapFromAddressViewToAddress(sourceDto, MapperContextHolder.createEntity(Address.class));
    }

    protected Address mapFromAddressViewToAddress(AddressView sourceDto, Address address) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return address;
    	}
	    MapperContextHolder.getContext().put(sourceDto, address);
		if (sourceDto.getOid() != null) {
			address.setOid(sourceDto.getOid());
		}
		address.setVersion(sourceDto.getVersion());
		address.setStreetName(sourceDto.getStreetName());
		address.setStreetNumber(sourceDto.getStreetNumber());
		address.setZip(sourceDto.getZip());
		address.setCity(sourceDto.getCity());
		address.setCountry(sourceDto.getCountry());
	    return address;
	}
	
	protected AddressView mapFromAddressToAddressView(Address address) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return (AddressView) MapperContextHolder.getContext().get(address);
		}
		AddressView addressView = new AddressView();
    	MapperContextHolder.getContext().put(address, addressView);
		addressView.setOid(address.getOid());
		addressView.setVersion(address.getVersion());
		addressView.setStreetName(address.getStreetName());
		addressView.setStreetNumber(address.getStreetNumber());
		addressView.setZip(address.getZip());
		addressView.setCity(address.getCity());
		addressView.setCountry(address.getCountry());
        return addressView;
	}
	
	protected AddressView mapFromAddressToAddressView(Address address, AddressView addressView) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return addressView;
		}		
    	MapperContextHolder.getContext().put(address, addressView);
		addressView.setOid(address.getOid());
		addressView.setVersion(address.getVersion());
		addressView.setStreetName(address.getStreetName());
		addressView.setStreetNumber(address.getStreetNumber());
		addressView.setZip(address.getZip());
		addressView.setCity(address.getCity());
		addressView.setCountry(address.getCountry());
        return addressView;
	}
	
	

	private DtoAssembler<BugView> createDtoAssemblerBugView() {
		return new DtoAssembler<BugView>() {
		    public BugView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Bug) {
					Bug bug = (Bug) sourceEntity;
		    		BugView result = mapFromBugToBugView(bug);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public BugView mapFromEntity(Object sourceEntity, BugView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Bug) {
					Bug bug = (Bug) sourceEntity;
		    		mapFromBugToBugView(bug, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(BugView sourceDto, Class<T> target) {
				if (BugView.class.equals(target)) {
					BugView result = new BugView();
					mapFromBugViewToBugView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Bug.class.equals(target)) {
		    		return target.cast(mapFromBugViewToBug(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(BugView sourceDto, Object targetObject) {
		    	if (targetObject instanceof BugView) {
					mapFromBugViewToBugView(sourceDto, (BugView) targetObject);
				}				
		    	else if (targetObject instanceof Bug) {
		    		mapFromBugViewToBug(sourceDto, (Bug)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromBugViewToBugView(BugView sourceDto, BugView bugView) {
   		bugView.setOid(sourceDto.getOid());
   		bugView.setBugId(sourceDto.getBugId());
    }
    
    protected Bug mapFromBugViewToBug(BugView sourceDto) {
    	return mapFromBugViewToBug(sourceDto, MapperContextHolder.createEntity(Bug.class));
    }

    protected Bug mapFromBugViewToBug(BugView sourceDto, Bug bug) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return bug;
    	}
	    MapperContextHolder.getContext().put(sourceDto, bug);
		if (sourceDto.getOid() != null) {
			bug.setOid(sourceDto.getOid());
		}
		bug.setBugId(sourceDto.getBugId());
	    return bug;
	}
	
	protected BugView mapFromBugToBugView(Bug bug) {
		if (MapperContextHolder.getContext().containsKey(bug)) {
			return (BugView) MapperContextHolder.getContext().get(bug);
		}
		BugView bugView = new BugView();
    	MapperContextHolder.getContext().put(bug, bugView);
		bugView.setOid(bug.getOid());
		bugView.setBugId(bug.getBugId());
        return bugView;
	}
	
	protected BugView mapFromBugToBugView(Bug bug, BugView bugView) {
		if (MapperContextHolder.getContext().containsKey(bug)) {
			return bugView;
		}		
    	MapperContextHolder.getContext().put(bug, bugView);
		bugView.setOid(bug.getOid());
		bugView.setBugId(bug.getBugId());
        return bugView;
	}
	
	

	private DtoAssembler<CategoryView> createDtoAssemblerCategoryView() {
		return new DtoAssembler<CategoryView>() {
		    public CategoryView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Category) {
					Category category = (Category) sourceEntity;
		    		CategoryView result = mapFromCategoryToCategoryView(category);
		    		if (null != category.getParentCategory()) {
		    			result.setParentCategoryOid(category.getParentCategory().getOid());
		    		}
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public CategoryView mapFromEntity(Object sourceEntity, CategoryView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Category) {
					Category category = (Category) sourceEntity;
		    		mapFromCategoryToCategoryView(category, targetDto);
		    		if (null != category.getParentCategory()) {
		    			targetDto.setParentCategoryOid(category.getParentCategory().getOid());
		    		}
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(CategoryView sourceDto, Class<T> target) {
				if (CategoryView.class.equals(target)) {
					CategoryView result = new CategoryView();
					mapFromCategoryViewToCategoryView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Category.class.equals(target)) {
		    		return target.cast(mapFromCategoryViewToCategory(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(CategoryView sourceDto, Object targetObject) {
		    	if (targetObject instanceof CategoryView) {
					mapFromCategoryViewToCategoryView(sourceDto, (CategoryView) targetObject);
				}				
		    	else if (targetObject instanceof Category) {
		    		mapFromCategoryViewToCategory(sourceDto, (Category)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromCategoryViewToCategoryView(CategoryView sourceDto, CategoryView categoryView) {
   		categoryView.setSubCategories(sourceDto.getSubCategories());
   		categoryView.setProducts(sourceDto.getProducts());
   		categoryView.setOid(sourceDto.getOid());
   		categoryView.setName(sourceDto.getName());
   		categoryView.setDisplayName(sourceDto.getDisplayName());
   		categoryView.setParentCategoryOid(sourceDto.getParentCategoryOid());
    }
    
    protected Category mapFromCategoryViewToCategory(CategoryView sourceDto) {
    	return mapFromCategoryViewToCategory(sourceDto, MapperContextHolder.createEntity(Category.class));
    }

    protected Category mapFromCategoryViewToCategory(CategoryView sourceDto, Category category) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return category;
    	}
	    MapperContextHolder.getContext().put(sourceDto, category);
		if (sourceDto.getOid() != null) {
			category.setOid(sourceDto.getOid());
		}
		category.setName(sourceDto.getName());
		category.setDisplayName(sourceDto.getDisplayName());
		if (sourceDto.getParentCategoryOid() != null  && MapperContextHolder.isContext("parentCategory")) {
			category.setOid(sourceDto.getParentCategoryOid());
		}
	    if (!MapperContextHolder.isContext("saveCategory") && !MapperContextHolder.isContext("updateCategory")) {
			if (null != sourceDto.getSubCategories()) {
				for (CategoryView categoryView : sourceDto.getSubCategories()) {
					Category subCategories = (Category) dtoAssemblerRegistry.getDtoAssembler(CategoryView.class).mapTo(categoryView, Category.class);
					category.addSubCategories(subCategories);
				}
			}
			if (null != sourceDto.getProducts()) {
				for (ProductView productView : sourceDto.getProducts()) {
					Product products = (Product) dtoAssemblerRegistry.getDtoAssembler(ProductView.class).mapTo(productView, Product.class);
					category.addProducts(products);
				}
			}
	    }
	    return category;
	}
	
	protected CategoryView mapFromCategoryToCategoryView(Category category) {
		if (MapperContextHolder.getContext().containsKey(category)) {
			return (CategoryView) MapperContextHolder.getContext().get(category);
		}
		CategoryView categoryView = new CategoryView();
    	MapperContextHolder.getContext().put(category, categoryView);
		categoryView.setOid(category.getOid());
		categoryView.setName(category.getName());
		categoryView.setDisplayName(category.getDisplayName());
		categoryView.setParentCategoryOid(category.getOid());
		if (category.hasSubCategories()) {
			for (Category next : category.getSubCategories()) {
	    		CategoryView nextCategoryView = (CategoryView) MapperContextHolder.getContext().get(next);
	    		if (null == nextCategoryView) {
		        	nextCategoryView = dtoAssemblerRegistry.getDtoAssembler(CategoryView.class).mapFromEntity(next);
		        }
	        	categoryView.addSubCategories(nextCategoryView);
	    	}
		}
		if (category.hasProducts()) {
			for (Product next : category.getProducts()) {
	    		ProductView nextProductView = (ProductView) MapperContextHolder.getContext().get(next);
	    		if (null == nextProductView) {
		        	nextProductView = dtoAssemblerRegistry.getDtoAssembler(ProductView.class).mapFromEntity(next);
		        }
	        	categoryView.addProducts(nextProductView);
	    	}
		}
        return categoryView;
	}
	
	protected CategoryView mapFromCategoryToCategoryView(Category category, CategoryView categoryView) {
		if (MapperContextHolder.getContext().containsKey(category)) {
			return categoryView;
		}		
    	MapperContextHolder.getContext().put(category, categoryView);
		categoryView.setOid(category.getOid());
		categoryView.setName(category.getName());
		categoryView.setDisplayName(category.getDisplayName());
		categoryView.setParentCategoryOid(category.getOid());
		if (category.hasSubCategories()) {
			for (Category next : category.getSubCategories()) {
	    		CategoryView nextCategoryView = (CategoryView) MapperContextHolder.getContext().get(next);
	    		if (null == nextCategoryView) {
		        	nextCategoryView = dtoAssemblerRegistry.getDtoAssembler(CategoryView.class).mapFromEntity(next);
		        }
	        	categoryView.addSubCategories(nextCategoryView);
	    	}
		}
		if (category.hasProducts()) {
			for (Product next : category.getProducts()) {
	    		ProductView nextProductView = (ProductView) MapperContextHolder.getContext().get(next);
	    		if (null == nextProductView) {
		        	nextProductView = dtoAssemblerRegistry.getDtoAssembler(ProductView.class).mapFromEntity(next);
		        }
	        	categoryView.addProducts(nextProductView);
	    	}
		}
        return categoryView;
	}
	
	

	private DtoAssembler<CertificateView> createDtoAssemblerCertificateView() {
		return new DtoAssembler<CertificateView>() {
		    public CertificateView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Certificate) {
					Certificate certificate = (Certificate) sourceEntity;
		    		CertificateView result = mapFromCertificateToCertificateView(certificate);
		    		if (null != certificate.getProduct()) {
		    			result.setProductOid(certificate.getProduct().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		CertificateView result = mapFromProductToCertificateView(product);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public CertificateView mapFromEntity(Object sourceEntity, CertificateView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Certificate) {
					Certificate certificate = (Certificate) sourceEntity;
		    		mapFromCertificateToCertificateView(certificate, targetDto);
		    		if (null != certificate.getProduct()) {
		    			targetDto.setProductOid(certificate.getProduct().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		mapFromProductToCertificateView(product, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(CertificateView sourceDto, Class<T> target) {
				if (CertificateView.class.equals(target)) {
					CertificateView result = new CertificateView();
					mapFromCertificateViewToCertificateView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Certificate.class.equals(target)) {
		    		return target.cast(mapFromCertificateViewToCertificate(sourceDto));
		    	}
				else if (Product.class.equals(target)) {
		    		return target.cast(mapFromCertificateViewToProduct(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(CertificateView sourceDto, Object targetObject) {
		    	if (targetObject instanceof CertificateView) {
					mapFromCertificateViewToCertificateView(sourceDto, (CertificateView) targetObject);
				}				
		    	else if (targetObject instanceof Certificate) {
		    		mapFromCertificateViewToCertificate(sourceDto, (Certificate)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Product) {
		    		mapFromCertificateViewToProduct(sourceDto, (Product)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromCertificateViewToCertificateView(CertificateView sourceDto, CertificateView certificateView) {
   		certificateView.setOid(sourceDto.getOid());
   		certificateView.setVersion(sourceDto.getVersion());
   		certificateView.setCertificateDescription(sourceDto.getCertificateDescription());
   		certificateView.setProductOid(sourceDto.getProductOid());
    }
    
    protected Certificate mapFromCertificateViewToCertificate(CertificateView sourceDto) {
    	return mapFromCertificateViewToCertificate(sourceDto, MapperContextHolder.createEntity(Certificate.class));
    }

    protected Certificate mapFromCertificateViewToCertificate(CertificateView sourceDto, Certificate certificate) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return certificate;
    	}
	    MapperContextHolder.getContext().put(sourceDto, certificate);
		if (sourceDto.getOid() != null) {
			certificate.setOid(sourceDto.getOid());
		}
		certificate.setVersion(sourceDto.getVersion());
		certificate.setCertificateDescription(sourceDto.getCertificateDescription());
	    return certificate;
	}
			
    protected Product mapFromCertificateViewToProduct(CertificateView sourceDto) {
    	return mapFromCertificateViewToProduct(sourceDto, MapperContextHolder.createEntity(Product.class));
    }

    protected Product mapFromCertificateViewToProduct(CertificateView sourceDto, Product product) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return product;
    	}
	    MapperContextHolder.getContext().put(sourceDto, product);
		if (sourceDto.getProductOid() != null  && MapperContextHolder.isContext("product")) {
			product.setOid(sourceDto.getProductOid());
		}
	    return product;
	}
	
	protected CertificateView mapFromCertificateToCertificateView(Certificate certificate) {
		if (MapperContextHolder.getContext().containsKey(certificate)) {
			return (CertificateView) MapperContextHolder.getContext().get(certificate);
		}
		CertificateView certificateView = new CertificateView();
    	MapperContextHolder.getContext().put(certificate, certificateView);
		certificateView.setOid(certificate.getOid());
		certificateView.setVersion(certificate.getVersion());
		certificateView.setCertificateDescription(certificate.getCertificateDescription());
        return certificateView;
	}
	
	protected CertificateView mapFromCertificateToCertificateView(Certificate certificate, CertificateView certificateView) {
		if (MapperContextHolder.getContext().containsKey(certificate)) {
			return certificateView;
		}		
    	MapperContextHolder.getContext().put(certificate, certificateView);
		certificateView.setOid(certificate.getOid());
		certificateView.setVersion(certificate.getVersion());
		certificateView.setCertificateDescription(certificate.getCertificateDescription());
        return certificateView;
	}
	
	protected CertificateView mapFromProductToCertificateView(Product product) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return (CertificateView) MapperContextHolder.getContext().get(product);
		}
		CertificateView certificateView = new CertificateView();
    	MapperContextHolder.getContext().put(product, certificateView);
		certificateView.setProductOid(product.getOid());
        return certificateView;
	}
	
	protected CertificateView mapFromProductToCertificateView(Product product, CertificateView certificateView) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return certificateView;
		}		
    	MapperContextHolder.getContext().put(product, certificateView);
		certificateView.setProductOid(product.getOid());
        return certificateView;
	}
	
	

	private DtoAssembler<CustomerAddressDto> createDtoAssemblerCustomerAddressDto() {
		return new DtoAssembler<CustomerAddressDto>() {
		    public CustomerAddressDto mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		CustomerAddressDto result = mapFromCustomerToCustomerAddressDto(customer);
		    		return result;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		CustomerAddressDto result = mapFromAddressToCustomerAddressDto(address);
		    		return result;
		    	}else {
					CustomerAddressDto result = new CustomerAddressDto();
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
						.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
								.mapFromEntity(sourceEntity), result);
					return result;
				}
			}
			
			public CustomerAddressDto mapFromEntity(Object sourceEntity, CustomerAddressDto targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToCustomerAddressDto(customer, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		mapFromAddressToCustomerAddressDto(address, targetDto);
		    		return targetDto;
		    	}else {					
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
						.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
								.mapFromEntity(sourceEntity), targetDto);
					return targetDto;
				}
			}
			
			public <T> T mapTo(CustomerAddressDto sourceDto, Class<T> target) {
				if (CustomerAddressDto.class.equals(target)) {
					CustomerAddressDto result = new CustomerAddressDto();
					mapFromCustomerAddressDtoToCustomerAddressDto(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromCustomerAddressDtoToCustomer(sourceDto));
		    	}
				else if (Address.class.equals(target)) {
		    		return target.cast(mapFromCustomerAddressDtoToAddress(sourceDto));
		    	}
		    	else {
					return dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, target);
				}
		    }

		    public void mapTo(CustomerAddressDto sourceDto, Object targetObject) {
		    	if (targetObject instanceof CustomerAddressDto) {
					mapFromCustomerAddressDtoToCustomerAddressDto(sourceDto, (CustomerAddressDto) targetObject);
				}				
		    	else if (targetObject instanceof Customer) {
		    		mapFromCustomerAddressDtoToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Address) {
		    		mapFromCustomerAddressDtoToAddress(sourceDto, (Address)targetObject);
		    	}		    	
		    	else {
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, targetObject);
				}
			}
		};
	}

    protected void mapFromCustomerAddressDtoToCustomerAddressDto(CustomerAddressDto sourceDto, CustomerAddressDto customerAddressDto) {
        dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, customerAddressDto);
   		customerAddressDto.setFirstName(sourceDto.getFirstName());
   		customerAddressDto.setLastName(sourceDto.getLastName());
   		customerAddressDto.setEmailAddress(sourceDto.getEmailAddress());
   		customerAddressDto.setTelefonNumber(sourceDto.getTelefonNumber());
   		customerAddressDto.setCity(sourceDto.getCity());
   		customerAddressDto.setBillingAddressCity(sourceDto.getBillingAddressCity());
    }
    
    protected Customer mapFromCustomerAddressDtoToCustomer(CustomerAddressDto sourceDto) {
    	return mapFromCustomerAddressDtoToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromCustomerAddressDtoToCustomer(CustomerAddressDto sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, customer);
		customer.setFirstName(sourceDto.getFirstName());
		customer.setLastName(sourceDto.getLastName());
		customer.setEmailAddress(sourceDto.getEmailAddress());
		customer.setTelefonNumber(sourceDto.getTelefonNumber());
	    return customer;
	}
			
    protected Address mapFromCustomerAddressDtoToAddress(CustomerAddressDto sourceDto) {
    	return mapFromCustomerAddressDtoToAddress(sourceDto, MapperContextHolder.createEntity(Address.class));
    }

    protected Address mapFromCustomerAddressDtoToAddress(CustomerAddressDto sourceDto, Address address) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return address;
    	}
	    MapperContextHolder.getContext().put(sourceDto, address);
		address.setCity(sourceDto.getCity());
		address.setCity(sourceDto.getBillingAddressCity());
	    return address;
	}
	
	protected CustomerAddressDto mapFromCustomerToCustomerAddressDto(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (CustomerAddressDto) MapperContextHolder.getContext().get(customer);
		}
		CustomerAddressDto customerAddressDto = new CustomerAddressDto();
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    	.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    			.mapFromEntity(customer), customerAddressDto);
    	MapperContextHolder.getContext().put(customer, customerAddressDto);
		customerAddressDto.setFirstName(customer.getFirstName());
		customerAddressDto.setLastName(customer.getLastName());
		customerAddressDto.setEmailAddress(customer.getEmailAddress());
		customerAddressDto.setTelefonNumber(customer.getTelefonNumber());
        return customerAddressDto;
	}
	
	protected CustomerAddressDto mapFromCustomerToCustomerAddressDto(Customer customer, CustomerAddressDto customerAddressDto) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return customerAddressDto;
		}		
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    	.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    			.mapFromEntity(customer), customerAddressDto);
    	MapperContextHolder.getContext().put(customer, customerAddressDto);
		customerAddressDto.setFirstName(customer.getFirstName());
		customerAddressDto.setLastName(customer.getLastName());
		customerAddressDto.setEmailAddress(customer.getEmailAddress());
		customerAddressDto.setTelefonNumber(customer.getTelefonNumber());
        return customerAddressDto;
	}
	
	protected CustomerAddressDto mapFromAddressToCustomerAddressDto(Address address) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return (CustomerAddressDto) MapperContextHolder.getContext().get(address);
		}
		CustomerAddressDto customerAddressDto = new CustomerAddressDto();
    	MapperContextHolder.getContext().put(address, customerAddressDto);
		customerAddressDto.setCity(address.getCity());
		customerAddressDto.setBillingAddressCity(address.getCity());
        return customerAddressDto;
	}
	
	protected CustomerAddressDto mapFromAddressToCustomerAddressDto(Address address, CustomerAddressDto customerAddressDto) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return customerAddressDto;
		}		
    	MapperContextHolder.getContext().put(address, customerAddressDto);
		customerAddressDto.setCity(address.getCity());
		customerAddressDto.setBillingAddressCity(address.getCity());
        return customerAddressDto;
	}
	
	

	private DtoAssembler<CustomerContactReport> createDtoAssemblerCustomerContactReport() {
		return new DtoAssembler<CustomerContactReport>() {
		    public CustomerContactReport mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		CustomerContactReport result = mapFromCustomerToCustomerContactReport(customer);
		    		return result;
		    	}else {
					CustomerContactReport result = new CustomerContactReport();
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
						.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
								.mapFromEntity(sourceEntity), result);
					return result;
				}
			}
			
			public CustomerContactReport mapFromEntity(Object sourceEntity, CustomerContactReport targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToCustomerContactReport(customer, targetDto);
		    		return targetDto;
		    	}else {					
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
						.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
								.mapFromEntity(sourceEntity), targetDto);
					return targetDto;
				}
			}
			
			public <T> T mapTo(CustomerContactReport sourceDto, Class<T> target) {
				if (CustomerContactReport.class.equals(target)) {
					CustomerContactReport result = new CustomerContactReport();
					mapFromCustomerContactReportToCustomerContactReport(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromCustomerContactReportToCustomer(sourceDto));
		    	}
		    	else {
					return dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, target);
				}
		    }

		    public void mapTo(CustomerContactReport sourceDto, Object targetObject) {
		    	if (targetObject instanceof CustomerContactReport) {
					mapFromCustomerContactReportToCustomerContactReport(sourceDto, (CustomerContactReport) targetObject);
				}				
		    	else if (targetObject instanceof Customer) {
		    		mapFromCustomerContactReportToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else {
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, targetObject);
				}
			}
		};
	}

    protected void mapFromCustomerContactReportToCustomerContactReport(CustomerContactReport sourceDto, CustomerContactReport customerContactReport) {
        dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, customerContactReport);
   		customerContactReport.setFirstName(sourceDto.getFirstName());
   		customerContactReport.setLastName(sourceDto.getLastName());
   		customerContactReport.setEmailAddress(sourceDto.getEmailAddress());
   		customerContactReport.setTelefonNumber(sourceDto.getTelefonNumber());
    }
    
    protected Customer mapFromCustomerContactReportToCustomer(CustomerContactReport sourceDto) {
    	return mapFromCustomerContactReportToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromCustomerContactReportToCustomer(CustomerContactReport sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, customer);
		customer.setFirstName(sourceDto.getFirstName());
		customer.setLastName(sourceDto.getLastName());
		customer.setEmailAddress(sourceDto.getEmailAddress());
		customer.setTelefonNumber(sourceDto.getTelefonNumber());
	    return customer;
	}
	
	protected CustomerContactReport mapFromCustomerToCustomerContactReport(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (CustomerContactReport) MapperContextHolder.getContext().get(customer);
		}
		CustomerContactReport customerContactReport = new CustomerContactReport();
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    	.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    			.mapFromEntity(customer), customerContactReport);
    	MapperContextHolder.getContext().put(customer, customerContactReport);
		customerContactReport.setFirstName(customer.getFirstName());
		customerContactReport.setLastName(customer.getLastName());
		customerContactReport.setEmailAddress(customer.getEmailAddress());
		customerContactReport.setTelefonNumber(customer.getTelefonNumber());
        return customerContactReport;
	}
	
	protected CustomerContactReport mapFromCustomerToCustomerContactReport(Customer customer, CustomerContactReport customerContactReport) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return customerContactReport;
		}		
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    	.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    			.mapFromEntity(customer), customerContactReport);
    	MapperContextHolder.getContext().put(customer, customerContactReport);
		customerContactReport.setFirstName(customer.getFirstName());
		customerContactReport.setLastName(customer.getLastName());
		customerContactReport.setEmailAddress(customer.getEmailAddress());
		customerContactReport.setTelefonNumber(customer.getTelefonNumber());
        return customerContactReport;
	}
	
	

	private DtoAssembler<CustomerIdDto> createDtoAssemblerCustomerIdDto() {
		return new DtoAssembler<CustomerIdDto>() {
		    public CustomerIdDto mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		CustomerIdDto result = mapFromCustomerToCustomerIdDto(customer);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public CustomerIdDto mapFromEntity(Object sourceEntity, CustomerIdDto targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToCustomerIdDto(customer, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(CustomerIdDto sourceDto, Class<T> target) {
				if (CustomerIdDto.class.equals(target)) {
					CustomerIdDto result = new CustomerIdDto();
					mapFromCustomerIdDtoToCustomerIdDto(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromCustomerIdDtoToCustomer(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(CustomerIdDto sourceDto, Object targetObject) {
		    	if (targetObject instanceof CustomerIdDto) {
					mapFromCustomerIdDtoToCustomerIdDto(sourceDto, (CustomerIdDto) targetObject);
				}				
		    	else if (targetObject instanceof Customer) {
		    		mapFromCustomerIdDtoToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromCustomerIdDtoToCustomerIdDto(CustomerIdDto sourceDto, CustomerIdDto customerIdDto) {
   		customerIdDto.setOid(sourceDto.getOid());
    }
    
    protected Customer mapFromCustomerIdDtoToCustomer(CustomerIdDto sourceDto) {
    	return mapFromCustomerIdDtoToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromCustomerIdDtoToCustomer(CustomerIdDto sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    MapperContextHolder.getContext().put(sourceDto, customer);
		if (sourceDto.getOid() != null) {
			customer.setOid(sourceDto.getOid());
		}
	    return customer;
	}
	
	protected CustomerIdDto mapFromCustomerToCustomerIdDto(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (CustomerIdDto) MapperContextHolder.getContext().get(customer);
		}
		CustomerIdDto customerIdDto = new CustomerIdDto();
    	MapperContextHolder.getContext().put(customer, customerIdDto);
		customerIdDto.setOid(customer.getOid());
        return customerIdDto;
	}
	
	protected CustomerIdDto mapFromCustomerToCustomerIdDto(Customer customer, CustomerIdDto customerIdDto) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return customerIdDto;
		}		
    	MapperContextHolder.getContext().put(customer, customerIdDto);
		customerIdDto.setOid(customer.getOid());
        return customerIdDto;
	}
	
	

	private DtoAssembler<CustomerOrderReportDto> createDtoAssemblerCustomerOrderReportDto() {
		return new DtoAssembler<CustomerOrderReportDto>() {
		    public CustomerOrderReportDto mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		CustomerOrderReportDto result = mapFromCustomerToCustomerOrderReportDto(customer);
		    		return result;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		CustomerOrderReportDto result = mapFromAddressToCustomerOrderReportDto(address);
		    		return result;
		    	} else if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		CustomerOrderReportDto result = mapFromOrderToCustomerOrderReportDto(order);
		    		return result;
		    	} else if (sourceEntity instanceof OrderItem) {
					OrderItem orderItem = (OrderItem) sourceEntity;
		    		CustomerOrderReportDto result = mapFromOrderItemToCustomerOrderReportDto(orderItem);
		    		return result;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		CustomerOrderReportDto result = mapFromProductToCustomerOrderReportDto(product);
		    		return result;
		    	} else if (sourceEntity instanceof ProductImage) {
					ProductImage productImage = (ProductImage) sourceEntity;
		    		CustomerOrderReportDto result = mapFromProductImageToCustomerOrderReportDto(productImage);
		    		return result;
		    	}else {
					CustomerOrderReportDto result = new CustomerOrderReportDto();
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
						.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
								.mapFromEntity(sourceEntity), result);
					return result;
				}
			}
			
			public CustomerOrderReportDto mapFromEntity(Object sourceEntity, CustomerOrderReportDto targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToCustomerOrderReportDto(customer, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		mapFromAddressToCustomerOrderReportDto(address, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		mapFromOrderToCustomerOrderReportDto(order, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof OrderItem) {
					OrderItem orderItem = (OrderItem) sourceEntity;
		    		mapFromOrderItemToCustomerOrderReportDto(orderItem, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		mapFromProductToCustomerOrderReportDto(product, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof ProductImage) {
					ProductImage productImage = (ProductImage) sourceEntity;
		    		mapFromProductImageToCustomerOrderReportDto(productImage, targetDto);
		    		return targetDto;
		    	}else {					
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
						.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
								.mapFromEntity(sourceEntity), targetDto);
					return targetDto;
				}
			}
			
			public <T> T mapTo(CustomerOrderReportDto sourceDto, Class<T> target) {
				if (CustomerOrderReportDto.class.equals(target)) {
					CustomerOrderReportDto result = new CustomerOrderReportDto();
					mapFromCustomerOrderReportDtoToCustomerOrderReportDto(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromCustomerOrderReportDtoToCustomer(sourceDto));
		    	}
				else if (Address.class.equals(target)) {
		    		return target.cast(mapFromCustomerOrderReportDtoToAddress(sourceDto));
		    	}
				else if (Order.class.equals(target)) {
		    		return target.cast(mapFromCustomerOrderReportDtoToOrder(sourceDto));
		    	}
				else if (OrderItem.class.equals(target)) {
		    		return target.cast(mapFromCustomerOrderReportDtoToOrderItem(sourceDto));
		    	}
				else if (Product.class.equals(target)) {
		    		return target.cast(mapFromCustomerOrderReportDtoToProduct(sourceDto));
		    	}
				else if (ProductImage.class.equals(target)) {
		    		return target.cast(mapFromCustomerOrderReportDtoToProductImage(sourceDto));
		    	}
		    	else {
					return dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, target);
				}
		    }

		    public void mapTo(CustomerOrderReportDto sourceDto, Object targetObject) {
		    	if (targetObject instanceof CustomerOrderReportDto) {
					mapFromCustomerOrderReportDtoToCustomerOrderReportDto(sourceDto, (CustomerOrderReportDto) targetObject);
				}				
		    	else if (targetObject instanceof Customer) {
		    		mapFromCustomerOrderReportDtoToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Address) {
		    		mapFromCustomerOrderReportDtoToAddress(sourceDto, (Address)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Order) {
		    		mapFromCustomerOrderReportDtoToOrder(sourceDto, (Order)targetObject);
		    	}		    	
		    	else if (targetObject instanceof OrderItem) {
		    		mapFromCustomerOrderReportDtoToOrderItem(sourceDto, (OrderItem)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Product) {
		    		mapFromCustomerOrderReportDtoToProduct(sourceDto, (Product)targetObject);
		    	}		    	
		    	else if (targetObject instanceof ProductImage) {
		    		mapFromCustomerOrderReportDtoToProductImage(sourceDto, (ProductImage)targetObject);
		    	}		    	
		    	else {
					dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, targetObject);
				}
			}
		};
	}

    protected void mapFromCustomerOrderReportDtoToCustomerOrderReportDto(CustomerOrderReportDto sourceDto, CustomerOrderReportDto customerOrderReportDto) {
        dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, customerOrderReportDto);
   		customerOrderReportDto.setFirstName(sourceDto.getFirstName());
   		customerOrderReportDto.setLastName(sourceDto.getLastName());
   		customerOrderReportDto.setEmailAddress(sourceDto.getEmailAddress());
   		customerOrderReportDto.setCity(sourceDto.getCity());
   		customerOrderReportDto.setStreetName(sourceDto.getStreetName());
   		customerOrderReportDto.setStreetNumber(sourceDto.getStreetNumber());
   		customerOrderReportDto.setBillingCountry(sourceDto.getBillingCountry());
   		customerOrderReportDto.setDeliveryCountry(sourceDto.getDeliveryCountry());
   		customerOrderReportDto.setOrderNumber(sourceDto.getOrderNumber());
   		customerOrderReportDto.setOrderState(sourceDto.getOrderState());
   		customerOrderReportDto.setTotalAmount(sourceDto.getTotalAmount());
   		customerOrderReportDto.setQuantity(sourceDto.getQuantity());
   		customerOrderReportDto.setName(sourceDto.getName());
   		customerOrderReportDto.setFileName(sourceDto.getFileName());
    }
    
    protected Customer mapFromCustomerOrderReportDtoToCustomer(CustomerOrderReportDto sourceDto) {
    	return mapFromCustomerOrderReportDtoToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromCustomerOrderReportDtoToCustomer(CustomerOrderReportDto sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class).mapTo(sourceDto, customer);
		customer.setFirstName(sourceDto.getFirstName());
		customer.setLastName(sourceDto.getLastName());
		customer.setEmailAddress(sourceDto.getEmailAddress());
	    return customer;
	}
			
    protected Address mapFromCustomerOrderReportDtoToAddress(CustomerOrderReportDto sourceDto) {
    	return mapFromCustomerOrderReportDtoToAddress(sourceDto, MapperContextHolder.createEntity(Address.class));
    }

    protected Address mapFromCustomerOrderReportDtoToAddress(CustomerOrderReportDto sourceDto, Address address) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return address;
    	}
	    MapperContextHolder.getContext().put(sourceDto, address);
		address.setCity(sourceDto.getCity());
		address.setStreetName(sourceDto.getStreetName());
		address.setStreetNumber(sourceDto.getStreetNumber());
		address.setCountry(sourceDto.getBillingCountry());
		address.setCountry(sourceDto.getDeliveryCountry());
	    return address;
	}
			
    protected Order mapFromCustomerOrderReportDtoToOrder(CustomerOrderReportDto sourceDto) {
    	return mapFromCustomerOrderReportDtoToOrder(sourceDto, MapperContextHolder.createEntity(Order.class));
    }

    protected Order mapFromCustomerOrderReportDtoToOrder(CustomerOrderReportDto sourceDto, Order order) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return order;
    	}
	    MapperContextHolder.getContext().put(sourceDto, order);
		order.setOrderNumber(sourceDto.getOrderNumber());
		order.setOrderState(sourceDto.getOrderState());
		order.setTotalAmount(sourceDto.getTotalAmount());
	    return order;
	}
			
    protected OrderItem mapFromCustomerOrderReportDtoToOrderItem(CustomerOrderReportDto sourceDto) {
    	return mapFromCustomerOrderReportDtoToOrderItem(sourceDto, MapperContextHolder.createEntity(OrderItem.class));
    }

    protected OrderItem mapFromCustomerOrderReportDtoToOrderItem(CustomerOrderReportDto sourceDto, OrderItem orderItem) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return orderItem;
    	}
	    MapperContextHolder.getContext().put(sourceDto, orderItem);
		orderItem.setQuantity(sourceDto.getQuantity());
	    return orderItem;
	}
			
    protected Product mapFromCustomerOrderReportDtoToProduct(CustomerOrderReportDto sourceDto) {
    	return mapFromCustomerOrderReportDtoToProduct(sourceDto, MapperContextHolder.createEntity(Product.class));
    }

    protected Product mapFromCustomerOrderReportDtoToProduct(CustomerOrderReportDto sourceDto, Product product) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return product;
    	}
	    MapperContextHolder.getContext().put(sourceDto, product);
		product.setName(sourceDto.getName());
	    return product;
	}
			
    protected ProductImage mapFromCustomerOrderReportDtoToProductImage(CustomerOrderReportDto sourceDto) {
    	return mapFromCustomerOrderReportDtoToProductImage(sourceDto, MapperContextHolder.createEntity(ProductImage.class));
    }

    protected ProductImage mapFromCustomerOrderReportDtoToProductImage(CustomerOrderReportDto sourceDto, ProductImage productImage) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return productImage;
    	}
	    MapperContextHolder.getContext().put(sourceDto, productImage);
		productImage.setFileName(sourceDto.getFileName());
	    return productImage;
	}
	
	protected CustomerOrderReportDto mapFromCustomerToCustomerOrderReportDto(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (CustomerOrderReportDto) MapperContextHolder.getContext().get(customer);
		}
		CustomerOrderReportDto customerOrderReportDto = new CustomerOrderReportDto();
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    	.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    			.mapFromEntity(customer), customerOrderReportDto);
    	MapperContextHolder.getContext().put(customer, customerOrderReportDto);
		customerOrderReportDto.setFirstName(customer.getFirstName());
		customerOrderReportDto.setLastName(customer.getLastName());
		customerOrderReportDto.setEmailAddress(customer.getEmailAddress());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromCustomerToCustomerOrderReportDto(Customer customer, CustomerOrderReportDto customerOrderReportDto) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return customerOrderReportDto;
		}		
	    dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    	.mapTo(dtoAssemblerRegistry.getDtoAssembler(CustomerIdDto.class)
	    			.mapFromEntity(customer), customerOrderReportDto);
    	MapperContextHolder.getContext().put(customer, customerOrderReportDto);
		customerOrderReportDto.setFirstName(customer.getFirstName());
		customerOrderReportDto.setLastName(customer.getLastName());
		customerOrderReportDto.setEmailAddress(customer.getEmailAddress());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromAddressToCustomerOrderReportDto(Address address) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return (CustomerOrderReportDto) MapperContextHolder.getContext().get(address);
		}
		CustomerOrderReportDto customerOrderReportDto = new CustomerOrderReportDto();
    	MapperContextHolder.getContext().put(address, customerOrderReportDto);
		customerOrderReportDto.setCity(address.getCity());
		customerOrderReportDto.setStreetName(address.getStreetName());
		customerOrderReportDto.setStreetNumber(address.getStreetNumber());
		customerOrderReportDto.setBillingCountry(address.getCountry());
		customerOrderReportDto.setDeliveryCountry(address.getCountry());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromAddressToCustomerOrderReportDto(Address address, CustomerOrderReportDto customerOrderReportDto) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return customerOrderReportDto;
		}		
    	MapperContextHolder.getContext().put(address, customerOrderReportDto);
		customerOrderReportDto.setCity(address.getCity());
		customerOrderReportDto.setStreetName(address.getStreetName());
		customerOrderReportDto.setStreetNumber(address.getStreetNumber());
		customerOrderReportDto.setBillingCountry(address.getCountry());
		customerOrderReportDto.setDeliveryCountry(address.getCountry());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromOrderToCustomerOrderReportDto(Order order) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return (CustomerOrderReportDto) MapperContextHolder.getContext().get(order);
		}
		CustomerOrderReportDto customerOrderReportDto = new CustomerOrderReportDto();
    	MapperContextHolder.getContext().put(order, customerOrderReportDto);
		customerOrderReportDto.setOrderNumber(order.getOrderNumber());
		customerOrderReportDto.setOrderState(order.getOrderState());
		customerOrderReportDto.setTotalAmount(order.getTotalAmount());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromOrderToCustomerOrderReportDto(Order order, CustomerOrderReportDto customerOrderReportDto) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return customerOrderReportDto;
		}		
    	MapperContextHolder.getContext().put(order, customerOrderReportDto);
		customerOrderReportDto.setOrderNumber(order.getOrderNumber());
		customerOrderReportDto.setOrderState(order.getOrderState());
		customerOrderReportDto.setTotalAmount(order.getTotalAmount());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromOrderItemToCustomerOrderReportDto(OrderItem orderItem) {
		if (MapperContextHolder.getContext().containsKey(orderItem)) {
			return (CustomerOrderReportDto) MapperContextHolder.getContext().get(orderItem);
		}
		CustomerOrderReportDto customerOrderReportDto = new CustomerOrderReportDto();
    	MapperContextHolder.getContext().put(orderItem, customerOrderReportDto);
		customerOrderReportDto.setQuantity(orderItem.getQuantity());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromOrderItemToCustomerOrderReportDto(OrderItem orderItem, CustomerOrderReportDto customerOrderReportDto) {
		if (MapperContextHolder.getContext().containsKey(orderItem)) {
			return customerOrderReportDto;
		}		
    	MapperContextHolder.getContext().put(orderItem, customerOrderReportDto);
		customerOrderReportDto.setQuantity(orderItem.getQuantity());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromProductToCustomerOrderReportDto(Product product) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return (CustomerOrderReportDto) MapperContextHolder.getContext().get(product);
		}
		CustomerOrderReportDto customerOrderReportDto = new CustomerOrderReportDto();
    	MapperContextHolder.getContext().put(product, customerOrderReportDto);
		customerOrderReportDto.setName(product.getName());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromProductToCustomerOrderReportDto(Product product, CustomerOrderReportDto customerOrderReportDto) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return customerOrderReportDto;
		}		
    	MapperContextHolder.getContext().put(product, customerOrderReportDto);
		customerOrderReportDto.setName(product.getName());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromProductImageToCustomerOrderReportDto(ProductImage productImage) {
		if (MapperContextHolder.getContext().containsKey(productImage)) {
			return (CustomerOrderReportDto) MapperContextHolder.getContext().get(productImage);
		}
		CustomerOrderReportDto customerOrderReportDto = new CustomerOrderReportDto();
    	MapperContextHolder.getContext().put(productImage, customerOrderReportDto);
		customerOrderReportDto.setFileName(productImage.getFileName());
        return customerOrderReportDto;
	}
	
	protected CustomerOrderReportDto mapFromProductImageToCustomerOrderReportDto(ProductImage productImage, CustomerOrderReportDto customerOrderReportDto) {
		if (MapperContextHolder.getContext().containsKey(productImage)) {
			return customerOrderReportDto;
		}		
    	MapperContextHolder.getContext().put(productImage, customerOrderReportDto);
		customerOrderReportDto.setFileName(productImage.getFileName());
        return customerOrderReportDto;
	}
	
	

	private DtoAssembler<CustomerOrderView> createDtoAssemblerCustomerOrderView() {
		return new DtoAssembler<CustomerOrderView>() {
		    public CustomerOrderView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		CustomerOrderView result = mapFromCustomerToCustomerOrderView(customer);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public CustomerOrderView mapFromEntity(Object sourceEntity, CustomerOrderView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToCustomerOrderView(customer, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(CustomerOrderView sourceDto, Class<T> target) {
				if (CustomerOrderView.class.equals(target)) {
					CustomerOrderView result = new CustomerOrderView();
					mapFromCustomerOrderViewToCustomerOrderView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromCustomerOrderViewToCustomer(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(CustomerOrderView sourceDto, Object targetObject) {
		    	if (targetObject instanceof CustomerOrderView) {
					mapFromCustomerOrderViewToCustomerOrderView(sourceDto, (CustomerOrderView) targetObject);
				}				
		    	else if (targetObject instanceof Customer) {
		    		mapFromCustomerOrderViewToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromCustomerOrderViewToCustomerOrderView(CustomerOrderView sourceDto, CustomerOrderView customerOrderView) {
   		customerOrderView.setOid(sourceDto.getOid());
   		customerOrderView.setFirstName(sourceDto.getFirstName());
   		customerOrderView.setLastName(sourceDto.getLastName());
   		customerOrderView.setBirthDate(sourceDto.getBirthDate());
   		customerOrderView.setEmailAddress(sourceDto.getEmailAddress());
   		customerOrderView.setOrders(sourceDto.getOrders());
    }
    
    protected Customer mapFromCustomerOrderViewToCustomer(CustomerOrderView sourceDto) {
    	return mapFromCustomerOrderViewToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromCustomerOrderViewToCustomer(CustomerOrderView sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    MapperContextHolder.getContext().put(sourceDto, customer);
		if (sourceDto.getOid() != null) {
			customer.setOid(sourceDto.getOid());
		}
		customer.setFirstName(sourceDto.getFirstName());
		customer.setLastName(sourceDto.getLastName());
		customer.setBirthDate(sourceDto.getBirthDate());
		customer.setEmailAddress(sourceDto.getEmailAddress());
	    if (!MapperContextHolder.isContext("saveCustomer") && !MapperContextHolder.isContext("updateCustomer")) {
			if (null != sourceDto.getOrders()) {
				for (OrderStateView orderStateView : sourceDto.getOrders()) {
					Order orders = (Order) dtoAssemblerRegistry.getDtoAssembler(OrderStateView.class).mapTo(orderStateView, Order.class);
					customer.addOrders(orders);
				}
			}
	    }
	    return customer;
	}
	
	protected CustomerOrderView mapFromCustomerToCustomerOrderView(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (CustomerOrderView) MapperContextHolder.getContext().get(customer);
		}
		CustomerOrderView customerOrderView = new CustomerOrderView();
    	MapperContextHolder.getContext().put(customer, customerOrderView);
		customerOrderView.setOid(customer.getOid());
		customerOrderView.setFirstName(customer.getFirstName());
		customerOrderView.setLastName(customer.getLastName());
		customerOrderView.setBirthDate(customer.getBirthDate());
		customerOrderView.setEmailAddress(customer.getEmailAddress());
		if (customer.hasOrders()) {
			for (Order next : customer.getOrders()) {
	    		OrderStateView nextOrderStateView = (OrderStateView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderStateView) {
		        	nextOrderStateView = dtoAssemblerRegistry.getDtoAssembler(OrderStateView.class).mapFromEntity(next);
		        }
	        	customerOrderView.addOrders(nextOrderStateView);
	    	}
		}
        return customerOrderView;
	}
	
	protected CustomerOrderView mapFromCustomerToCustomerOrderView(Customer customer, CustomerOrderView customerOrderView) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return customerOrderView;
		}		
    	MapperContextHolder.getContext().put(customer, customerOrderView);
		customerOrderView.setOid(customer.getOid());
		customerOrderView.setFirstName(customer.getFirstName());
		customerOrderView.setLastName(customer.getLastName());
		customerOrderView.setBirthDate(customer.getBirthDate());
		customerOrderView.setEmailAddress(customer.getEmailAddress());
		if (customer.hasOrders()) {
			for (Order next : customer.getOrders()) {
	    		OrderStateView nextOrderStateView = (OrderStateView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderStateView) {
		        	nextOrderStateView = dtoAssemblerRegistry.getDtoAssembler(OrderStateView.class).mapFromEntity(next);
		        }
	        	customerOrderView.addOrders(nextOrderStateView);
	    	}
		}
        return customerOrderView;
	}
	
	

	private DtoAssembler<CustomerView> createDtoAssemblerCustomerView() {
		return new DtoAssembler<CustomerView>() {
		    public CustomerView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		CustomerView result = mapFromCustomerToCustomerView(customer);
		    		if (null != customer.getInvoiceAddress()) {
		    			result.setInvoiceAddressOid(customer.getInvoiceAddress().getOid());
		    		}
		    		if (null != customer.getDeliveryAddress()) {
		    			result.setDeliveryAddressOid(customer.getDeliveryAddress().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		CustomerView result = mapFromAddressToCustomerView(address);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public CustomerView mapFromEntity(Object sourceEntity, CustomerView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToCustomerView(customer, targetDto);
		    		if (null != customer.getInvoiceAddress()) {
		    			targetDto.setInvoiceAddressOid(customer.getInvoiceAddress().getOid());
		    		}
		    		if (null != customer.getDeliveryAddress()) {
		    			targetDto.setDeliveryAddressOid(customer.getDeliveryAddress().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		mapFromAddressToCustomerView(address, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(CustomerView sourceDto, Class<T> target) {
				if (CustomerView.class.equals(target)) {
					CustomerView result = new CustomerView();
					mapFromCustomerViewToCustomerView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromCustomerViewToCustomer(sourceDto));
		    	}
				else if (Address.class.equals(target)) {
		    		return target.cast(mapFromCustomerViewToAddress(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(CustomerView sourceDto, Object targetObject) {
		    	if (targetObject instanceof CustomerView) {
					mapFromCustomerViewToCustomerView(sourceDto, (CustomerView) targetObject);
				}				
		    	else if (targetObject instanceof Customer) {
		    		mapFromCustomerViewToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Address) {
		    		mapFromCustomerViewToAddress(sourceDto, (Address)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromCustomerViewToCustomerView(CustomerView sourceDto, CustomerView customerView) {
   		customerView.setCity(sourceDto.getCity());
   		customerView.setCountry(sourceDto.getCountry());
   		customerView.setStreetName(sourceDto.getStreetName());
   		customerView.setOrders(sourceDto.getOrders());
   		customerView.setInvoiceAddress(sourceDto.getInvoiceAddress());
   		customerView.setDeliveryAddress(sourceDto.getDeliveryAddress());
   		customerView.setOid(sourceDto.getOid());
   		customerView.setVersion(sourceDto.getVersion());
   		customerView.setFirstName(sourceDto.getFirstName());
   		customerView.setLastName(sourceDto.getLastName());
   		customerView.setGender(sourceDto.getGender());
   		customerView.setEmailAddress(sourceDto.getEmailAddress());
   		customerView.setBirthDate(sourceDto.getBirthDate());
   		customerView.setTelefonNumber(sourceDto.getTelefonNumber());
   		customerView.setInvoiceAddressOid(sourceDto.getInvoiceAddressOid());
   		customerView.setDeliveryAddressOid(sourceDto.getDeliveryAddressOid());
    }
    
    protected Customer mapFromCustomerViewToCustomer(CustomerView sourceDto) {
    	return mapFromCustomerViewToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromCustomerViewToCustomer(CustomerView sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    MapperContextHolder.getContext().put(sourceDto, customer);
		if (sourceDto.getOid() != null) {
			customer.setOid(sourceDto.getOid());
		}
		customer.setVersion(sourceDto.getVersion());
		customer.setFirstName(sourceDto.getFirstName());
		customer.setLastName(sourceDto.getLastName());
		customer.setGender(sourceDto.getGender());
		customer.setEmailAddress(sourceDto.getEmailAddress());
		customer.setBirthDate(sourceDto.getBirthDate());
		customer.setTelefonNumber(sourceDto.getTelefonNumber());
	    if (!MapperContextHolder.isContext("saveCustomer") && !MapperContextHolder.isContext("updateCustomer")) {
			if (null != sourceDto.getOrders()) {
				for (OrderView orderView : sourceDto.getOrders()) {
					Order orders = (Order) dtoAssemblerRegistry.getDtoAssembler(OrderView.class).mapTo(orderView, Order.class);
					customer.addOrders(orders);
				}
			}
			if (null != sourceDto.getInvoiceAddress()) {
		   		Address invoiceAddress = (Address) dtoAssemblerRegistry.getDtoAssembler(AddressView.class).mapTo(sourceDto.getInvoiceAddress(), Address.class);
				customer.setInvoiceAddress(invoiceAddress);
			}
			if (null != sourceDto.getDeliveryAddress()) {
		   		Address deliveryAddress = (Address) dtoAssemblerRegistry.getDtoAssembler(AddressView.class).mapTo(sourceDto.getDeliveryAddress(), Address.class);
				customer.setDeliveryAddress(deliveryAddress);
			}
	    }
	    return customer;
	}
			
    protected Address mapFromCustomerViewToAddress(CustomerView sourceDto) {
    	return mapFromCustomerViewToAddress(sourceDto, MapperContextHolder.createEntity(Address.class));
    }

    protected Address mapFromCustomerViewToAddress(CustomerView sourceDto, Address address) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return address;
    	}
	    MapperContextHolder.getContext().put(sourceDto, address);
		address.setCity(sourceDto.getCity());
		address.setCountry(sourceDto.getCountry());
		address.setStreetName(sourceDto.getStreetName());
		if (sourceDto.getInvoiceAddressOid() != null  && MapperContextHolder.isContext("invoiceAddress")) {
			address.setOid(sourceDto.getInvoiceAddressOid());
		}
		if (sourceDto.getDeliveryAddressOid() != null  && MapperContextHolder.isContext("deliveryAddress")) {
			address.setOid(sourceDto.getDeliveryAddressOid());
		}
	    return address;
	}
	
	protected CustomerView mapFromCustomerToCustomerView(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (CustomerView) MapperContextHolder.getContext().get(customer);
		}
		CustomerView customerView = new CustomerView();
    	MapperContextHolder.getContext().put(customer, customerView);
		customerView.setOid(customer.getOid());
		customerView.setVersion(customer.getVersion());
		customerView.setFirstName(customer.getFirstName());
		customerView.setLastName(customer.getLastName());
		customerView.setGender(customer.getGender());
		customerView.setEmailAddress(customer.getEmailAddress());
		customerView.setBirthDate(customer.getBirthDate());
		customerView.setTelefonNumber(customer.getTelefonNumber());
		if (customer.hasOrders()) {
			for (Order next : customer.getOrders()) {
	    		OrderView nextOrderView = (OrderView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderView) {
		        	nextOrderView = dtoAssemblerRegistry.getDtoAssembler(OrderView.class).mapFromEntity(next);
		        }
	        	customerView.addOrders(nextOrderView);
	    	}
		}
        if (null != customer.getInvoiceAddress()) {
	        AddressView invoiceAddress = (AddressView) MapperContextHolder.getContext().get(customer.getInvoiceAddress());
	        if (null == invoiceAddress) {
	        	invoiceAddress = dtoAssemblerRegistry.getDtoAssembler(AddressView.class).mapFromEntity(customer.getInvoiceAddress());
	        }
        	customerView.setInvoiceAddress(invoiceAddress);
        }
        if (null != customer.getDeliveryAddress()) {
	        AddressView deliveryAddress = (AddressView) MapperContextHolder.getContext().get(customer.getDeliveryAddress());
	        if (null == deliveryAddress) {
	        	deliveryAddress = dtoAssemblerRegistry.getDtoAssembler(AddressView.class).mapFromEntity(customer.getDeliveryAddress());
	        }
        	customerView.setDeliveryAddress(deliveryAddress);
        }
        return customerView;
	}
	
	protected CustomerView mapFromCustomerToCustomerView(Customer customer, CustomerView customerView) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return customerView;
		}		
    	MapperContextHolder.getContext().put(customer, customerView);
		customerView.setOid(customer.getOid());
		customerView.setVersion(customer.getVersion());
		customerView.setFirstName(customer.getFirstName());
		customerView.setLastName(customer.getLastName());
		customerView.setGender(customer.getGender());
		customerView.setEmailAddress(customer.getEmailAddress());
		customerView.setBirthDate(customer.getBirthDate());
		customerView.setTelefonNumber(customer.getTelefonNumber());
		if (customer.hasOrders()) {
			for (Order next : customer.getOrders()) {
	    		OrderView nextOrderView = (OrderView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderView) {
		        	nextOrderView = dtoAssemblerRegistry.getDtoAssembler(OrderView.class).mapFromEntity(next);
		        }
	        	customerView.addOrders(nextOrderView);
	    	}
		}
        if (null != customer.getInvoiceAddress()) {
	        AddressView invoiceAddress = (AddressView) MapperContextHolder.getContext().get(customer.getInvoiceAddress());
	        if (null == invoiceAddress) {
	        	invoiceAddress = dtoAssemblerRegistry.getDtoAssembler(AddressView.class).mapFromEntity(customer.getInvoiceAddress());
	        }
        	customerView.setInvoiceAddress(invoiceAddress);
        }
        if (null != customer.getDeliveryAddress()) {
	        AddressView deliveryAddress = (AddressView) MapperContextHolder.getContext().get(customer.getDeliveryAddress());
	        if (null == deliveryAddress) {
	        	deliveryAddress = dtoAssemblerRegistry.getDtoAssembler(AddressView.class).mapFromEntity(customer.getDeliveryAddress());
	        }
        	customerView.setDeliveryAddress(deliveryAddress);
        }
        return customerView;
	}
	
	protected CustomerView mapFromAddressToCustomerView(Address address) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return (CustomerView) MapperContextHolder.getContext().get(address);
		}
		CustomerView customerView = new CustomerView();
    	MapperContextHolder.getContext().put(address, customerView);
		customerView.setCity(address.getCity());
		customerView.setCountry(address.getCountry());
		customerView.setStreetName(address.getStreetName());
		customerView.setInvoiceAddressOid(address.getOid());
		customerView.setDeliveryAddressOid(address.getOid());
        return customerView;
	}
	
	protected CustomerView mapFromAddressToCustomerView(Address address, CustomerView customerView) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return customerView;
		}		
    	MapperContextHolder.getContext().put(address, customerView);
		customerView.setCity(address.getCity());
		customerView.setCountry(address.getCountry());
		customerView.setStreetName(address.getStreetName());
		customerView.setInvoiceAddressOid(address.getOid());
		customerView.setDeliveryAddressOid(address.getOid());
        return customerView;
	}
	
	

	private DtoAssembler<OrderItemQuantityView> createDtoAssemblerOrderItemQuantityView() {
		return new DtoAssembler<OrderItemQuantityView>() {
		    public OrderItemQuantityView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof OrderItem) {
					OrderItem orderItem = (OrderItem) sourceEntity;
		    		OrderItemQuantityView result = mapFromOrderItemToOrderItemQuantityView(orderItem);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public OrderItemQuantityView mapFromEntity(Object sourceEntity, OrderItemQuantityView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof OrderItem) {
					OrderItem orderItem = (OrderItem) sourceEntity;
		    		mapFromOrderItemToOrderItemQuantityView(orderItem, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(OrderItemQuantityView sourceDto, Class<T> target) {
				if (OrderItemQuantityView.class.equals(target)) {
					OrderItemQuantityView result = new OrderItemQuantityView();
					mapFromOrderItemQuantityViewToOrderItemQuantityView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (OrderItem.class.equals(target)) {
		    		return target.cast(mapFromOrderItemQuantityViewToOrderItem(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(OrderItemQuantityView sourceDto, Object targetObject) {
		    	if (targetObject instanceof OrderItemQuantityView) {
					mapFromOrderItemQuantityViewToOrderItemQuantityView(sourceDto, (OrderItemQuantityView) targetObject);
				}				
		    	else if (targetObject instanceof OrderItem) {
		    		mapFromOrderItemQuantityViewToOrderItem(sourceDto, (OrderItem)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromOrderItemQuantityViewToOrderItemQuantityView(OrderItemQuantityView sourceDto, OrderItemQuantityView orderItemQuantityView) {
   		orderItemQuantityView.setQuantity(sourceDto.getQuantity());
   		orderItemQuantityView.setOrder(sourceDto.getOrder());
   		orderItemQuantityView.setProduct(sourceDto.getProduct());
    }
    
    protected OrderItem mapFromOrderItemQuantityViewToOrderItem(OrderItemQuantityView sourceDto) {
    	return mapFromOrderItemQuantityViewToOrderItem(sourceDto, MapperContextHolder.createEntity(OrderItem.class));
    }

    protected OrderItem mapFromOrderItemQuantityViewToOrderItem(OrderItemQuantityView sourceDto, OrderItem orderItem) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return orderItem;
    	}
	    MapperContextHolder.getContext().put(sourceDto, orderItem);
		orderItem.setQuantity(sourceDto.getQuantity());
	    if (!MapperContextHolder.isContext("saveOrderItem") && !MapperContextHolder.isContext("updateOrderItem")) {
			if (null != sourceDto.getOrder()) {
		   		Order order = (Order) dtoAssemblerRegistry.getDtoAssembler(OrderStateView.class).mapTo(sourceDto.getOrder(), Order.class);
				orderItem.setOrder(order);
			}
			if (null != sourceDto.getProduct()) {
		   		Product product = (Product) dtoAssemblerRegistry.getDtoAssembler(ProductIdView.class).mapTo(sourceDto.getProduct(), Product.class);
				orderItem.setProduct(product);
			}
	    }
	    return orderItem;
	}
	
	protected OrderItemQuantityView mapFromOrderItemToOrderItemQuantityView(OrderItem orderItem) {
		if (MapperContextHolder.getContext().containsKey(orderItem)) {
			return (OrderItemQuantityView) MapperContextHolder.getContext().get(orderItem);
		}
		OrderItemQuantityView orderItemQuantityView = new OrderItemQuantityView();
    	MapperContextHolder.getContext().put(orderItem, orderItemQuantityView);
		orderItemQuantityView.setQuantity(orderItem.getQuantity());
        if (null != orderItem.getOrder()) {
	        OrderStateView order = (OrderStateView) MapperContextHolder.getContext().get(orderItem.getOrder());
	        if (null == order) {
	        	order = dtoAssemblerRegistry.getDtoAssembler(OrderStateView.class).mapFromEntity(orderItem.getOrder());
	        }
        	orderItemQuantityView.setOrder(order);
        }
        if (null != orderItem.getProduct()) {
	        ProductIdView product = (ProductIdView) MapperContextHolder.getContext().get(orderItem.getProduct());
	        if (null == product) {
	        	product = dtoAssemblerRegistry.getDtoAssembler(ProductIdView.class).mapFromEntity(orderItem.getProduct());
	        }
        	orderItemQuantityView.setProduct(product);
        }
        return orderItemQuantityView;
	}
	
	protected OrderItemQuantityView mapFromOrderItemToOrderItemQuantityView(OrderItem orderItem, OrderItemQuantityView orderItemQuantityView) {
		if (MapperContextHolder.getContext().containsKey(orderItem)) {
			return orderItemQuantityView;
		}		
    	MapperContextHolder.getContext().put(orderItem, orderItemQuantityView);
		orderItemQuantityView.setQuantity(orderItem.getQuantity());
        if (null != orderItem.getOrder()) {
	        OrderStateView order = (OrderStateView) MapperContextHolder.getContext().get(orderItem.getOrder());
	        if (null == order) {
	        	order = dtoAssemblerRegistry.getDtoAssembler(OrderStateView.class).mapFromEntity(orderItem.getOrder());
	        }
        	orderItemQuantityView.setOrder(order);
        }
        if (null != orderItem.getProduct()) {
	        ProductIdView product = (ProductIdView) MapperContextHolder.getContext().get(orderItem.getProduct());
	        if (null == product) {
	        	product = dtoAssemblerRegistry.getDtoAssembler(ProductIdView.class).mapFromEntity(orderItem.getProduct());
	        }
        	orderItemQuantityView.setProduct(product);
        }
        return orderItemQuantityView;
	}
	
	

	private DtoAssembler<OrderItemView> createDtoAssemblerOrderItemView() {
		return new DtoAssembler<OrderItemView>() {
		    public OrderItemView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof OrderItem) {
					OrderItem orderItem = (OrderItem) sourceEntity;
		    		OrderItemView result = mapFromOrderItemToOrderItemView(orderItem);
		    		if (null != orderItem.getOrder()) {
		    			result.setOrderOid(orderItem.getOrder().getOid());
		    		}
		    		if (null != orderItem.getProduct()) {
		    			result.setProductOid(orderItem.getProduct().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		OrderItemView result = mapFromOrderToOrderItemView(order);
		    		return result;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		OrderItemView result = mapFromProductToOrderItemView(product);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public OrderItemView mapFromEntity(Object sourceEntity, OrderItemView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof OrderItem) {
					OrderItem orderItem = (OrderItem) sourceEntity;
		    		mapFromOrderItemToOrderItemView(orderItem, targetDto);
		    		if (null != orderItem.getOrder()) {
		    			targetDto.setOrderOid(orderItem.getOrder().getOid());
		    		}
		    		if (null != orderItem.getProduct()) {
		    			targetDto.setProductOid(orderItem.getProduct().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		mapFromOrderToOrderItemView(order, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		mapFromProductToOrderItemView(product, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(OrderItemView sourceDto, Class<T> target) {
				if (OrderItemView.class.equals(target)) {
					OrderItemView result = new OrderItemView();
					mapFromOrderItemViewToOrderItemView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (OrderItem.class.equals(target)) {
		    		return target.cast(mapFromOrderItemViewToOrderItem(sourceDto));
		    	}
				else if (Order.class.equals(target)) {
		    		return target.cast(mapFromOrderItemViewToOrder(sourceDto));
		    	}
				else if (Product.class.equals(target)) {
		    		return target.cast(mapFromOrderItemViewToProduct(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(OrderItemView sourceDto, Object targetObject) {
		    	if (targetObject instanceof OrderItemView) {
					mapFromOrderItemViewToOrderItemView(sourceDto, (OrderItemView) targetObject);
				}				
		    	else if (targetObject instanceof OrderItem) {
		    		mapFromOrderItemViewToOrderItem(sourceDto, (OrderItem)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Order) {
		    		mapFromOrderItemViewToOrder(sourceDto, (Order)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Product) {
		    		mapFromOrderItemViewToProduct(sourceDto, (Product)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromOrderItemViewToOrderItemView(OrderItemView sourceDto, OrderItemView orderItemView) {
   		orderItemView.setOid(sourceDto.getOid());
   		orderItemView.setVersion(sourceDto.getVersion());
   		orderItemView.setItemNo(sourceDto.getItemNo());
   		orderItemView.setQuantity(sourceDto.getQuantity());
   		orderItemView.setOrderOid(sourceDto.getOrderOid());
   		orderItemView.setProductOid(sourceDto.getProductOid());
    }
    
    protected OrderItem mapFromOrderItemViewToOrderItem(OrderItemView sourceDto) {
    	return mapFromOrderItemViewToOrderItem(sourceDto, MapperContextHolder.createEntity(OrderItem.class));
    }

    protected OrderItem mapFromOrderItemViewToOrderItem(OrderItemView sourceDto, OrderItem orderItem) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return orderItem;
    	}
	    MapperContextHolder.getContext().put(sourceDto, orderItem);
		if (sourceDto.getOid() != null) {
			orderItem.setOid(sourceDto.getOid());
		}
		orderItem.setVersion(sourceDto.getVersion());
		orderItem.setItemNo(sourceDto.getItemNo());
		orderItem.setQuantity(sourceDto.getQuantity());
	    return orderItem;
	}
			
    protected Order mapFromOrderItemViewToOrder(OrderItemView sourceDto) {
    	return mapFromOrderItemViewToOrder(sourceDto, MapperContextHolder.createEntity(Order.class));
    }

    protected Order mapFromOrderItemViewToOrder(OrderItemView sourceDto, Order order) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return order;
    	}
	    MapperContextHolder.getContext().put(sourceDto, order);
		if (sourceDto.getOrderOid() != null  && MapperContextHolder.isContext("order")) {
			order.setOid(sourceDto.getOrderOid());
		}
	    return order;
	}
			
    protected Product mapFromOrderItemViewToProduct(OrderItemView sourceDto) {
    	return mapFromOrderItemViewToProduct(sourceDto, MapperContextHolder.createEntity(Product.class));
    }

    protected Product mapFromOrderItemViewToProduct(OrderItemView sourceDto, Product product) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return product;
    	}
	    MapperContextHolder.getContext().put(sourceDto, product);
		if (sourceDto.getProductOid() != null  && MapperContextHolder.isContext("product")) {
			product.setOid(sourceDto.getProductOid());
		}
	    return product;
	}
	
	protected OrderItemView mapFromOrderItemToOrderItemView(OrderItem orderItem) {
		if (MapperContextHolder.getContext().containsKey(orderItem)) {
			return (OrderItemView) MapperContextHolder.getContext().get(orderItem);
		}
		OrderItemView orderItemView = new OrderItemView();
    	MapperContextHolder.getContext().put(orderItem, orderItemView);
		orderItemView.setOid(orderItem.getOid());
		orderItemView.setVersion(orderItem.getVersion());
		orderItemView.setItemNo(orderItem.getItemNo());
		orderItemView.setQuantity(orderItem.getQuantity());
        return orderItemView;
	}
	
	protected OrderItemView mapFromOrderItemToOrderItemView(OrderItem orderItem, OrderItemView orderItemView) {
		if (MapperContextHolder.getContext().containsKey(orderItem)) {
			return orderItemView;
		}		
    	MapperContextHolder.getContext().put(orderItem, orderItemView);
		orderItemView.setOid(orderItem.getOid());
		orderItemView.setVersion(orderItem.getVersion());
		orderItemView.setItemNo(orderItem.getItemNo());
		orderItemView.setQuantity(orderItem.getQuantity());
        return orderItemView;
	}
	
	protected OrderItemView mapFromOrderToOrderItemView(Order order) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return (OrderItemView) MapperContextHolder.getContext().get(order);
		}
		OrderItemView orderItemView = new OrderItemView();
    	MapperContextHolder.getContext().put(order, orderItemView);
		orderItemView.setOrderOid(order.getOid());
        return orderItemView;
	}
	
	protected OrderItemView mapFromOrderToOrderItemView(Order order, OrderItemView orderItemView) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return orderItemView;
		}		
    	MapperContextHolder.getContext().put(order, orderItemView);
		orderItemView.setOrderOid(order.getOid());
        return orderItemView;
	}
	
	protected OrderItemView mapFromProductToOrderItemView(Product product) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return (OrderItemView) MapperContextHolder.getContext().get(product);
		}
		OrderItemView orderItemView = new OrderItemView();
    	MapperContextHolder.getContext().put(product, orderItemView);
		orderItemView.setProductOid(product.getOid());
        return orderItemView;
	}
	
	protected OrderItemView mapFromProductToOrderItemView(Product product, OrderItemView orderItemView) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return orderItemView;
		}		
    	MapperContextHolder.getContext().put(product, orderItemView);
		orderItemView.setProductOid(product.getOid());
        return orderItemView;
	}
	
	

	private DtoAssembler<OrderStateView> createDtoAssemblerOrderStateView() {
		return new DtoAssembler<OrderStateView>() {
		    public OrderStateView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		OrderStateView result = mapFromOrderToOrderStateView(order);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public OrderStateView mapFromEntity(Object sourceEntity, OrderStateView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		mapFromOrderToOrderStateView(order, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(OrderStateView sourceDto, Class<T> target) {
				if (OrderStateView.class.equals(target)) {
					OrderStateView result = new OrderStateView();
					mapFromOrderStateViewToOrderStateView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Order.class.equals(target)) {
		    		return target.cast(mapFromOrderStateViewToOrder(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(OrderStateView sourceDto, Object targetObject) {
		    	if (targetObject instanceof OrderStateView) {
					mapFromOrderStateViewToOrderStateView(sourceDto, (OrderStateView) targetObject);
				}				
		    	else if (targetObject instanceof Order) {
		    		mapFromOrderStateViewToOrder(sourceDto, (Order)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromOrderStateViewToOrderStateView(OrderStateView sourceDto, OrderStateView orderStateView) {
   		orderStateView.setOid(sourceDto.getOid());
   		orderStateView.setOrderNumber(sourceDto.getOrderNumber());
   		orderStateView.setDeliveryDate(sourceDto.getDeliveryDate());
   		orderStateView.setStoreId(sourceDto.getStoreId());
   		orderStateView.setPlacementDate(sourceDto.getPlacementDate());
   		orderStateView.setOrderState(sourceDto.getOrderState());
   		orderStateView.setCustomer(sourceDto.getCustomer());
   		orderStateView.setOrderItems(sourceDto.getOrderItems());
    }
    
    protected Order mapFromOrderStateViewToOrder(OrderStateView sourceDto) {
    	return mapFromOrderStateViewToOrder(sourceDto, MapperContextHolder.createEntity(Order.class));
    }

    protected Order mapFromOrderStateViewToOrder(OrderStateView sourceDto, Order order) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return order;
    	}
	    MapperContextHolder.getContext().put(sourceDto, order);
		if (sourceDto.getOid() != null) {
			order.setOid(sourceDto.getOid());
		}
		order.setOrderNumber(sourceDto.getOrderNumber());
		order.setDeliveryDate(sourceDto.getDeliveryDate());
		order.setStoreId(sourceDto.getStoreId());
		order.setPlacementDate(sourceDto.getPlacementDate());
		order.setOrderState(sourceDto.getOrderState());
	    if (!MapperContextHolder.isContext("saveOrder") && !MapperContextHolder.isContext("updateOrder")) {
			if (null != sourceDto.getCustomer()) {
		   		Customer customer = (Customer) dtoAssemblerRegistry.getDtoAssembler(CustomerOrderView.class).mapTo(sourceDto.getCustomer(), Customer.class);
				order.setCustomer(customer);
			}
			if (null != sourceDto.getOrderItems()) {
				for (OrderItemQuantityView orderItemQuantityView : sourceDto.getOrderItems()) {
					OrderItem orderItems = (OrderItem) dtoAssemblerRegistry.getDtoAssembler(OrderItemQuantityView.class).mapTo(orderItemQuantityView, OrderItem.class);
					order.addOrderItems(orderItems);
				}
			}
	    }
	    return order;
	}
	
	protected OrderStateView mapFromOrderToOrderStateView(Order order) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return (OrderStateView) MapperContextHolder.getContext().get(order);
		}
		OrderStateView orderStateView = new OrderStateView();
    	MapperContextHolder.getContext().put(order, orderStateView);
		orderStateView.setOid(order.getOid());
		orderStateView.setOrderNumber(order.getOrderNumber());
		orderStateView.setDeliveryDate(order.getDeliveryDate());
		orderStateView.setStoreId(order.getStoreId());
		orderStateView.setPlacementDate(order.getPlacementDate());
		orderStateView.setOrderState(order.getOrderState());
        if (null != order.getCustomer()) {
	        CustomerOrderView customer = (CustomerOrderView) MapperContextHolder.getContext().get(order.getCustomer());
	        if (null == customer) {
	        	customer = dtoAssemblerRegistry.getDtoAssembler(CustomerOrderView.class).mapFromEntity(order.getCustomer());
	        }
        	orderStateView.setCustomer(customer);
        }
		if (order.hasOrderItems()) {
			for (OrderItem next : order.getOrderItems()) {
	    		OrderItemQuantityView nextOrderItemQuantityView = (OrderItemQuantityView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderItemQuantityView) {
		        	nextOrderItemQuantityView = dtoAssemblerRegistry.getDtoAssembler(OrderItemQuantityView.class).mapFromEntity(next);
		        }
	        	orderStateView.addOrderItems(nextOrderItemQuantityView);
	    	}
		}
        return orderStateView;
	}
	
	protected OrderStateView mapFromOrderToOrderStateView(Order order, OrderStateView orderStateView) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return orderStateView;
		}		
    	MapperContextHolder.getContext().put(order, orderStateView);
		orderStateView.setOid(order.getOid());
		orderStateView.setOrderNumber(order.getOrderNumber());
		orderStateView.setDeliveryDate(order.getDeliveryDate());
		orderStateView.setStoreId(order.getStoreId());
		orderStateView.setPlacementDate(order.getPlacementDate());
		orderStateView.setOrderState(order.getOrderState());
        if (null != order.getCustomer()) {
	        CustomerOrderView customer = (CustomerOrderView) MapperContextHolder.getContext().get(order.getCustomer());
	        if (null == customer) {
	        	customer = dtoAssemblerRegistry.getDtoAssembler(CustomerOrderView.class).mapFromEntity(order.getCustomer());
	        }
        	orderStateView.setCustomer(customer);
        }
		if (order.hasOrderItems()) {
			for (OrderItem next : order.getOrderItems()) {
	    		OrderItemQuantityView nextOrderItemQuantityView = (OrderItemQuantityView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderItemQuantityView) {
		        	nextOrderItemQuantityView = dtoAssemblerRegistry.getDtoAssembler(OrderItemQuantityView.class).mapFromEntity(next);
		        }
	        	orderStateView.addOrderItems(nextOrderItemQuantityView);
	    	}
		}
        return orderStateView;
	}
	
	

	private DtoAssembler<OrderView> createDtoAssemblerOrderView() {
		return new DtoAssembler<OrderView>() {
		    public OrderView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		OrderView result = mapFromOrderToOrderView(order);
		    		if (null != order.getCustomer()) {
		    			result.setCustomerOid(order.getCustomer().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		OrderView result = mapFromCustomerToOrderView(customer);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public OrderView mapFromEntity(Object sourceEntity, OrderView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		mapFromOrderToOrderView(order, targetDto);
		    		if (null != order.getCustomer()) {
		    			targetDto.setCustomerOid(order.getCustomer().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToOrderView(customer, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(OrderView sourceDto, Class<T> target) {
				if (OrderView.class.equals(target)) {
					OrderView result = new OrderView();
					mapFromOrderViewToOrderView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Order.class.equals(target)) {
		    		return target.cast(mapFromOrderViewToOrder(sourceDto));
		    	}
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromOrderViewToCustomer(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(OrderView sourceDto, Object targetObject) {
		    	if (targetObject instanceof OrderView) {
					mapFromOrderViewToOrderView(sourceDto, (OrderView) targetObject);
				}				
		    	else if (targetObject instanceof Order) {
		    		mapFromOrderViewToOrder(sourceDto, (Order)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Customer) {
		    		mapFromOrderViewToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromOrderViewToOrderView(OrderView sourceDto, OrderView orderView) {
   		orderView.setOrders(sourceDto.getOrders());
   		orderView.setOrderItems(sourceDto.getOrderItems());
   		orderView.setOid(sourceDto.getOid());
   		orderView.setVersion(sourceDto.getVersion());
   		orderView.setOrderNumber(sourceDto.getOrderNumber());
   		orderView.setStoreId(sourceDto.getStoreId());
   		orderView.setPlacementDate(sourceDto.getPlacementDate());
   		orderView.setDeliveryDate(sourceDto.getDeliveryDate());
   		orderView.setOrderState(sourceDto.getOrderState());
   		orderView.setTaxes(sourceDto.getTaxes());
   		orderView.setTotalAmount(sourceDto.getTotalAmount());
   		orderView.setCustomerOid(sourceDto.getCustomerOid());
    }
    
    protected Order mapFromOrderViewToOrder(OrderView sourceDto) {
    	return mapFromOrderViewToOrder(sourceDto, MapperContextHolder.createEntity(Order.class));
    }

    protected Order mapFromOrderViewToOrder(OrderView sourceDto, Order order) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return order;
    	}
	    MapperContextHolder.getContext().put(sourceDto, order);
		if (sourceDto.getOid() != null) {
			order.setOid(sourceDto.getOid());
		}
		order.setVersion(sourceDto.getVersion());
		order.setOrderNumber(sourceDto.getOrderNumber());
		order.setStoreId(sourceDto.getStoreId());
		order.setPlacementDate(sourceDto.getPlacementDate());
		order.setDeliveryDate(sourceDto.getDeliveryDate());
		order.setOrderState(sourceDto.getOrderState());
		order.setTaxes(sourceDto.getTaxes());
		order.setTotalAmount(sourceDto.getTotalAmount());
	    if (!MapperContextHolder.isContext("saveOrder") && !MapperContextHolder.isContext("updateOrder")) {
			if (null != sourceDto.getOrderItems()) {
				for (OrderItemView orderItemView : sourceDto.getOrderItems()) {
					OrderItem orderItems = (OrderItem) dtoAssemblerRegistry.getDtoAssembler(OrderItemView.class).mapTo(orderItemView, OrderItem.class);
					order.addOrderItems(orderItems);
				}
			}
	    }
	    return order;
	}
			
    protected Customer mapFromOrderViewToCustomer(OrderView sourceDto) {
    	return mapFromOrderViewToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromOrderViewToCustomer(OrderView sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    MapperContextHolder.getContext().put(sourceDto, customer);
		if (sourceDto.getCustomerOid() != null  && MapperContextHolder.isContext("customer")) {
			customer.setOid(sourceDto.getCustomerOid());
		}
	    if (!MapperContextHolder.isContext("saveCustomer") && !MapperContextHolder.isContext("updateCustomer")) {
			if (null != sourceDto.getOrders()) {
				for (OrderView orderView : sourceDto.getOrders()) {
					Order orders = (Order) dtoAssemblerRegistry.getDtoAssembler(OrderView.class).mapTo(orderView, Order.class);
					customer.addOrders(orders);
				}
			}
	    }
	    return customer;
	}
	
	protected OrderView mapFromOrderToOrderView(Order order) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return (OrderView) MapperContextHolder.getContext().get(order);
		}
		OrderView orderView = new OrderView();
    	MapperContextHolder.getContext().put(order, orderView);
		orderView.setOid(order.getOid());
		orderView.setVersion(order.getVersion());
		orderView.setOrderNumber(order.getOrderNumber());
		orderView.setStoreId(order.getStoreId());
		orderView.setPlacementDate(order.getPlacementDate());
		orderView.setDeliveryDate(order.getDeliveryDate());
		orderView.setOrderState(order.getOrderState());
		orderView.setTaxes(order.getTaxes());
		orderView.setTotalAmount(order.getTotalAmount());
		if (order.hasOrderItems()) {
			for (OrderItem next : order.getOrderItems()) {
	    		OrderItemView nextOrderItemView = (OrderItemView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderItemView) {
		        	nextOrderItemView = dtoAssemblerRegistry.getDtoAssembler(OrderItemView.class).mapFromEntity(next);
		        }
	        	orderView.addOrderItems(nextOrderItemView);
	    	}
		}
        return orderView;
	}
	
	protected OrderView mapFromOrderToOrderView(Order order, OrderView orderView) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return orderView;
		}		
    	MapperContextHolder.getContext().put(order, orderView);
		orderView.setOid(order.getOid());
		orderView.setVersion(order.getVersion());
		orderView.setOrderNumber(order.getOrderNumber());
		orderView.setStoreId(order.getStoreId());
		orderView.setPlacementDate(order.getPlacementDate());
		orderView.setDeliveryDate(order.getDeliveryDate());
		orderView.setOrderState(order.getOrderState());
		orderView.setTaxes(order.getTaxes());
		orderView.setTotalAmount(order.getTotalAmount());
		if (order.hasOrderItems()) {
			for (OrderItem next : order.getOrderItems()) {
	    		OrderItemView nextOrderItemView = (OrderItemView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderItemView) {
		        	nextOrderItemView = dtoAssemblerRegistry.getDtoAssembler(OrderItemView.class).mapFromEntity(next);
		        }
	        	orderView.addOrderItems(nextOrderItemView);
	    	}
		}
        return orderView;
	}
	
	protected OrderView mapFromCustomerToOrderView(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (OrderView) MapperContextHolder.getContext().get(customer);
		}
		OrderView orderView = new OrderView();
    	MapperContextHolder.getContext().put(customer, orderView);
		orderView.setCustomerOid(customer.getOid());
		if (customer.hasOrders()) {
			for (Order next : customer.getOrders()) {
	    		OrderView nextOrderView = (OrderView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderView) {
		        	nextOrderView = dtoAssemblerRegistry.getDtoAssembler(OrderView.class).mapFromEntity(next);
		        }
	        	orderView.addOrders(nextOrderView);
	    	}
		}
        return orderView;
	}
	
	protected OrderView mapFromCustomerToOrderView(Customer customer, OrderView orderView) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return orderView;
		}		
    	MapperContextHolder.getContext().put(customer, orderView);
		orderView.setCustomerOid(customer.getOid());
		if (customer.hasOrders()) {
			for (Order next : customer.getOrders()) {
	    		OrderView nextOrderView = (OrderView) MapperContextHolder.getContext().get(next);
	    		if (null == nextOrderView) {
		        	nextOrderView = dtoAssemblerRegistry.getDtoAssembler(OrderView.class).mapFromEntity(next);
		        }
	        	orderView.addOrders(nextOrderView);
	    	}
		}
        return orderView;
	}
	
	

	private DtoAssembler<PrivateCustomerView> createDtoAssemblerPrivateCustomerView() {
		return new DtoAssembler<PrivateCustomerView>() {
		    public PrivateCustomerView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof PrivateCustomer) {
					PrivateCustomer privateCustomer = (PrivateCustomer) sourceEntity;
		    		PrivateCustomerView result = mapFromPrivateCustomerToPrivateCustomerView(privateCustomer);
		    		if (null != privateCustomer.getInvoiceAddress()) {
		    			result.setInvoiceAddressOid(privateCustomer.getInvoiceAddress().getOid());
		    		}
		    		if (null != privateCustomer.getDeliveryAddress()) {
		    			result.setDeliveryAddressOid(privateCustomer.getDeliveryAddress().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		PrivateCustomerView result = mapFromAddressToPrivateCustomerView(address);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public PrivateCustomerView mapFromEntity(Object sourceEntity, PrivateCustomerView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof PrivateCustomer) {
					PrivateCustomer privateCustomer = (PrivateCustomer) sourceEntity;
		    		mapFromPrivateCustomerToPrivateCustomerView(privateCustomer, targetDto);
		    		if (null != privateCustomer.getInvoiceAddress()) {
		    			targetDto.setInvoiceAddressOid(privateCustomer.getInvoiceAddress().getOid());
		    		}
		    		if (null != privateCustomer.getDeliveryAddress()) {
		    			targetDto.setDeliveryAddressOid(privateCustomer.getDeliveryAddress().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Address) {
					Address address = (Address) sourceEntity;
		    		mapFromAddressToPrivateCustomerView(address, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(PrivateCustomerView sourceDto, Class<T> target) {
				if (PrivateCustomerView.class.equals(target)) {
					PrivateCustomerView result = new PrivateCustomerView();
					mapFromPrivateCustomerViewToPrivateCustomerView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (PrivateCustomer.class.equals(target)) {
		    		return target.cast(mapFromPrivateCustomerViewToPrivateCustomer(sourceDto));
		    	}
				else if (Address.class.equals(target)) {
		    		return target.cast(mapFromPrivateCustomerViewToAddress(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(PrivateCustomerView sourceDto, Object targetObject) {
		    	if (targetObject instanceof PrivateCustomerView) {
					mapFromPrivateCustomerViewToPrivateCustomerView(sourceDto, (PrivateCustomerView) targetObject);
				}				
		    	else if (targetObject instanceof PrivateCustomer) {
		    		mapFromPrivateCustomerViewToPrivateCustomer(sourceDto, (PrivateCustomer)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Address) {
		    		mapFromPrivateCustomerViewToAddress(sourceDto, (Address)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromPrivateCustomerViewToPrivateCustomerView(PrivateCustomerView sourceDto, PrivateCustomerView privateCustomerView) {
   		privateCustomerView.setOid(sourceDto.getOid());
   		privateCustomerView.setVersion(sourceDto.getVersion());
   		privateCustomerView.setFirstName(sourceDto.getFirstName());
   		privateCustomerView.setLastName(sourceDto.getLastName());
   		privateCustomerView.setGender(sourceDto.getGender());
   		privateCustomerView.setEmailAddress(sourceDto.getEmailAddress());
   		privateCustomerView.setBirthDate(sourceDto.getBirthDate());
   		privateCustomerView.setTelefonNumber(sourceDto.getTelefonNumber());
   		privateCustomerView.setInvoiceAddressOid(sourceDto.getInvoiceAddressOid());
   		privateCustomerView.setDeliveryAddressOid(sourceDto.getDeliveryAddressOid());
   		privateCustomerView.setCcInfo(sourceDto.getCcInfo());
    }
    
    protected PrivateCustomer mapFromPrivateCustomerViewToPrivateCustomer(PrivateCustomerView sourceDto) {
    	return mapFromPrivateCustomerViewToPrivateCustomer(sourceDto, MapperContextHolder.createEntity(PrivateCustomer.class));
    }

    protected PrivateCustomer mapFromPrivateCustomerViewToPrivateCustomer(PrivateCustomerView sourceDto, PrivateCustomer privateCustomer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return privateCustomer;
    	}
	    MapperContextHolder.getContext().put(sourceDto, privateCustomer);
		if (sourceDto.getOid() != null) {
			privateCustomer.setOid(sourceDto.getOid());
		}
		privateCustomer.setVersion(sourceDto.getVersion());
		privateCustomer.setFirstName(sourceDto.getFirstName());
		privateCustomer.setLastName(sourceDto.getLastName());
		privateCustomer.setGender(sourceDto.getGender());
		privateCustomer.setEmailAddress(sourceDto.getEmailAddress());
		privateCustomer.setBirthDate(sourceDto.getBirthDate());
		privateCustomer.setTelefonNumber(sourceDto.getTelefonNumber());
		privateCustomer.setCcInfo(sourceDto.getCcInfo());
	    return privateCustomer;
	}
			
    protected Address mapFromPrivateCustomerViewToAddress(PrivateCustomerView sourceDto) {
    	return mapFromPrivateCustomerViewToAddress(sourceDto, MapperContextHolder.createEntity(Address.class));
    }

    protected Address mapFromPrivateCustomerViewToAddress(PrivateCustomerView sourceDto, Address address) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return address;
    	}
	    MapperContextHolder.getContext().put(sourceDto, address);
		if (sourceDto.getInvoiceAddressOid() != null  && MapperContextHolder.isContext("invoiceAddress")) {
			address.setOid(sourceDto.getInvoiceAddressOid());
		}
		if (sourceDto.getDeliveryAddressOid() != null  && MapperContextHolder.isContext("deliveryAddress")) {
			address.setOid(sourceDto.getDeliveryAddressOid());
		}
	    return address;
	}
	
	protected PrivateCustomerView mapFromPrivateCustomerToPrivateCustomerView(PrivateCustomer privateCustomer) {
		if (MapperContextHolder.getContext().containsKey(privateCustomer)) {
			return (PrivateCustomerView) MapperContextHolder.getContext().get(privateCustomer);
		}
		PrivateCustomerView privateCustomerView = new PrivateCustomerView();
    	MapperContextHolder.getContext().put(privateCustomer, privateCustomerView);
		privateCustomerView.setOid(privateCustomer.getOid());
		privateCustomerView.setVersion(privateCustomer.getVersion());
		privateCustomerView.setFirstName(privateCustomer.getFirstName());
		privateCustomerView.setLastName(privateCustomer.getLastName());
		privateCustomerView.setGender(privateCustomer.getGender());
		privateCustomerView.setEmailAddress(privateCustomer.getEmailAddress());
		privateCustomerView.setBirthDate(privateCustomer.getBirthDate());
		privateCustomerView.setTelefonNumber(privateCustomer.getTelefonNumber());
		privateCustomerView.setCcInfo(privateCustomer.getCcInfo());
        return privateCustomerView;
	}
	
	protected PrivateCustomerView mapFromPrivateCustomerToPrivateCustomerView(PrivateCustomer privateCustomer, PrivateCustomerView privateCustomerView) {
		if (MapperContextHolder.getContext().containsKey(privateCustomer)) {
			return privateCustomerView;
		}		
    	MapperContextHolder.getContext().put(privateCustomer, privateCustomerView);
		privateCustomerView.setOid(privateCustomer.getOid());
		privateCustomerView.setVersion(privateCustomer.getVersion());
		privateCustomerView.setFirstName(privateCustomer.getFirstName());
		privateCustomerView.setLastName(privateCustomer.getLastName());
		privateCustomerView.setGender(privateCustomer.getGender());
		privateCustomerView.setEmailAddress(privateCustomer.getEmailAddress());
		privateCustomerView.setBirthDate(privateCustomer.getBirthDate());
		privateCustomerView.setTelefonNumber(privateCustomer.getTelefonNumber());
		privateCustomerView.setCcInfo(privateCustomer.getCcInfo());
        return privateCustomerView;
	}
	
	protected PrivateCustomerView mapFromAddressToPrivateCustomerView(Address address) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return (PrivateCustomerView) MapperContextHolder.getContext().get(address);
		}
		PrivateCustomerView privateCustomerView = new PrivateCustomerView();
    	MapperContextHolder.getContext().put(address, privateCustomerView);
		privateCustomerView.setInvoiceAddressOid(address.getOid());
		privateCustomerView.setDeliveryAddressOid(address.getOid());
        return privateCustomerView;
	}
	
	protected PrivateCustomerView mapFromAddressToPrivateCustomerView(Address address, PrivateCustomerView privateCustomerView) {
		if (MapperContextHolder.getContext().containsKey(address)) {
			return privateCustomerView;
		}		
    	MapperContextHolder.getContext().put(address, privateCustomerView);
		privateCustomerView.setInvoiceAddressOid(address.getOid());
		privateCustomerView.setDeliveryAddressOid(address.getOid());
        return privateCustomerView;
	}
	
	

	private DtoAssembler<ProductIdView> createDtoAssemblerProductIdView() {
		return new DtoAssembler<ProductIdView>() {
		    public ProductIdView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		ProductIdView result = mapFromProductToProductIdView(product);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public ProductIdView mapFromEntity(Object sourceEntity, ProductIdView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		mapFromProductToProductIdView(product, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(ProductIdView sourceDto, Class<T> target) {
				if (ProductIdView.class.equals(target)) {
					ProductIdView result = new ProductIdView();
					mapFromProductIdViewToProductIdView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Product.class.equals(target)) {
		    		return target.cast(mapFromProductIdViewToProduct(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(ProductIdView sourceDto, Object targetObject) {
		    	if (targetObject instanceof ProductIdView) {
					mapFromProductIdViewToProductIdView(sourceDto, (ProductIdView) targetObject);
				}				
		    	else if (targetObject instanceof Product) {
		    		mapFromProductIdViewToProduct(sourceDto, (Product)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromProductIdViewToProductIdView(ProductIdView sourceDto, ProductIdView productIdView) {
   		productIdView.setOid(sourceDto.getOid());
    }
    
    protected Product mapFromProductIdViewToProduct(ProductIdView sourceDto) {
    	return mapFromProductIdViewToProduct(sourceDto, MapperContextHolder.createEntity(Product.class));
    }

    protected Product mapFromProductIdViewToProduct(ProductIdView sourceDto, Product product) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return product;
    	}
	    MapperContextHolder.getContext().put(sourceDto, product);
		if (sourceDto.getOid() != null) {
			product.setOid(sourceDto.getOid());
		}
	    return product;
	}
	
	protected ProductIdView mapFromProductToProductIdView(Product product) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return (ProductIdView) MapperContextHolder.getContext().get(product);
		}
		ProductIdView productIdView = new ProductIdView();
    	MapperContextHolder.getContext().put(product, productIdView);
		productIdView.setOid(product.getOid());
        return productIdView;
	}
	
	protected ProductIdView mapFromProductToProductIdView(Product product, ProductIdView productIdView) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return productIdView;
		}		
    	MapperContextHolder.getContext().put(product, productIdView);
		productIdView.setOid(product.getOid());
        return productIdView;
	}
	
	

	private DtoAssembler<ProductImageView> createDtoAssemblerProductImageView() {
		return new DtoAssembler<ProductImageView>() {
		    public ProductImageView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof ProductImage) {
					ProductImage productImage = (ProductImage) sourceEntity;
		    		ProductImageView result = mapFromProductImageToProductImageView(productImage);
		    		if (null != productImage.getProduct()) {
		    			result.setProductOid(productImage.getProduct().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		ProductImageView result = mapFromProductToProductImageView(product);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public ProductImageView mapFromEntity(Object sourceEntity, ProductImageView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof ProductImage) {
					ProductImage productImage = (ProductImage) sourceEntity;
		    		mapFromProductImageToProductImageView(productImage, targetDto);
		    		if (null != productImage.getProduct()) {
		    			targetDto.setProductOid(productImage.getProduct().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		mapFromProductToProductImageView(product, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(ProductImageView sourceDto, Class<T> target) {
				if (ProductImageView.class.equals(target)) {
					ProductImageView result = new ProductImageView();
					mapFromProductImageViewToProductImageView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (ProductImage.class.equals(target)) {
		    		return target.cast(mapFromProductImageViewToProductImage(sourceDto));
		    	}
				else if (Product.class.equals(target)) {
		    		return target.cast(mapFromProductImageViewToProduct(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(ProductImageView sourceDto, Object targetObject) {
		    	if (targetObject instanceof ProductImageView) {
					mapFromProductImageViewToProductImageView(sourceDto, (ProductImageView) targetObject);
				}				
		    	else if (targetObject instanceof ProductImage) {
		    		mapFromProductImageViewToProductImage(sourceDto, (ProductImage)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Product) {
		    		mapFromProductImageViewToProduct(sourceDto, (Product)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromProductImageViewToProductImageView(ProductImageView sourceDto, ProductImageView productImageView) {
   		productImageView.setOid(sourceDto.getOid());
   		productImageView.setVersion(sourceDto.getVersion());
   		productImageView.setName(sourceDto.getName());
   		productImageView.setFileName(sourceDto.getFileName());
   		productImageView.setSizeX(sourceDto.getSizeX());
   		productImageView.setSizeY(sourceDto.getSizeY());
   		productImageView.setProductOid(sourceDto.getProductOid());
    }
    
    protected ProductImage mapFromProductImageViewToProductImage(ProductImageView sourceDto) {
    	return mapFromProductImageViewToProductImage(sourceDto, MapperContextHolder.createEntity(ProductImage.class));
    }

    protected ProductImage mapFromProductImageViewToProductImage(ProductImageView sourceDto, ProductImage productImage) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return productImage;
    	}
	    MapperContextHolder.getContext().put(sourceDto, productImage);
		if (sourceDto.getOid() != null) {
			productImage.setOid(sourceDto.getOid());
		}
		productImage.setVersion(sourceDto.getVersion());
		productImage.setName(sourceDto.getName());
		productImage.setFileName(sourceDto.getFileName());
		productImage.setSizeX(sourceDto.getSizeX());
		productImage.setSizeY(sourceDto.getSizeY());
	    return productImage;
	}
			
    protected Product mapFromProductImageViewToProduct(ProductImageView sourceDto) {
    	return mapFromProductImageViewToProduct(sourceDto, MapperContextHolder.createEntity(Product.class));
    }

    protected Product mapFromProductImageViewToProduct(ProductImageView sourceDto, Product product) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return product;
    	}
	    MapperContextHolder.getContext().put(sourceDto, product);
		if (sourceDto.getProductOid() != null  && MapperContextHolder.isContext("product")) {
			product.setOid(sourceDto.getProductOid());
		}
	    return product;
	}
	
	protected ProductImageView mapFromProductImageToProductImageView(ProductImage productImage) {
		if (MapperContextHolder.getContext().containsKey(productImage)) {
			return (ProductImageView) MapperContextHolder.getContext().get(productImage);
		}
		ProductImageView productImageView = new ProductImageView();
    	MapperContextHolder.getContext().put(productImage, productImageView);
		productImageView.setOid(productImage.getOid());
		productImageView.setVersion(productImage.getVersion());
		productImageView.setName(productImage.getName());
		productImageView.setFileName(productImage.getFileName());
		productImageView.setSizeX(productImage.getSizeX());
		productImageView.setSizeY(productImage.getSizeY());
        return productImageView;
	}
	
	protected ProductImageView mapFromProductImageToProductImageView(ProductImage productImage, ProductImageView productImageView) {
		if (MapperContextHolder.getContext().containsKey(productImage)) {
			return productImageView;
		}		
    	MapperContextHolder.getContext().put(productImage, productImageView);
		productImageView.setOid(productImage.getOid());
		productImageView.setVersion(productImage.getVersion());
		productImageView.setName(productImage.getName());
		productImageView.setFileName(productImage.getFileName());
		productImageView.setSizeX(productImage.getSizeX());
		productImageView.setSizeY(productImage.getSizeY());
        return productImageView;
	}
	
	protected ProductImageView mapFromProductToProductImageView(Product product) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return (ProductImageView) MapperContextHolder.getContext().get(product);
		}
		ProductImageView productImageView = new ProductImageView();
    	MapperContextHolder.getContext().put(product, productImageView);
		productImageView.setProductOid(product.getOid());
        return productImageView;
	}
	
	protected ProductImageView mapFromProductToProductImageView(Product product, ProductImageView productImageView) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return productImageView;
		}		
    	MapperContextHolder.getContext().put(product, productImageView);
		productImageView.setProductOid(product.getOid());
        return productImageView;
	}
	
	

	private DtoAssembler<ProductView> createDtoAssemblerProductView() {
		return new DtoAssembler<ProductView>() {
		    public ProductView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		ProductView result = mapFromProductToProductView(product);
		    		if (null != product.getSupplier()) {
		    			result.setSupplierOid(product.getSupplier().getOid());
		    		}
		    		if (null != product.getProductImage()) {
		    			result.setProductImageOid(product.getProductImage().getOid());
		    		}
		    		if (null != product.getCert1()) {
		    			result.setCert1Oid(product.getCert1().getOid());
		    		}
		    		if (null != product.getCert2()) {
		    			result.setCert2Oid(product.getCert2().getOid());
		    		}
		    		if (null != product.getCert3()) {
		    			result.setCert3Oid(product.getCert3().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		ProductView result = mapFromSupplierToProductView(supplier);
		    		return result;
		    	} else if (sourceEntity instanceof ProductImage) {
					ProductImage productImage = (ProductImage) sourceEntity;
		    		ProductView result = mapFromProductImageToProductView(productImage);
		    		return result;
		    	} else if (sourceEntity instanceof Certificate) {
					Certificate certificate = (Certificate) sourceEntity;
		    		ProductView result = mapFromCertificateToProductView(certificate);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public ProductView mapFromEntity(Object sourceEntity, ProductView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Product) {
					Product product = (Product) sourceEntity;
		    		mapFromProductToProductView(product, targetDto);
		    		if (null != product.getSupplier()) {
		    			targetDto.setSupplierOid(product.getSupplier().getOid());
		    		}
		    		if (null != product.getProductImage()) {
		    			targetDto.setProductImageOid(product.getProductImage().getOid());
		    		}
		    		if (null != product.getCert1()) {
		    			targetDto.setCert1Oid(product.getCert1().getOid());
		    		}
		    		if (null != product.getCert2()) {
		    			targetDto.setCert2Oid(product.getCert2().getOid());
		    		}
		    		if (null != product.getCert3()) {
		    			targetDto.setCert3Oid(product.getCert3().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		mapFromSupplierToProductView(supplier, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof ProductImage) {
					ProductImage productImage = (ProductImage) sourceEntity;
		    		mapFromProductImageToProductView(productImage, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof Certificate) {
					Certificate certificate = (Certificate) sourceEntity;
		    		mapFromCertificateToProductView(certificate, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(ProductView sourceDto, Class<T> target) {
				if (ProductView.class.equals(target)) {
					ProductView result = new ProductView();
					mapFromProductViewToProductView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Product.class.equals(target)) {
		    		return target.cast(mapFromProductViewToProduct(sourceDto));
		    	}
				else if (Supplier.class.equals(target)) {
		    		return target.cast(mapFromProductViewToSupplier(sourceDto));
		    	}
				else if (ProductImage.class.equals(target)) {
		    		return target.cast(mapFromProductViewToProductImage(sourceDto));
		    	}
				else if (Certificate.class.equals(target)) {
		    		return target.cast(mapFromProductViewToCertificate(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(ProductView sourceDto, Object targetObject) {
		    	if (targetObject instanceof ProductView) {
					mapFromProductViewToProductView(sourceDto, (ProductView) targetObject);
				}				
		    	else if (targetObject instanceof Product) {
		    		mapFromProductViewToProduct(sourceDto, (Product)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Supplier) {
		    		mapFromProductViewToSupplier(sourceDto, (Supplier)targetObject);
		    	}		    	
		    	else if (targetObject instanceof ProductImage) {
		    		mapFromProductViewToProductImage(sourceDto, (ProductImage)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Certificate) {
		    		mapFromProductViewToCertificate(sourceDto, (Certificate)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromProductViewToProductView(ProductView sourceDto, ProductView productView) {
   		productView.setCert1(sourceDto.getCert1());
   		productView.setCert2(sourceDto.getCert2());
   		productView.setCert3(sourceDto.getCert3());
   		productView.setOid(sourceDto.getOid());
   		productView.setVersion(sourceDto.getVersion());
   		productView.setName(sourceDto.getName());
   		productView.setUnitPrice(sourceDto.getUnitPrice());
   		productView.setUnitOnStock(sourceDto.getUnitOnStock());
   		productView.setUnitOnOrder(sourceDto.getUnitOnOrder());
   		productView.setSupplierOid(sourceDto.getSupplierOid());
   		productView.setProductImageOid(sourceDto.getProductImageOid());
   		productView.setCert1Oid(sourceDto.getCert1Oid());
   		productView.setCert2Oid(sourceDto.getCert2Oid());
   		productView.setCert3Oid(sourceDto.getCert3Oid());
    }
    
    protected Product mapFromProductViewToProduct(ProductView sourceDto) {
    	return mapFromProductViewToProduct(sourceDto, MapperContextHolder.createEntity(Product.class));
    }

    protected Product mapFromProductViewToProduct(ProductView sourceDto, Product product) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return product;
    	}
	    MapperContextHolder.getContext().put(sourceDto, product);
		if (sourceDto.getOid() != null) {
			product.setOid(sourceDto.getOid());
		}
		product.setVersion(sourceDto.getVersion());
		product.setName(sourceDto.getName());
		product.setUnitPrice(sourceDto.getUnitPrice());
		product.setUnitOnStock(sourceDto.getUnitOnStock());
		product.setUnitOnOrder(sourceDto.getUnitOnOrder());
	    if (!MapperContextHolder.isContext("saveProduct") && !MapperContextHolder.isContext("updateProduct")) {
			if (null != sourceDto.getCert1()) {
		   		Certificate cert1 = (Certificate) dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapTo(sourceDto.getCert1(), Certificate.class);
				product.setCert1(cert1);
			}
			if (null != sourceDto.getCert2()) {
		   		Certificate cert2 = (Certificate) dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapTo(sourceDto.getCert2(), Certificate.class);
				product.setCert2(cert2);
			}
			if (null != sourceDto.getCert3()) {
		   		Certificate cert3 = (Certificate) dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapTo(sourceDto.getCert3(), Certificate.class);
				product.setCert3(cert3);
			}
	    }
	    return product;
	}
			
    protected Supplier mapFromProductViewToSupplier(ProductView sourceDto) {
    	return mapFromProductViewToSupplier(sourceDto, MapperContextHolder.createEntity(Supplier.class));
    }

    protected Supplier mapFromProductViewToSupplier(ProductView sourceDto, Supplier supplier) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return supplier;
    	}
	    MapperContextHolder.getContext().put(sourceDto, supplier);
		if (sourceDto.getSupplierOid() != null  && MapperContextHolder.isContext("supplier")) {
			supplier.setOid(sourceDto.getSupplierOid());
		}
	    return supplier;
	}
			
    protected ProductImage mapFromProductViewToProductImage(ProductView sourceDto) {
    	return mapFromProductViewToProductImage(sourceDto, MapperContextHolder.createEntity(ProductImage.class));
    }

    protected ProductImage mapFromProductViewToProductImage(ProductView sourceDto, ProductImage productImage) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return productImage;
    	}
	    MapperContextHolder.getContext().put(sourceDto, productImage);
		if (sourceDto.getProductImageOid() != null  && MapperContextHolder.isContext("productImage")) {
			productImage.setOid(sourceDto.getProductImageOid());
		}
	    return productImage;
	}
			
    protected Certificate mapFromProductViewToCertificate(ProductView sourceDto) {
    	return mapFromProductViewToCertificate(sourceDto, MapperContextHolder.createEntity(Certificate.class));
    }

    protected Certificate mapFromProductViewToCertificate(ProductView sourceDto, Certificate certificate) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return certificate;
    	}
	    MapperContextHolder.getContext().put(sourceDto, certificate);
		if (sourceDto.getCert1Oid() != null  && MapperContextHolder.isContext("cert1")) {
			certificate.setOid(sourceDto.getCert1Oid());
		}
		if (sourceDto.getCert2Oid() != null  && MapperContextHolder.isContext("cert2")) {
			certificate.setOid(sourceDto.getCert2Oid());
		}
		if (sourceDto.getCert3Oid() != null  && MapperContextHolder.isContext("cert3")) {
			certificate.setOid(sourceDto.getCert3Oid());
		}
	    return certificate;
	}
	
	protected ProductView mapFromProductToProductView(Product product) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return (ProductView) MapperContextHolder.getContext().get(product);
		}
		ProductView productView = new ProductView();
    	MapperContextHolder.getContext().put(product, productView);
		productView.setOid(product.getOid());
		productView.setVersion(product.getVersion());
		productView.setName(product.getName());
		productView.setUnitPrice(product.getUnitPrice());
		productView.setUnitOnStock(product.getUnitOnStock());
		productView.setUnitOnOrder(product.getUnitOnOrder());
        if (null != product.getCert1()) {
	        CertificateView cert1 = (CertificateView) MapperContextHolder.getContext().get(product.getCert1());
	        if (null == cert1) {
	        	cert1 = dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapFromEntity(product.getCert1());
	        }
        	productView.setCert1(cert1);
        }
        if (null != product.getCert2()) {
	        CertificateView cert2 = (CertificateView) MapperContextHolder.getContext().get(product.getCert2());
	        if (null == cert2) {
	        	cert2 = dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapFromEntity(product.getCert2());
	        }
        	productView.setCert2(cert2);
        }
        if (null != product.getCert3()) {
	        CertificateView cert3 = (CertificateView) MapperContextHolder.getContext().get(product.getCert3());
	        if (null == cert3) {
	        	cert3 = dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapFromEntity(product.getCert3());
	        }
        	productView.setCert3(cert3);
        }
        return productView;
	}
	
	protected ProductView mapFromProductToProductView(Product product, ProductView productView) {
		if (MapperContextHolder.getContext().containsKey(product)) {
			return productView;
		}		
    	MapperContextHolder.getContext().put(product, productView);
		productView.setOid(product.getOid());
		productView.setVersion(product.getVersion());
		productView.setName(product.getName());
		productView.setUnitPrice(product.getUnitPrice());
		productView.setUnitOnStock(product.getUnitOnStock());
		productView.setUnitOnOrder(product.getUnitOnOrder());
        if (null != product.getCert1()) {
	        CertificateView cert1 = (CertificateView) MapperContextHolder.getContext().get(product.getCert1());
	        if (null == cert1) {
	        	cert1 = dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapFromEntity(product.getCert1());
	        }
        	productView.setCert1(cert1);
        }
        if (null != product.getCert2()) {
	        CertificateView cert2 = (CertificateView) MapperContextHolder.getContext().get(product.getCert2());
	        if (null == cert2) {
	        	cert2 = dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapFromEntity(product.getCert2());
	        }
        	productView.setCert2(cert2);
        }
        if (null != product.getCert3()) {
	        CertificateView cert3 = (CertificateView) MapperContextHolder.getContext().get(product.getCert3());
	        if (null == cert3) {
	        	cert3 = dtoAssemblerRegistry.getDtoAssembler(CertificateView.class).mapFromEntity(product.getCert3());
	        }
        	productView.setCert3(cert3);
        }
        return productView;
	}
	
	protected ProductView mapFromSupplierToProductView(Supplier supplier) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return (ProductView) MapperContextHolder.getContext().get(supplier);
		}
		ProductView productView = new ProductView();
    	MapperContextHolder.getContext().put(supplier, productView);
		productView.setSupplierOid(supplier.getOid());
        return productView;
	}
	
	protected ProductView mapFromSupplierToProductView(Supplier supplier, ProductView productView) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return productView;
		}		
    	MapperContextHolder.getContext().put(supplier, productView);
		productView.setSupplierOid(supplier.getOid());
        return productView;
	}
	
	protected ProductView mapFromProductImageToProductView(ProductImage productImage) {
		if (MapperContextHolder.getContext().containsKey(productImage)) {
			return (ProductView) MapperContextHolder.getContext().get(productImage);
		}
		ProductView productView = new ProductView();
    	MapperContextHolder.getContext().put(productImage, productView);
		productView.setProductImageOid(productImage.getOid());
        return productView;
	}
	
	protected ProductView mapFromProductImageToProductView(ProductImage productImage, ProductView productView) {
		if (MapperContextHolder.getContext().containsKey(productImage)) {
			return productView;
		}		
    	MapperContextHolder.getContext().put(productImage, productView);
		productView.setProductImageOid(productImage.getOid());
        return productView;
	}
	
	protected ProductView mapFromCertificateToProductView(Certificate certificate) {
		if (MapperContextHolder.getContext().containsKey(certificate)) {
			return (ProductView) MapperContextHolder.getContext().get(certificate);
		}
		ProductView productView = new ProductView();
    	MapperContextHolder.getContext().put(certificate, productView);
		productView.setCert1Oid(certificate.getOid());
		productView.setCert2Oid(certificate.getOid());
		productView.setCert3Oid(certificate.getOid());
        return productView;
	}
	
	protected ProductView mapFromCertificateToProductView(Certificate certificate, ProductView productView) {
		if (MapperContextHolder.getContext().containsKey(certificate)) {
			return productView;
		}		
    	MapperContextHolder.getContext().put(certificate, productView);
		productView.setCert1Oid(certificate.getOid());
		productView.setCert2Oid(certificate.getOid());
		productView.setCert3Oid(certificate.getOid());
        return productView;
	}
	
	

	private DtoAssembler<RoleGroupView> createDtoAssemblerRoleGroupView() {
		return new DtoAssembler<RoleGroupView>() {
		    public RoleGroupView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof RoleGroup) {
					RoleGroup roleGroup = (RoleGroup) sourceEntity;
		    		RoleGroupView result = mapFromRoleGroupToRoleGroupView(roleGroup);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public RoleGroupView mapFromEntity(Object sourceEntity, RoleGroupView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof RoleGroup) {
					RoleGroup roleGroup = (RoleGroup) sourceEntity;
		    		mapFromRoleGroupToRoleGroupView(roleGroup, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(RoleGroupView sourceDto, Class<T> target) {
				if (RoleGroupView.class.equals(target)) {
					RoleGroupView result = new RoleGroupView();
					mapFromRoleGroupViewToRoleGroupView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (RoleGroup.class.equals(target)) {
		    		return target.cast(mapFromRoleGroupViewToRoleGroup(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(RoleGroupView sourceDto, Object targetObject) {
		    	if (targetObject instanceof RoleGroupView) {
					mapFromRoleGroupViewToRoleGroupView(sourceDto, (RoleGroupView) targetObject);
				}				
		    	else if (targetObject instanceof RoleGroup) {
		    		mapFromRoleGroupViewToRoleGroup(sourceDto, (RoleGroup)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromRoleGroupViewToRoleGroupView(RoleGroupView sourceDto, RoleGroupView roleGroupView) {
   		roleGroupView.setOid(sourceDto.getOid());
   		roleGroupView.setVersion(sourceDto.getVersion());
   		roleGroupView.setName(sourceDto.getName());
    }
    
    protected RoleGroup mapFromRoleGroupViewToRoleGroup(RoleGroupView sourceDto) {
    	return mapFromRoleGroupViewToRoleGroup(sourceDto, MapperContextHolder.createEntity(RoleGroup.class));
    }

    protected RoleGroup mapFromRoleGroupViewToRoleGroup(RoleGroupView sourceDto, RoleGroup roleGroup) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return roleGroup;
    	}
	    MapperContextHolder.getContext().put(sourceDto, roleGroup);
		if (sourceDto.getOid() != null) {
			roleGroup.setOid(sourceDto.getOid());
		}
		roleGroup.setVersion(sourceDto.getVersion());
		roleGroup.setName(sourceDto.getName());
	    return roleGroup;
	}
	
	protected RoleGroupView mapFromRoleGroupToRoleGroupView(RoleGroup roleGroup) {
		if (MapperContextHolder.getContext().containsKey(roleGroup)) {
			return (RoleGroupView) MapperContextHolder.getContext().get(roleGroup);
		}
		RoleGroupView roleGroupView = new RoleGroupView();
    	MapperContextHolder.getContext().put(roleGroup, roleGroupView);
		roleGroupView.setOid(roleGroup.getOid());
		roleGroupView.setVersion(roleGroup.getVersion());
		roleGroupView.setName(roleGroup.getName());
        return roleGroupView;
	}
	
	protected RoleGroupView mapFromRoleGroupToRoleGroupView(RoleGroup roleGroup, RoleGroupView roleGroupView) {
		if (MapperContextHolder.getContext().containsKey(roleGroup)) {
			return roleGroupView;
		}		
    	MapperContextHolder.getContext().put(roleGroup, roleGroupView);
		roleGroupView.setOid(roleGroup.getOid());
		roleGroupView.setVersion(roleGroup.getVersion());
		roleGroupView.setName(roleGroup.getName());
        return roleGroupView;
	}
	
	

	private DtoAssembler<RoleView> createDtoAssemblerRoleView() {
		return new DtoAssembler<RoleView>() {
		    public RoleView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Role) {
					Role role = (Role) sourceEntity;
		    		RoleView result = mapFromRoleToRoleView(role);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public RoleView mapFromEntity(Object sourceEntity, RoleView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Role) {
					Role role = (Role) sourceEntity;
		    		mapFromRoleToRoleView(role, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(RoleView sourceDto, Class<T> target) {
				if (RoleView.class.equals(target)) {
					RoleView result = new RoleView();
					mapFromRoleViewToRoleView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Role.class.equals(target)) {
		    		return target.cast(mapFromRoleViewToRole(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(RoleView sourceDto, Object targetObject) {
		    	if (targetObject instanceof RoleView) {
					mapFromRoleViewToRoleView(sourceDto, (RoleView) targetObject);
				}				
		    	else if (targetObject instanceof Role) {
		    		mapFromRoleViewToRole(sourceDto, (Role)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromRoleViewToRoleView(RoleView sourceDto, RoleView roleView) {
   		roleView.setOid(sourceDto.getOid());
   		roleView.setVersion(sourceDto.getVersion());
   		roleView.setName(sourceDto.getName());
    }
    
    protected Role mapFromRoleViewToRole(RoleView sourceDto) {
    	return mapFromRoleViewToRole(sourceDto, MapperContextHolder.createEntity(Role.class));
    }

    protected Role mapFromRoleViewToRole(RoleView sourceDto, Role role) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return role;
    	}
	    MapperContextHolder.getContext().put(sourceDto, role);
		if (sourceDto.getOid() != null) {
			role.setOid(sourceDto.getOid());
		}
		role.setVersion(sourceDto.getVersion());
		role.setName(sourceDto.getName());
	    return role;
	}
	
	protected RoleView mapFromRoleToRoleView(Role role) {
		if (MapperContextHolder.getContext().containsKey(role)) {
			return (RoleView) MapperContextHolder.getContext().get(role);
		}
		RoleView roleView = new RoleView();
    	MapperContextHolder.getContext().put(role, roleView);
		roleView.setOid(role.getOid());
		roleView.setVersion(role.getVersion());
		roleView.setName(role.getName());
        return roleView;
	}
	
	protected RoleView mapFromRoleToRoleView(Role role, RoleView roleView) {
		if (MapperContextHolder.getContext().containsKey(role)) {
			return roleView;
		}		
    	MapperContextHolder.getContext().put(role, roleView);
		roleView.setOid(role.getOid());
		roleView.setVersion(role.getVersion());
		roleView.setName(role.getName());
        return roleView;
	}
	
	

	private DtoAssembler<SingleOrderView> createDtoAssemblerSingleOrderView() {
		return new DtoAssembler<SingleOrderView>() {
		    public SingleOrderView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		SingleOrderView result = mapFromCustomerToSingleOrderView(customer);
		    		return result;
		    	} else if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		SingleOrderView result = mapFromOrderToSingleOrderView(order);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SingleOrderView mapFromEntity(Object sourceEntity, SingleOrderView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToSingleOrderView(customer, targetDto);
		    		return targetDto;
		    	} else if (sourceEntity instanceof Order) {
					Order order = (Order) sourceEntity;
		    		mapFromOrderToSingleOrderView(order, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SingleOrderView sourceDto, Class<T> target) {
				if (SingleOrderView.class.equals(target)) {
					SingleOrderView result = new SingleOrderView();
					mapFromSingleOrderViewToSingleOrderView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromSingleOrderViewToCustomer(sourceDto));
		    	}
				else if (Order.class.equals(target)) {
		    		return target.cast(mapFromSingleOrderViewToOrder(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SingleOrderView sourceDto, Object targetObject) {
		    	if (targetObject instanceof SingleOrderView) {
					mapFromSingleOrderViewToSingleOrderView(sourceDto, (SingleOrderView) targetObject);
				}				
		    	else if (targetObject instanceof Customer) {
		    		mapFromSingleOrderViewToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Order) {
		    		mapFromSingleOrderViewToOrder(sourceDto, (Order)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSingleOrderViewToSingleOrderView(SingleOrderView sourceDto, SingleOrderView singleOrderView) {
   		singleOrderView.setCustomerOid(sourceDto.getCustomerOid());
   		singleOrderView.setFirstName(sourceDto.getFirstName());
   		singleOrderView.setLastName(sourceDto.getLastName());
   		singleOrderView.setOrderOid(sourceDto.getOrderOid());
   		singleOrderView.setOrderNumber(sourceDto.getOrderNumber());
   		singleOrderView.setDeliveryDate(sourceDto.getDeliveryDate());
   		singleOrderView.setStoreId(sourceDto.getStoreId());
    }
    
    protected Customer mapFromSingleOrderViewToCustomer(SingleOrderView sourceDto) {
    	return mapFromSingleOrderViewToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromSingleOrderViewToCustomer(SingleOrderView sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    MapperContextHolder.getContext().put(sourceDto, customer);
		if (sourceDto.getCustomerOid() != null) {
			customer.setOid(sourceDto.getCustomerOid());
		}
		customer.setFirstName(sourceDto.getFirstName());
		customer.setLastName(sourceDto.getLastName());
	    return customer;
	}
			
    protected Order mapFromSingleOrderViewToOrder(SingleOrderView sourceDto) {
    	return mapFromSingleOrderViewToOrder(sourceDto, MapperContextHolder.createEntity(Order.class));
    }

    protected Order mapFromSingleOrderViewToOrder(SingleOrderView sourceDto, Order order) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return order;
    	}
	    MapperContextHolder.getContext().put(sourceDto, order);
		if (sourceDto.getOrderOid() != null) {
			order.setOid(sourceDto.getOrderOid());
		}
		order.setOrderNumber(sourceDto.getOrderNumber());
		order.setDeliveryDate(sourceDto.getDeliveryDate());
		order.setStoreId(sourceDto.getStoreId());
	    return order;
	}
	
	protected SingleOrderView mapFromCustomerToSingleOrderView(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (SingleOrderView) MapperContextHolder.getContext().get(customer);
		}
		SingleOrderView singleOrderView = new SingleOrderView();
    	MapperContextHolder.getContext().put(customer, singleOrderView);
		singleOrderView.setCustomerOid(customer.getOid());
		singleOrderView.setFirstName(customer.getFirstName());
		singleOrderView.setLastName(customer.getLastName());
        return singleOrderView;
	}
	
	protected SingleOrderView mapFromCustomerToSingleOrderView(Customer customer, SingleOrderView singleOrderView) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return singleOrderView;
		}		
    	MapperContextHolder.getContext().put(customer, singleOrderView);
		singleOrderView.setCustomerOid(customer.getOid());
		singleOrderView.setFirstName(customer.getFirstName());
		singleOrderView.setLastName(customer.getLastName());
        return singleOrderView;
	}
	
	protected SingleOrderView mapFromOrderToSingleOrderView(Order order) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return (SingleOrderView) MapperContextHolder.getContext().get(order);
		}
		SingleOrderView singleOrderView = new SingleOrderView();
    	MapperContextHolder.getContext().put(order, singleOrderView);
		singleOrderView.setOrderOid(order.getOid());
		singleOrderView.setOrderNumber(order.getOrderNumber());
		singleOrderView.setDeliveryDate(order.getDeliveryDate());
		singleOrderView.setStoreId(order.getStoreId());
        return singleOrderView;
	}
	
	protected SingleOrderView mapFromOrderToSingleOrderView(Order order, SingleOrderView singleOrderView) {
		if (MapperContextHolder.getContext().containsKey(order)) {
			return singleOrderView;
		}		
    	MapperContextHolder.getContext().put(order, singleOrderView);
		singleOrderView.setOrderOid(order.getOid());
		singleOrderView.setOrderNumber(order.getOrderNumber());
		singleOrderView.setDeliveryDate(order.getDeliveryDate());
		singleOrderView.setStoreId(order.getStoreId());
        return singleOrderView;
	}
	
	

	private DtoAssembler<SingleRoleView> createDtoAssemblerSingleRoleView() {
		return new DtoAssembler<SingleRoleView>() {
		    public SingleRoleView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof SingleRole) {
					SingleRole singleRole = (SingleRole) sourceEntity;
		    		SingleRoleView result = mapFromSingleRoleToSingleRoleView(singleRole);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SingleRoleView mapFromEntity(Object sourceEntity, SingleRoleView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof SingleRole) {
					SingleRole singleRole = (SingleRole) sourceEntity;
		    		mapFromSingleRoleToSingleRoleView(singleRole, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SingleRoleView sourceDto, Class<T> target) {
				if (SingleRoleView.class.equals(target)) {
					SingleRoleView result = new SingleRoleView();
					mapFromSingleRoleViewToSingleRoleView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (SingleRole.class.equals(target)) {
		    		return target.cast(mapFromSingleRoleViewToSingleRole(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SingleRoleView sourceDto, Object targetObject) {
		    	if (targetObject instanceof SingleRoleView) {
					mapFromSingleRoleViewToSingleRoleView(sourceDto, (SingleRoleView) targetObject);
				}				
		    	else if (targetObject instanceof SingleRole) {
		    		mapFromSingleRoleViewToSingleRole(sourceDto, (SingleRole)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSingleRoleViewToSingleRoleView(SingleRoleView sourceDto, SingleRoleView singleRoleView) {
   		singleRoleView.setOid(sourceDto.getOid());
   		singleRoleView.setVersion(sourceDto.getVersion());
   		singleRoleView.setName(sourceDto.getName());
   		singleRoleView.setRoleValue(sourceDto.getRoleValue());
    }
    
    protected SingleRole mapFromSingleRoleViewToSingleRole(SingleRoleView sourceDto) {
    	return mapFromSingleRoleViewToSingleRole(sourceDto, MapperContextHolder.createEntity(SingleRole.class));
    }

    protected SingleRole mapFromSingleRoleViewToSingleRole(SingleRoleView sourceDto, SingleRole singleRole) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return singleRole;
    	}
	    MapperContextHolder.getContext().put(sourceDto, singleRole);
		if (sourceDto.getOid() != null) {
			singleRole.setOid(sourceDto.getOid());
		}
		singleRole.setVersion(sourceDto.getVersion());
		singleRole.setName(sourceDto.getName());
		singleRole.setRoleValue(sourceDto.getRoleValue());
	    return singleRole;
	}
	
	protected SingleRoleView mapFromSingleRoleToSingleRoleView(SingleRole singleRole) {
		if (MapperContextHolder.getContext().containsKey(singleRole)) {
			return (SingleRoleView) MapperContextHolder.getContext().get(singleRole);
		}
		SingleRoleView singleRoleView = new SingleRoleView();
    	MapperContextHolder.getContext().put(singleRole, singleRoleView);
		singleRoleView.setOid(singleRole.getOid());
		singleRoleView.setVersion(singleRole.getVersion());
		singleRoleView.setName(singleRole.getName());
		singleRoleView.setRoleValue(singleRole.getRoleValue());
        return singleRoleView;
	}
	
	protected SingleRoleView mapFromSingleRoleToSingleRoleView(SingleRole singleRole, SingleRoleView singleRoleView) {
		if (MapperContextHolder.getContext().containsKey(singleRole)) {
			return singleRoleView;
		}		
    	MapperContextHolder.getContext().put(singleRole, singleRoleView);
		singleRoleView.setOid(singleRole.getOid());
		singleRoleView.setVersion(singleRole.getVersion());
		singleRoleView.setName(singleRole.getName());
		singleRoleView.setRoleValue(singleRole.getRoleValue());
        return singleRoleView;
	}
	
	

	private DtoAssembler<SpCustomerInputParameter> createDtoAssemblerSpCustomerInputParameter() {
		return new DtoAssembler<SpCustomerInputParameter>() {
		    public SpCustomerInputParameter mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SpCustomerInputParameter mapFromEntity(Object sourceEntity, SpCustomerInputParameter targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SpCustomerInputParameter sourceDto, Class<T> target) {
				if (SpCustomerInputParameter.class.equals(target)) {
					SpCustomerInputParameter result = new SpCustomerInputParameter();
					mapFromSpCustomerInputParameterToSpCustomerInputParameter(sourceDto, result);
					return target.cast(result);
				}		    	
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SpCustomerInputParameter sourceDto, Object targetObject) {
		    	if (targetObject instanceof SpCustomerInputParameter) {
					mapFromSpCustomerInputParameterToSpCustomerInputParameter(sourceDto, (SpCustomerInputParameter) targetObject);
				}				
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSpCustomerInputParameterToSpCustomerInputParameter(SpCustomerInputParameter sourceDto, SpCustomerInputParameter spCustomerInputParameter) {
    }
	
	

	private DtoAssembler<SpOutCustomer> createDtoAssemblerSpOutCustomer() {
		return new DtoAssembler<SpOutCustomer>() {
		    public SpOutCustomer mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SpOutCustomer mapFromEntity(Object sourceEntity, SpOutCustomer targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SpOutCustomer sourceDto, Class<T> target) {
				if (SpOutCustomer.class.equals(target)) {
					SpOutCustomer result = new SpOutCustomer();
					mapFromSpOutCustomerToSpOutCustomer(sourceDto, result);
					return target.cast(result);
				}		    	
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SpOutCustomer sourceDto, Object targetObject) {
		    	if (targetObject instanceof SpOutCustomer) {
					mapFromSpOutCustomerToSpOutCustomer(sourceDto, (SpOutCustomer) targetObject);
				}				
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSpOutCustomerToSpOutCustomer(SpOutCustomer sourceDto, SpOutCustomer spOutCustomer) {
    }
	
	

	private DtoAssembler<SpReportResultDto> createDtoAssemblerSpReportResultDto() {
		return new DtoAssembler<SpReportResultDto>() {
		    public SpReportResultDto mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SpReportResultDto mapFromEntity(Object sourceEntity, SpReportResultDto targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SpReportResultDto sourceDto, Class<T> target) {
				if (SpReportResultDto.class.equals(target)) {
					SpReportResultDto result = new SpReportResultDto();
					mapFromSpReportResultDtoToSpReportResultDto(sourceDto, result);
					return target.cast(result);
				}		    	
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SpReportResultDto sourceDto, Object targetObject) {
		    	if (targetObject instanceof SpReportResultDto) {
					mapFromSpReportResultDtoToSpReportResultDto(sourceDto, (SpReportResultDto) targetObject);
				}				
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSpReportResultDtoToSpReportResultDto(SpReportResultDto sourceDto, SpReportResultDto spReportResultDto) {
    }
	
	

	private DtoAssembler<SpResultDtoWithNestedCollection> createDtoAssemblerSpResultDtoWithNestedCollection() {
		return new DtoAssembler<SpResultDtoWithNestedCollection>() {
		    public SpResultDtoWithNestedCollection mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SpResultDtoWithNestedCollection mapFromEntity(Object sourceEntity, SpResultDtoWithNestedCollection targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SpResultDtoWithNestedCollection sourceDto, Class<T> target) {
				if (SpResultDtoWithNestedCollection.class.equals(target)) {
					SpResultDtoWithNestedCollection result = new SpResultDtoWithNestedCollection();
					mapFromSpResultDtoWithNestedCollectionToSpResultDtoWithNestedCollection(sourceDto, result);
					return target.cast(result);
				}		    	
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SpResultDtoWithNestedCollection sourceDto, Object targetObject) {
		    	if (targetObject instanceof SpResultDtoWithNestedCollection) {
					mapFromSpResultDtoWithNestedCollectionToSpResultDtoWithNestedCollection(sourceDto, (SpResultDtoWithNestedCollection) targetObject);
				}				
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSpResultDtoWithNestedCollectionToSpResultDtoWithNestedCollection(SpResultDtoWithNestedCollection sourceDto, SpResultDtoWithNestedCollection spResultDtoWithNestedCollection) {
    }
	
	

	private DtoAssembler<SpResultDtoWithNestedStructure> createDtoAssemblerSpResultDtoWithNestedStructure() {
		return new DtoAssembler<SpResultDtoWithNestedStructure>() {
		    public SpResultDtoWithNestedStructure mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SpResultDtoWithNestedStructure mapFromEntity(Object sourceEntity, SpResultDtoWithNestedStructure targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SpResultDtoWithNestedStructure sourceDto, Class<T> target) {
				if (SpResultDtoWithNestedStructure.class.equals(target)) {
					SpResultDtoWithNestedStructure result = new SpResultDtoWithNestedStructure();
					mapFromSpResultDtoWithNestedStructureToSpResultDtoWithNestedStructure(sourceDto, result);
					return target.cast(result);
				}		    	
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SpResultDtoWithNestedStructure sourceDto, Object targetObject) {
		    	if (targetObject instanceof SpResultDtoWithNestedStructure) {
					mapFromSpResultDtoWithNestedStructureToSpResultDtoWithNestedStructure(sourceDto, (SpResultDtoWithNestedStructure) targetObject);
				}				
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSpResultDtoWithNestedStructureToSpResultDtoWithNestedStructure(SpResultDtoWithNestedStructure sourceDto, SpResultDtoWithNestedStructure spResultDtoWithNestedStructure) {
    }
	
	

	private DtoAssembler<SpResultDtoWithNestedStructures> createDtoAssemblerSpResultDtoWithNestedStructures() {
		return new DtoAssembler<SpResultDtoWithNestedStructures>() {
		    public SpResultDtoWithNestedStructures mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SpResultDtoWithNestedStructures mapFromEntity(Object sourceEntity, SpResultDtoWithNestedStructures targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");

				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SpResultDtoWithNestedStructures sourceDto, Class<T> target) {
				if (SpResultDtoWithNestedStructures.class.equals(target)) {
					SpResultDtoWithNestedStructures result = new SpResultDtoWithNestedStructures();
					mapFromSpResultDtoWithNestedStructuresToSpResultDtoWithNestedStructures(sourceDto, result);
					return target.cast(result);
				}		    	
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SpResultDtoWithNestedStructures sourceDto, Object targetObject) {
		    	if (targetObject instanceof SpResultDtoWithNestedStructures) {
					mapFromSpResultDtoWithNestedStructuresToSpResultDtoWithNestedStructures(sourceDto, (SpResultDtoWithNestedStructures) targetObject);
				}				
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSpResultDtoWithNestedStructuresToSpResultDtoWithNestedStructures(SpResultDtoWithNestedStructures sourceDto, SpResultDtoWithNestedStructures spResultDtoWithNestedStructures) {
    }
	
	

	private DtoAssembler<SpTestView> createDtoAssemblerSpTestView() {
		return new DtoAssembler<SpTestView>() {
		    public SpTestView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof SpTest) {
					SpTest spTest = (SpTest) sourceEntity;
		    		SpTestView result = mapFromSpTestToSpTestView(spTest);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SpTestView mapFromEntity(Object sourceEntity, SpTestView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof SpTest) {
					SpTest spTest = (SpTest) sourceEntity;
		    		mapFromSpTestToSpTestView(spTest, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SpTestView sourceDto, Class<T> target) {
				if (SpTestView.class.equals(target)) {
					SpTestView result = new SpTestView();
					mapFromSpTestViewToSpTestView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (SpTest.class.equals(target)) {
		    		return target.cast(mapFromSpTestViewToSpTest(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SpTestView sourceDto, Object targetObject) {
		    	if (targetObject instanceof SpTestView) {
					mapFromSpTestViewToSpTestView(sourceDto, (SpTestView) targetObject);
				}				
		    	else if (targetObject instanceof SpTest) {
		    		mapFromSpTestViewToSpTest(sourceDto, (SpTest)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSpTestViewToSpTestView(SpTestView sourceDto, SpTestView spTestView) {
   		spTestView.setOid(sourceDto.getOid());
    }
    
    protected SpTest mapFromSpTestViewToSpTest(SpTestView sourceDto) {
    	return mapFromSpTestViewToSpTest(sourceDto, MapperContextHolder.createEntity(SpTest.class));
    }

    protected SpTest mapFromSpTestViewToSpTest(SpTestView sourceDto, SpTest spTest) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return spTest;
    	}
	    MapperContextHolder.getContext().put(sourceDto, spTest);
		if (sourceDto.getOid() != null) {
			spTest.setOid(sourceDto.getOid());
		}
	    return spTest;
	}
	
	protected SpTestView mapFromSpTestToSpTestView(SpTest spTest) {
		if (MapperContextHolder.getContext().containsKey(spTest)) {
			return (SpTestView) MapperContextHolder.getContext().get(spTest);
		}
		SpTestView spTestView = new SpTestView();
    	MapperContextHolder.getContext().put(spTest, spTestView);
		spTestView.setOid(spTest.getOid());
        return spTestView;
	}
	
	protected SpTestView mapFromSpTestToSpTestView(SpTest spTest, SpTestView spTestView) {
		if (MapperContextHolder.getContext().containsKey(spTest)) {
			return spTestView;
		}		
    	MapperContextHolder.getContext().put(spTest, spTestView);
		spTestView.setOid(spTest.getOid());
        return spTestView;
	}
	
	

	private DtoAssembler<SupplierNameView> createDtoAssemblerSupplierNameView() {
		return new DtoAssembler<SupplierNameView>() {
		    public SupplierNameView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		SupplierNameView result = mapFromSupplierToSupplierNameView(supplier);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SupplierNameView mapFromEntity(Object sourceEntity, SupplierNameView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		mapFromSupplierToSupplierNameView(supplier, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SupplierNameView sourceDto, Class<T> target) {
				if (SupplierNameView.class.equals(target)) {
					SupplierNameView result = new SupplierNameView();
					mapFromSupplierNameViewToSupplierNameView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Supplier.class.equals(target)) {
		    		return target.cast(mapFromSupplierNameViewToSupplier(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SupplierNameView sourceDto, Object targetObject) {
		    	if (targetObject instanceof SupplierNameView) {
					mapFromSupplierNameViewToSupplierNameView(sourceDto, (SupplierNameView) targetObject);
				}				
		    	else if (targetObject instanceof Supplier) {
		    		mapFromSupplierNameViewToSupplier(sourceDto, (Supplier)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSupplierNameViewToSupplierNameView(SupplierNameView sourceDto, SupplierNameView supplierNameView) {
   		supplierNameView.setName(sourceDto.getName());
    }
    
    protected Supplier mapFromSupplierNameViewToSupplier(SupplierNameView sourceDto) {
    	return mapFromSupplierNameViewToSupplier(sourceDto, MapperContextHolder.createEntity(Supplier.class));
    }

    protected Supplier mapFromSupplierNameViewToSupplier(SupplierNameView sourceDto, Supplier supplier) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return supplier;
    	}
	    MapperContextHolder.getContext().put(sourceDto, supplier);
		supplier.setCompanyName(sourceDto.getName());
	    return supplier;
	}
	
	protected SupplierNameView mapFromSupplierToSupplierNameView(Supplier supplier) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return (SupplierNameView) MapperContextHolder.getContext().get(supplier);
		}
		SupplierNameView supplierNameView = new SupplierNameView();
    	MapperContextHolder.getContext().put(supplier, supplierNameView);
		supplierNameView.setName(supplier.getCompanyName());
        return supplierNameView;
	}
	
	protected SupplierNameView mapFromSupplierToSupplierNameView(Supplier supplier, SupplierNameView supplierNameView) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return supplierNameView;
		}		
    	MapperContextHolder.getContext().put(supplier, supplierNameView);
		supplierNameView.setName(supplier.getCompanyName());
        return supplierNameView;
	}
	
	

	private DtoAssembler<SupplierNameView2> createDtoAssemblerSupplierNameView2() {
		return new DtoAssembler<SupplierNameView2>() {
		    public SupplierNameView2 mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		SupplierNameView2 result = mapFromSupplierToSupplierNameView2(supplier);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SupplierNameView2 mapFromEntity(Object sourceEntity, SupplierNameView2 targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		mapFromSupplierToSupplierNameView2(supplier, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SupplierNameView2 sourceDto, Class<T> target) {
				if (SupplierNameView2.class.equals(target)) {
					SupplierNameView2 result = new SupplierNameView2();
					mapFromSupplierNameView2ToSupplierNameView2(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Supplier.class.equals(target)) {
		    		return target.cast(mapFromSupplierNameView2ToSupplier(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SupplierNameView2 sourceDto, Object targetObject) {
		    	if (targetObject instanceof SupplierNameView2) {
					mapFromSupplierNameView2ToSupplierNameView2(sourceDto, (SupplierNameView2) targetObject);
				}				
		    	else if (targetObject instanceof Supplier) {
		    		mapFromSupplierNameView2ToSupplier(sourceDto, (Supplier)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSupplierNameView2ToSupplierNameView2(SupplierNameView2 sourceDto, SupplierNameView2 supplierNameView2) {
   		supplierNameView2.setCompanyName(sourceDto.getCompanyName());
    }
    
    protected Supplier mapFromSupplierNameView2ToSupplier(SupplierNameView2 sourceDto) {
    	return mapFromSupplierNameView2ToSupplier(sourceDto, MapperContextHolder.createEntity(Supplier.class));
    }

    protected Supplier mapFromSupplierNameView2ToSupplier(SupplierNameView2 sourceDto, Supplier supplier) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return supplier;
    	}
	    MapperContextHolder.getContext().put(sourceDto, supplier);
		supplier.setCompanyName(sourceDto.getCompanyName());
	    return supplier;
	}
	
	protected SupplierNameView2 mapFromSupplierToSupplierNameView2(Supplier supplier) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return (SupplierNameView2) MapperContextHolder.getContext().get(supplier);
		}
		SupplierNameView2 supplierNameView2 = new SupplierNameView2();
    	MapperContextHolder.getContext().put(supplier, supplierNameView2);
		supplierNameView2.setCompanyName(supplier.getCompanyName());
        return supplierNameView2;
	}
	
	protected SupplierNameView2 mapFromSupplierToSupplierNameView2(Supplier supplier, SupplierNameView2 supplierNameView2) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return supplierNameView2;
		}		
    	MapperContextHolder.getContext().put(supplier, supplierNameView2);
		supplierNameView2.setCompanyName(supplier.getCompanyName());
        return supplierNameView2;
	}
	
	

	private DtoAssembler<SupplierView> createDtoAssemblerSupplierView() {
		return new DtoAssembler<SupplierView>() {
		    public SupplierView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		SupplierView result = mapFromSupplierToSupplierView(supplier);
		    		if (null != supplier.getCustomer()) {
		    			result.setCustomerOid(supplier.getCustomer().getOid());
		    		}
		    		return result;
		    	} else if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		SupplierView result = mapFromCustomerToSupplierView(customer);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public SupplierView mapFromEntity(Object sourceEntity, SupplierView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof Supplier) {
					Supplier supplier = (Supplier) sourceEntity;
		    		mapFromSupplierToSupplierView(supplier, targetDto);
		    		if (null != supplier.getCustomer()) {
		    			targetDto.setCustomerOid(supplier.getCustomer().getOid());
		    		}
		    		return targetDto;
		    	} else if (sourceEntity instanceof Customer) {
					Customer customer = (Customer) sourceEntity;
		    		mapFromCustomerToSupplierView(customer, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(SupplierView sourceDto, Class<T> target) {
				if (SupplierView.class.equals(target)) {
					SupplierView result = new SupplierView();
					mapFromSupplierViewToSupplierView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (Supplier.class.equals(target)) {
		    		return target.cast(mapFromSupplierViewToSupplier(sourceDto));
		    	}
				else if (Customer.class.equals(target)) {
		    		return target.cast(mapFromSupplierViewToCustomer(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(SupplierView sourceDto, Object targetObject) {
		    	if (targetObject instanceof SupplierView) {
					mapFromSupplierViewToSupplierView(sourceDto, (SupplierView) targetObject);
				}				
		    	else if (targetObject instanceof Supplier) {
		    		mapFromSupplierViewToSupplier(sourceDto, (Supplier)targetObject);
		    	}		    	
		    	else if (targetObject instanceof Customer) {
		    		mapFromSupplierViewToCustomer(sourceDto, (Customer)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromSupplierViewToSupplierView(SupplierView sourceDto, SupplierView supplierView) {
   		supplierView.setOid(sourceDto.getOid());
   		supplierView.setVersion(sourceDto.getVersion());
   		supplierView.setCompanyName(sourceDto.getCompanyName());
   		supplierView.setAddress(sourceDto.getAddress());
   		supplierView.setCustomerOid(sourceDto.getCustomerOid());
   		supplierView.setContact(sourceDto.getContact());
   		supplierView.setType3(sourceDto.getType3());
   		supplierView.setCode3(sourceDto.getCode3());
   		supplierView.setCode(sourceDto.getCode());
    }
    
    protected Supplier mapFromSupplierViewToSupplier(SupplierView sourceDto) {
    	return mapFromSupplierViewToSupplier(sourceDto, MapperContextHolder.createEntity(Supplier.class));
    }

    protected Supplier mapFromSupplierViewToSupplier(SupplierView sourceDto, Supplier supplier) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return supplier;
    	}
	    MapperContextHolder.getContext().put(sourceDto, supplier);
		if (sourceDto.getOid() != null) {
			supplier.setOid(sourceDto.getOid());
		}
		supplier.setVersion(sourceDto.getVersion());
		supplier.setCompanyName(sourceDto.getCompanyName());
		supplier.setAddress(sourceDto.getAddress());
		supplier.setContact(sourceDto.getContact());
		supplier.setType3(sourceDto.getType3());
		supplier.setCode3(sourceDto.getCode3());
		supplier.setCode(sourceDto.getCode());
	    return supplier;
	}
			
    protected Customer mapFromSupplierViewToCustomer(SupplierView sourceDto) {
    	return mapFromSupplierViewToCustomer(sourceDto, MapperContextHolder.createEntity(Customer.class));
    }

    protected Customer mapFromSupplierViewToCustomer(SupplierView sourceDto, Customer customer) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return customer;
    	}
	    MapperContextHolder.getContext().put(sourceDto, customer);
		if (sourceDto.getCustomerOid() != null  && MapperContextHolder.isContext("customer")) {
			customer.setOid(sourceDto.getCustomerOid());
		}
	    return customer;
	}
	
	protected SupplierView mapFromSupplierToSupplierView(Supplier supplier) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return (SupplierView) MapperContextHolder.getContext().get(supplier);
		}
		SupplierView supplierView = new SupplierView();
    	MapperContextHolder.getContext().put(supplier, supplierView);
		supplierView.setOid(supplier.getOid());
		supplierView.setVersion(supplier.getVersion());
		supplierView.setCompanyName(supplier.getCompanyName());
		supplierView.setAddress(supplier.getAddress());
		supplierView.setContact(supplier.getContact());
		supplierView.setType3(supplier.getType3());
		supplierView.setCode3(supplier.getCode3());
		supplierView.setCode(supplier.getCode());
        return supplierView;
	}
	
	protected SupplierView mapFromSupplierToSupplierView(Supplier supplier, SupplierView supplierView) {
		if (MapperContextHolder.getContext().containsKey(supplier)) {
			return supplierView;
		}		
    	MapperContextHolder.getContext().put(supplier, supplierView);
		supplierView.setOid(supplier.getOid());
		supplierView.setVersion(supplier.getVersion());
		supplierView.setCompanyName(supplier.getCompanyName());
		supplierView.setAddress(supplier.getAddress());
		supplierView.setContact(supplier.getContact());
		supplierView.setType3(supplier.getType3());
		supplierView.setCode3(supplier.getCode3());
		supplierView.setCode(supplier.getCode());
        return supplierView;
	}
	
	protected SupplierView mapFromCustomerToSupplierView(Customer customer) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return (SupplierView) MapperContextHolder.getContext().get(customer);
		}
		SupplierView supplierView = new SupplierView();
    	MapperContextHolder.getContext().put(customer, supplierView);
		supplierView.setCustomerOid(customer.getOid());
        return supplierView;
	}
	
	protected SupplierView mapFromCustomerToSupplierView(Customer customer, SupplierView supplierView) {
		if (MapperContextHolder.getContext().containsKey(customer)) {
			return supplierView;
		}		
    	MapperContextHolder.getContext().put(customer, supplierView);
		supplierView.setCustomerOid(customer.getOid());
        return supplierView;
	}
	
	

	private DtoAssembler<TestEntityView> createDtoAssemblerTestEntityView() {
		return new DtoAssembler<TestEntityView>() {
		    public TestEntityView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof TestEntity) {
					TestEntity testEntity = (TestEntity) sourceEntity;
		    		TestEntityView result = mapFromTestEntityToTestEntityView(testEntity);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public TestEntityView mapFromEntity(Object sourceEntity, TestEntityView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof TestEntity) {
					TestEntity testEntity = (TestEntity) sourceEntity;
		    		mapFromTestEntityToTestEntityView(testEntity, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(TestEntityView sourceDto, Class<T> target) {
				if (TestEntityView.class.equals(target)) {
					TestEntityView result = new TestEntityView();
					mapFromTestEntityViewToTestEntityView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (TestEntity.class.equals(target)) {
		    		return target.cast(mapFromTestEntityViewToTestEntity(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(TestEntityView sourceDto, Object targetObject) {
		    	if (targetObject instanceof TestEntityView) {
					mapFromTestEntityViewToTestEntityView(sourceDto, (TestEntityView) targetObject);
				}				
		    	else if (targetObject instanceof TestEntity) {
		    		mapFromTestEntityViewToTestEntity(sourceDto, (TestEntity)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromTestEntityViewToTestEntityView(TestEntityView sourceDto, TestEntityView testEntityView) {
   		testEntityView.setTestString2(sourceDto.getTestString2());
   		testEntityView.setTestInteger(sourceDto.getTestInteger());
   		testEntityView.setTestLong(sourceDto.getTestLong());
   		testEntityView.setTestBoolean(sourceDto.getTestBoolean());
   		testEntityView.setTestDouble(sourceDto.getTestDouble());
   		testEntityView.setTestFloat(sourceDto.getTestFloat());
   		testEntityView.setTestString1(sourceDto.getTestString1());
   		testEntityView.setBigNum(sourceDto.getBigNum());
   		testEntityView.setBigNum10(sourceDto.getBigNum10());
   		testEntityView.setBigNum10_2(sourceDto.getBigNum10_2());
   		testEntityView.setFloat5_2(sourceDto.getFloat5_2());
   		testEntityView.setDouble3_3(sourceDto.getDouble3_3());
   		testEntityView.setLongNumber(sourceDto.getLongNumber());
   		testEntityView.setIntNumber(sourceDto.getIntNumber());
    }
    
    protected TestEntity mapFromTestEntityViewToTestEntity(TestEntityView sourceDto) {
    	return mapFromTestEntityViewToTestEntity(sourceDto, MapperContextHolder.createEntity(TestEntity.class));
    }

    protected TestEntity mapFromTestEntityViewToTestEntity(TestEntityView sourceDto, TestEntity testEntity) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return testEntity;
    	}
	    MapperContextHolder.getContext().put(sourceDto, testEntity);
		testEntity.setTestString2(sourceDto.getTestString2());
		testEntity.setTestInteger(sourceDto.getTestInteger());
		testEntity.setTestLong(sourceDto.getTestLong());
		testEntity.setTestBoolean(sourceDto.getTestBoolean());
		testEntity.setTestDouble(sourceDto.getTestDouble());
		testEntity.setTestFloat(sourceDto.getTestFloat());
		testEntity.setTestString1(sourceDto.getTestString1());
		testEntity.setBigNum(sourceDto.getBigNum());
		testEntity.setBigNum10(sourceDto.getBigNum10());
		testEntity.setBigNum10_2(sourceDto.getBigNum10_2());
		testEntity.setFloat5_2(sourceDto.getFloat5_2());
		testEntity.setDouble3_3(sourceDto.getDouble3_3());
		testEntity.setLongNumber(sourceDto.getLongNumber());
		testEntity.setIntNumber(sourceDto.getIntNumber());
	    return testEntity;
	}
	
	protected TestEntityView mapFromTestEntityToTestEntityView(TestEntity testEntity) {
		if (MapperContextHolder.getContext().containsKey(testEntity)) {
			return (TestEntityView) MapperContextHolder.getContext().get(testEntity);
		}
		TestEntityView testEntityView = new TestEntityView();
    	MapperContextHolder.getContext().put(testEntity, testEntityView);
		testEntityView.setTestString2(testEntity.getTestString2());
		testEntityView.setTestInteger(testEntity.getTestInteger());
		testEntityView.setTestLong(testEntity.getTestLong());
		testEntityView.setTestBoolean(testEntity.getTestBoolean());
		testEntityView.setTestDouble(testEntity.getTestDouble());
		testEntityView.setTestFloat(testEntity.getTestFloat());
		testEntityView.setTestString1(testEntity.getTestString1());
		testEntityView.setBigNum(testEntity.getBigNum());
		testEntityView.setBigNum10(testEntity.getBigNum10());
		testEntityView.setBigNum10_2(testEntity.getBigNum10_2());
		testEntityView.setFloat5_2(testEntity.getFloat5_2());
		testEntityView.setDouble3_3(testEntity.getDouble3_3());
		testEntityView.setLongNumber(testEntity.getLongNumber());
		testEntityView.setIntNumber(testEntity.getIntNumber());
        return testEntityView;
	}
	
	protected TestEntityView mapFromTestEntityToTestEntityView(TestEntity testEntity, TestEntityView testEntityView) {
		if (MapperContextHolder.getContext().containsKey(testEntity)) {
			return testEntityView;
		}		
    	MapperContextHolder.getContext().put(testEntity, testEntityView);
		testEntityView.setTestString2(testEntity.getTestString2());
		testEntityView.setTestInteger(testEntity.getTestInteger());
		testEntityView.setTestLong(testEntity.getTestLong());
		testEntityView.setTestBoolean(testEntity.getTestBoolean());
		testEntityView.setTestDouble(testEntity.getTestDouble());
		testEntityView.setTestFloat(testEntity.getTestFloat());
		testEntityView.setTestString1(testEntity.getTestString1());
		testEntityView.setBigNum(testEntity.getBigNum());
		testEntityView.setBigNum10(testEntity.getBigNum10());
		testEntityView.setBigNum10_2(testEntity.getBigNum10_2());
		testEntityView.setFloat5_2(testEntity.getFloat5_2());
		testEntityView.setDouble3_3(testEntity.getDouble3_3());
		testEntityView.setLongNumber(testEntity.getLongNumber());
		testEntityView.setIntNumber(testEntity.getIntNumber());
        return testEntityView;
	}
	
	

	private DtoAssembler<VODataView> createDtoAssemblerVODataView() {
		return new DtoAssembler<VODataView>() {
		    public VODataView mapFromEntity(Object sourceEntity) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
		    	if (sourceEntity instanceof VOData) {
					VOData vOData = (VOData) sourceEntity;
		    		VODataView result = mapFromVODataToVODataView(vOData);
		    		return result;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public VODataView mapFromEntity(Object sourceEntity, VODataView targetDto) {
				Assert.notNull(sourceEntity, "parameter 'sourceEntity' must not be null");
				Assert.notNull(targetDto, "parameter 'targetDto' must not be null");
		    	if (sourceEntity instanceof VOData) {
					VOData vOData = (VOData) sourceEntity;
		    		mapFromVODataToVODataView(vOData, targetDto);
		    		return targetDto;
		    	}
				throw new IllegalArgumentException("mapping from object '"+sourceEntity+"' is not supported");
		    	
			}
			
			public <T> T mapTo(VODataView sourceDto, Class<T> target) {
				if (VODataView.class.equals(target)) {
					VODataView result = new VODataView();
					mapFromVODataViewToVODataView(sourceDto, result);
					return target.cast(result);
				}		    	
				else if (VOData.class.equals(target)) {
		    		return target.cast(mapFromVODataViewToVOData(sourceDto));
		    	}
		    	else {
		    		throw new IllegalArgumentException("mapping to class '"+target+"' is not supported");
		    	}
		    }

		    public void mapTo(VODataView sourceDto, Object targetObject) {
		    	if (targetObject instanceof VODataView) {
					mapFromVODataViewToVODataView(sourceDto, (VODataView) targetObject);
				}				
		    	else if (targetObject instanceof VOData) {
		    		mapFromVODataViewToVOData(sourceDto, (VOData)targetObject);
		    	}		    	
		    	else if (targetObject != null) {
					throw new IllegalArgumentException("mapping to object '"+targetObject+"' is not supported");
				}
			}
		};
	}

    protected void mapFromVODataViewToVODataView(VODataView sourceDto, VODataView vODataView) {
   		vODataView.setOid(sourceDto.getOid());
   		vODataView.setVersion(sourceDto.getVersion());
   		vODataView.setPVOBigDecimal(sourceDto.getPVOBigDecimal());
   		vODataView.setPVODate(sourceDto.getPVODate());
   		vODataView.setPVOTimestamp(sourceDto.getPVOTimestamp());
   		vODataView.setPVODouble(sourceDto.getPVODouble());
   		vODataView.setPVOFloat(sourceDto.getPVOFloat());
   		vODataView.setPVOLong(sourceDto.getPVOLong());
   		vODataView.setPVOString(sourceDto.getPVOString());
   		vODataView.setPVOBoolean(sourceDto.getPVOBoolean());
   		vODataView.setPVOI18Enumeration(sourceDto.getPVOI18Enumeration());
   		vODataView.setPVOByteArray(sourceDto.getPVOByteArray());
   		vODataView.setPVOXml(sourceDto.getPVOXml());
   		vODataView.setPVOXml2(sourceDto.getPVOXml2());
    }
    
    protected VOData mapFromVODataViewToVOData(VODataView sourceDto) {
    	return mapFromVODataViewToVOData(sourceDto, MapperContextHolder.createEntity(VOData.class));
    }

    protected VOData mapFromVODataViewToVOData(VODataView sourceDto, VOData vOData) {
    	if (MapperContextHolder.getContext().containsKey(sourceDto)) {
    		return vOData;
    	}
	    MapperContextHolder.getContext().put(sourceDto, vOData);
		if (sourceDto.getOid() != null) {
			vOData.setOid(sourceDto.getOid());
		}
		vOData.setVersion(sourceDto.getVersion());
		vOData.setPVOBigDecimal(sourceDto.getPVOBigDecimal());
		vOData.setPVODate(sourceDto.getPVODate());
		vOData.setPVOTimestamp(sourceDto.getPVOTimestamp());
		vOData.setPVODouble(sourceDto.getPVODouble());
		vOData.setPVOFloat(sourceDto.getPVOFloat());
		vOData.setPVOLong(sourceDto.getPVOLong());
		vOData.setPVOString(sourceDto.getPVOString());
		vOData.setPVOBoolean(sourceDto.getPVOBoolean());
		vOData.setPVOI18Enumeration(sourceDto.getPVOI18Enumeration());
		vOData.setPVOByteArray(sourceDto.getPVOByteArray());
		vOData.setPVOXml(sourceDto.getPVOXml());
		vOData.setPVOXml2(sourceDto.getPVOXml2());
	    return vOData;
	}
	
	protected VODataView mapFromVODataToVODataView(VOData vOData) {
		if (MapperContextHolder.getContext().containsKey(vOData)) {
			return (VODataView) MapperContextHolder.getContext().get(vOData);
		}
		VODataView vODataView = new VODataView();
    	MapperContextHolder.getContext().put(vOData, vODataView);
		vODataView.setOid(vOData.getOid());
		vODataView.setVersion(vOData.getVersion());
		vODataView.setPVOBigDecimal(vOData.getPVOBigDecimal());
		vODataView.setPVODate(vOData.getPVODate());
		vODataView.setPVOTimestamp(vOData.getPVOTimestamp());
		vODataView.setPVODouble(vOData.getPVODouble());
		vODataView.setPVOFloat(vOData.getPVOFloat());
		vODataView.setPVOLong(vOData.getPVOLong());
		vODataView.setPVOString(vOData.getPVOString());
		vODataView.setPVOBoolean(vOData.getPVOBoolean());
		vODataView.setPVOI18Enumeration(vOData.getPVOI18Enumeration());
		vODataView.setPVOByteArray(vOData.getPVOByteArray());
		vODataView.setPVOXml(vOData.getPVOXml());
		vODataView.setPVOXml2(vOData.getPVOXml2());
        return vODataView;
	}
	
	protected VODataView mapFromVODataToVODataView(VOData vOData, VODataView vODataView) {
		if (MapperContextHolder.getContext().containsKey(vOData)) {
			return vODataView;
		}		
    	MapperContextHolder.getContext().put(vOData, vODataView);
		vODataView.setOid(vOData.getOid());
		vODataView.setVersion(vOData.getVersion());
		vODataView.setPVOBigDecimal(vOData.getPVOBigDecimal());
		vODataView.setPVODate(vOData.getPVODate());
		vODataView.setPVOTimestamp(vOData.getPVOTimestamp());
		vODataView.setPVODouble(vOData.getPVODouble());
		vODataView.setPVOFloat(vOData.getPVOFloat());
		vODataView.setPVOLong(vOData.getPVOLong());
		vODataView.setPVOString(vOData.getPVOString());
		vODataView.setPVOBoolean(vOData.getPVOBoolean());
		vODataView.setPVOI18Enumeration(vOData.getPVOI18Enumeration());
		vODataView.setPVOByteArray(vOData.getPVOByteArray());
		vODataView.setPVOXml(vOData.getPVOXml());
		vODataView.setPVOXml2(vOData.getPVOXml2());
        return vODataView;
	}
	
	

}
